/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk;

import java.util.Date;

import com.lmsoft.cornu.webtrade.sdk.message.all.MB10042;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB10112;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB10202;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB10992;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13032;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB17172;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB23092;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB23102;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB23202;

/**
 * TradeClient <BR>
 * @author Jerry Zhang <BR>
 * 2012-12-27 下午05:20:05
 */
public interface CommClient extends SkyFallClient{
	
	/**
	 * 检测用户名
	 * @param loginName 用户名
	 * @return MB10112
	 */
	abstract public MB10112 checkLoginName(String loginName);
	/**
	 * 客户自注册客户组查询请求
	 * @return MB10202
	 */
	abstract public MB10202 queryRegCustGroups();
	/**
	 * 客户自注册
	 * @deprecated 使用com.lmsoft.cornu.webtrade.sdk.ManagerClient.addCust
	 * @param loginName 用户名
	 * @param loginPwd 密码
	 * @param readOnlyPwd 只读密码
	 * @param realName 真实姓名
	 * @param province 省
	 * @param city 市
	 * @param addr 地址
	 * @param birthday 生日
	 * @param zipCode 邮编
	 * @param phone 电话
	 * @param mobile 手机号
	 * @param eMail E-mail
	 * @param cardId 身份证号
	 * @param groupId 客户组ID
	 * @return MB10992
	 */
	@Deprecated
	abstract public MB10992 selfReg(String loginName, String loginPwd, String readOnlyPwd,
			String realName, String province, String city, String addr,
			Date birthday, String zipCode, String phone, String mobile,
			String eMail, String cardId, int groupId);
	/**
	 * 踢人的登陆确认
	 * @param loginkey 登录串
	 * @return MB10042
	 */
	abstract public MB10042 loginKey(String loginkey);
	/**
	 * 交易商品查询请求
	 * @param groupId 客户组ID
	 * @param custId 客户ID
	 * @return MB13032
	 */
	abstract public MB13032 getTradeSymbols(int groupId, int custId);
	/**
	 * 客户持仓明细账单查询
	 * @param agentId 代理商ID，0表示查询所有
	 * @param userId 用户ID，0表示查询所有
	 * @param custId 客户ID，0表示查询所有
	 * @param beginTime 开始时间，0表示不做限制
	 * @param endTime 结束时间，0表示不做限制
	 * @param symbolId 商品ID，0表示查询所有
	 * @param queryView 查询视野，1:代理商，2：用户，3：客户
	 * @param deepQuery 查询深度，true深度查询，false查询本身的资源
	 * @param custStatus 客户状态，0所有,1:正常,2:删除,3:锁定,4:冻结
	 * @param currency 货币单位，（USD/CNY..）空为所有
	 * @return MB17172
	 */
	abstract public MB17172 queryCustBill(int agentId, int userId, int custId, long beginTime,
			long endTime, int symbolId, byte queryView, boolean deepQuery,
			byte custStatus, String currency);
	
	void setWebOnlineSession(WebOnlineSession webOnlineSession);
	
	WebOnlineSession getWos();
	
	void setCommHandler(CommHandler commHandler);

	long getLastAliveMills();
	
	/**
	 * Cms使用的登陆
	 * @param custId 客户ID
	 * @param password　密码
	 * @param ip
	 * @return MB10042
	 */
	abstract public MB10042 login4Cms(int custId, String password, String ip);
	/**
	 * Jjh使用的登陆
	 * @param custId 客户ID
	 * @param password　密码
	 * @param ip
	 * @return MB10042
	 */
	abstract public MB10042 login4Jjh(int custId, String password, String ip);

	abstract MB23092 sendBalanceRequest(int custId,String bankNum,double balance, String reqReason);
	
	abstract MB23102 auditVoucherStatus(int custId,int reqId,int status,String reason,String assessor);
	
	abstract MB10992 confirmDrawCash(int custId,int reqId,String serialNum);
	
	abstract MB23202 getCustBalanceRequestList(int custId,int reqId,int status,String reqDate,int beginNum,int limit,String esc,String orderBy);

}
