package com.lmsoft.cornu.webtrade.sdk;

public class ErrCode {
	
	/**
	 * 操作成功，成功的通用返回码
	 */
	public static final int SUCCESS = 0;

	/**
	 * 不允许修改配置
	 * @since skyfall v1.1
	 */
	public static final int CONFIG_NOT_PERMIT = 8888;
	
	/**
	 * 未知错误
	 */
	public static final int UNKNOWN_ERR = 9999;

	/**
	 * 非法的SessionId
	 */
	public static final int INVALID_SESSION_ID = 1001;

	/**
	 * 非法的消息格式
	 */
	public static final int INVALID_MSG_FORMAT = 1002;
	
	/**
	 * 非法的日期格式
	 * */
	public static final int INVALID_DATE_FORMAT = 1999;
	/**
	 * 非常的单子状态
	 */
	public static final int INVALID_ORDER_STATUS = 1003;
	/**
	 * 没有权限
	 */
	public static final int AUTH_FROBIDEN = 1004;

	/**
	 * 系统内部错误
	 */
	public static final int INTERNAL_ERR = 2001;

	/**
	 * 数据库错误
	 */
	public static final int DB_ERR = 2101;

	/**
	 * 通讯错误
	 */
	public static final int SOCKET_ERR = 2201;

	/**
	 * 非法事件参数
	 */
	public static final int INVALID_PARAM = 2301;
	/**
	 * 客户名格式不正确
	 */
	public static final int CUST_NAME_WRONG = 15912;
	/**
	 *此客户名已经存在,不能添加
	 */
	public static final int CUST_NAME_IS_EXIST = 15901;
	/**
	 *代理商ID错误
	 */
	public static final int CUST_AGENTID_WRONG = 15903;
	/**
	 * 代理商不存在
	 */
	public static final int CUST_AGENT_NOT_EXIST = 15915;
	/**
	 *用户ID错误
	 */
	public static final int CUST_USERID_WRONG = 15904;
	/**
	 * 该cngoldId已经开过户了
	 * */
	public static final int CNGOLDID_HAVE_CREATE_ACCNT = 15769;
	/**
	 * 上级经理人不存在
	 */
	public static final int CUST_USER_NOT_EXIST = 15917;
	/**
	 *客户组ID错误
	 */
	public static final int CUST_CUSTID_WRONG = 15905;
	/**
	 * 此客户组不存在
	 */
	public static final int CUST_GROUP_NOT_EXIST = 15916;
	/**
	 *客户组状态ID不正确
	 */
	public static final int CUST_STATUS_WRONG = 15906;
	/**
	 *税收比例不正确
	 */
	public static final int CUST_TAX_PERCENT_WRONG = 15909;
	/**
	 * 此客户不存在
	 */
	public static final int CUST_ISNOT_EXIST = 15911;
	/**
	 * 出入金为零
	 */
	public static final int REQ_BALANCE_IS_ZERO = 15016;
	/**
	 * 余额不足
	 */
	public static final int NOT_ENOUGH_BALANCE=21021;
	/**
	 * 非法的审核状态
	 * */
	public static final int VOUCHER_STATUS_WRONG = 23301;
	/**
	 * 提现流水号为空
	 * */
	public static final int VOUCHER_NO_SERIALNUM = 23302;
	/**
	 * @since v3.2
	 * 买单未开放
	 */
	public static final int TRADE_CONTROL_BUY_FORBDEN = 22001;
	/**
	 * 行情不同步(等待报价中)
	 */
	public static final int WAIT_RIGHT_PRICE = 25017;
	/**
	 * 不合理的止盈价
	 */
	public static final int ORDER_PROFIT_PRICE_WRONG = 21003;
	/**
	 * 不合理的止损价
	 */
	public static final int ORDER_LOSS_PRICE_WRONG = 21004;
	/**
	 * @since v3.2
	 * 卖单未开放
	 */
	public static final int TRADE_CONTROL_SELL_FORBDEN = 22002;

	/**
	 * @since v3.2
	 * 买单挂单未开放
	 */
	public static final int TRADE_CONTROL_BUY_PENDING_FORBDEN = 22003;

	/**
	 * @since v3.2
	 * 卖单挂单未开放
	 */
	public static final int TRADE_CONTROL_SELL_PENDING_FORBDEN = 22004;
	
	/**
	 * @since v3.2
	 * 买单平单未开放
	 */
	public static final int TRADE_CONTROL_BUY_CLOSE_FORBDEN = 22005;

	/**
	 * @since v3.2
	 * 卖单平单未开放
	 */
	public static final int TRADE_CONTROL_SELL_CLOSE_FORBDEN = 22006;
	/**
	 * 金元券错误
	 */
	public static final int VOUCHERS_ERROR = 21024;
	/**
	 * 金元券金额不足
	 */
	public static final int VOUCHERS_INSUFFICIENT_FUND = 21025;
	/**
	 * 商品已存在未完成的单子
	 */
	public static final int SYMBOL_EXIST_UNFINISHED_ORDER = 21026;
	/**
	 * 挂单模式不正确
	 */
	public static final int SBML_HANG_MODE_ERROR = 15415;
	/**
	 * 超过最大交易量
	 */
	public static final int GREATE_THAN_MAX_TRADE = 25106;
	/**
	 * 挂价非法
	 */
	public static final int PENDING_PRICE_WRONG = 21002;
	/**
	 * 不合法的定单类型
	 */
	public static final int ORDER_TYPE_WRONG = 21010;
	/**
	 * @since v3.2
	 * 买单改挂单未开放
	 */
	public static final int TRADE_CONTROL_BUY_CANCEL_PENDING_FORBDEN = 22019;
	/**
	 * @since v3.2
	 * 卖单改挂单未开放
	 */
	public static final int TRADE_CONTROL_SELL_CANCEL_PENDING_FORBDEN = 22020;
	/**
	 * @since v3.2
	 * 买单改持单未开放
	 */
	public static final int TRADE_CONTROL_BUY_MODIFY_ORDER_FORBDEN = 22013;

	/**
	 * @since v3.2
	 * 卖单改持单未开放
	 */
	public static final int TRADE_CONTROL_SELL_MODIFY_ORDER_FORBDEN = 22014;
	/**
	 * @since v3.2
	 * 买单改挂单未开放
	 */
	public static final int TRADE_CONTROL_BUY_MODIFY_PENDING_FORBDEN = 22015;

	/**
	 * @since v3.2
	 * 卖单改挂单未开放
	 */
	public static final int TRADE_CONTROL_SELL_MODIFY_PENDING_FORBDEN = 22016;
	/**
	 * 可用保证金不足
	 */
	public static final int NOT_ENOUGH_ACCNT_AVAILABLE=21013;
	
    // 金元券相关26开头
	/**
	 * 金元券来源类型不合法
	 * */
    public static final int VOUCHER_SOURCE_TYPE_ILLEGAL = 260011;
    /**
     * 发放数量不合法
     */
    public static final int VOUCHER_SEND_AMOUNT_ILLEGAL = 260012;
    /**
     * 用户数量不合法
     */
    public static final int USER_AMOUNT_ILLEGAL = 260013;
    /**
     * 券来源不合法
     */
    public static final int VOUCHER_SOURCE_ILLEGAL = 260014;
    /**
     * 券类型不合法
     */
    public static final int VOUCHER_TYPE_ILLEGAL = 260015;
    /**
     * 券来源已删除
     */
    public static final int VOUCHER_SOURCE_DELETE = 260016;
    /**
     * 券类型已删除
     */
    public static final int VOUCHER_TYPE_DELETE = 260017;
    /**
     * limit不能为0，前端请求list类型是必须限制条数
     */
    public static final int QUERT_LIMIT_ERROR = 260111;
    /**
     * 业务类型不合法
     */
    public static final int BUSINESS_ILLEGAL = 260311;
    /**
     * 金额不合法
     */
    public static final int VOUCHER_CREDIT_ILLEGAL = 260312;
    /**
     * 过期类型不合法
     */
    public static final int VOUCHER_EXPIRE_TYPE_ILLEGAL = 260313;
    /**
     * 过期时间不合法
     */
    public static final int VOUCHER_EXPIRE_TIME_ILLEGAL = 260314;
    /**
     * 生效时间不合法
     * */
    public static final int VOUCHER_EFFECT_TIME_ILLEGAL = 260315;
    /**
     * 生效类型不合法
     * */
    public static final int VOUCHER_EFFECT_TYPE_ILLEGAL = 260316;
    /**
     * 来源描述不能为空
     */
    public static final int SOURCE_IS_NULL = 260611;
	/**
	 * 存在未成交的挂单平单
	 * */
	public static final int NOT_DEAL_PENDING_ORDER = 25108;
	/**
	 * 开仓手数小于该商品允许开仓的最小手数
	 * */
	public static final int LOTS_LESS_THAN_MIN = 20001;
}
