/**
 * Copyright (c) 2012 by sangame.com.
 * All right reserved.
 */
package com.lmsoft.cornu.webtrade.sdk;

import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.all.*;
import com.lmsoft.cornu.webtrade.sdk.message.bean.QueryTimeType;
import com.lmsoft.cornu.webtrade.sdk.message.bean.QueryType;
import com.lmsoft.cornu.webtrade.sdk.message.bean.TradeOrderPost;

import java.util.Date;
import java.util.List;

/**
 * ManagerClient <BR>
 * @author Jerry Zhang <BR>
 * 2012-12-27 下午05:17:35
 */
public interface ManagerClient extends VoucherTradeClient{
	void setManagerOnlineSession(ManagerOnlineSession managerOnlineSession);
	
	ManagerOnlineSession getManagerOnlineSession();
	
	/**
	 * 客户开户
	 * @param groupId 客户组ID
	 * @param realName 真实姓名
	 * @param province 省
	 * @param city 市
	 * @param addr 地址
	 * @param birthday 生日
	 * @param zipCode 邮编
	 * @param phone 电话
	 * @param mobile 手机号
	 * @param eMail E-mail
	 * @param cardId 身份证号
	 * @param memo4loginname 注释，用来传cngold的loginname
	 * @return MB15702
	 */
	abstract public MB15702 addCust(int groupId, 
			String passportId, String province, String city, String addr,
			Date birthday, String zipCode, String phone, String mobile,
			String eMail, String cardId, String memo4loginname, int userId);
	/**
	 * 账号交易次数查询
	 * @param accntIdList
	 * @return MB13492
	 */
	abstract public MB13492 queryTimes(List<Integer> accntIdList);
	
	/**
	 * 商品信息查询
	 * @param symbolId 商品id
	 * @return MB13032
	 */
	abstract public MB13032 querySymbols(int symbolId);

	/**
	 * 系统配置查询
	 * @param configKey 参数键
	 * @return MB13012
	 * */

	abstract public MB13012 querySystemConfig(String configKey);

	/**
	 * 增加客户
	 * @return MB15702
	 * */
	abstract public MB15702 addCustSimple(int cngoldId,int groupId, String realName,String mobile,String memo4loginname, int userId);

	/**
	 * 提现申请
	 * @return MB23092
	 * */
	abstract MB23092 sendBalanceRequest(int cngoldId,String bankNum,double balance, String reqReason);
	/**
	 * 审批提现申请
	 * @return MB23102
	 * */
	abstract MB23102 auditVoucherStatus(int cngoldId,int reqId,int status,String reason,String assessor);

	/**
	 * 提现确认
	 * @return MB10992
	 * */
	abstract MB10992 confirmDrawCash(int cngoldId,int reqId,String serialNum);

	/**
	 * 查询提现申请审批列表
	 * @return MB23202
	 * */
	abstract MB23202 getCustBalanceRequestList(int cngoldId,int reqId,int status,String reqDate,int beginNum,int limit,String esc,String orderBy);

	<T> T sendMsg(int custId, BaseWebTraderField bwtf, Class<T> tClass);

    MB10042 adminLogin(String loginName, String passwordToSend, String s);
   /**
    * 查询人券关系
    * */
    abstract MB26012 getCustVouchers(MB26201 mb26201);
    
	/**
	 * 修改持单请求
	 * */
	abstract MB20012 modifyHoldingWithCngoldId(int askId, TradeOrderPost to);
	/**
	 * 挂单查询
	 * */
	abstract MB13672 getPendOrders(int Cngoldid);
	
	abstract MB13672 getPendOrdersWithPage(int CngoldId,int beginPosition,int limit,String orderBy,String sequenceType);

	abstract MB20312 closeBuyHoldingWithCngold(int askid, TradeOrderPost to);

	abstract MB13332 getTradeOrdersWithCngoldId(int askid, List<QueryType> queryTypes, QueryTimeType queryTimeType);
	
	abstract MB13672 gettradeRecords(int CngoldId,long beginTime,long endTime,int beginPosition,int limit,String orderBy,String sequenceType);
}
