package com.lmsoft.cornu.webtrade.sdk;

import com.lmsoft.cornu.webtrade.sdk.message.all.MB20312;
import com.lmsoft.cornu.webtrade.sdk.message.bean.TradeOrderPost;

/**
 * 金元券交易
* @author liuming
* @date 2016年11月16日
 */
public interface VoucherTradeClient extends SkyFallClient {

	/**
	 * 金元券买单请求
	 * @param askId
	 * @param to
	 * @return
	 */
	public MB20312 openBuyHoldingByVouchers(int askId, TradeOrderPost to);
	
	/**
	 * 金元券卖单请求
	 * @param askId
	 * @param to
	 * @return
	 */
	public MB20312 openSellHoldingByVouchers(int askId, TradeOrderPost to);
	
	/**
	 * 金元券买单挂单
	 * @param askId
	 * @param to
	 * @return
	 */
	public MB20312 openTdBuyPendingByVouchers(int askId, TradeOrderPost to);
	
	/**
	 * 金元券卖单挂单
	 * @param askId
	 * @param to
	 * @return
	 */
	public MB20312 openTdSellPendingByVouchers(int askId, TradeOrderPost to);
	
	/**
	 * 金元券挂买单平单
	 * @param askId
	 * @param to
	 * @return
	 */
	public MB20312 openTdBuyClosePendingByVouchers(int askId, TradeOrderPost to);

	/**
	 * 金元券挂卖单平单
	 * @param askId
	 * @param to
	 * @return
	 */
	public MB20312 openTdSellClosePendingByVouchers(int askId, TradeOrderPost to);
	
	/**
	 * 金元券取消挂单
	 * @param askId
	 * @param to
	 * @return
	 */
	public MB20312 cancelPendingByVouchers(int askId, TradeOrderPost to);

}
