/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.client2;

import java.util.concurrent.atomic.AtomicLong;

import com.lmsoft.cornu.common.online.OnlineConst;
import com.lmsoft.cornu.webtrade.sdk.CommHandler;
import com.lmsoft.cornu.webtrade.sdk.base.DialogMsgHandler;
import com.lmsoft.cornu.webtrade.sdk.base.NoticeMsgHandler;
import com.lmsoft.cornu.webtrade.sdk.base.NoticeSessionCloseHandler;
import com.lmsoft.cornu.webtrade.sdk.client2.phoenix.ComminicationClient;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.sangame.phoenix.cornu.CornuMessage;

/**
 * @author JerryZ
 *
 */
public abstract class BaseCommClient implements DialogMsgHandler, NoticeMsgHandler, NoticeSessionCloseHandler{
	protected CommHandler commHandler;
	protected ComminicationClient comminicationClient;
	
    private AtomicLong lastDialogSeqNo;
    private long lastPrivateSeqNo;
    private long lastAliveMills;
	/**
	 * 返回dialog的seq
	 * @param tid
	 * @param bwtf
	 * @return
	 */
	protected int sendMsg(int tid, BaseWebTraderField bwtf){
		CornuMessage msg = new CornuMessage();
		
		int seqTemp = nextDialogSeqNo();
		msg.setTid(tid);
		msg.setSeqNo(seqTemp);
		msg.setSeqSeries(OnlineConst.COMM_MODE_DIALOG);
		msg.addField(bwtf);
		
		comminicationClient.sendMsg(msg);
		return seqTemp;
	}
	
	private int nextDialogSeqNo() {
		if(lastDialogSeqNo == null)
			lastDialogSeqNo = new AtomicLong(0);
		return (int)(lastDialogSeqNo.incrementAndGet()&0xFFFFFFFF);
	}
	
    public int getLastDialogSeqNo() {
		return lastDialogSeqNo.intValue();
	}
    
	public void setLastDialogSeqNo(int lastSeq) {
		this.lastDialogSeqNo.set(((long)lastSeq)&0xFFFFFFFF);
	}
	
	public long getLastPrivateSeqNo() {
		return lastPrivateSeqNo;
	}

	public void setLastPrivateSeqNo(long lastPrivateSeqNo) {
		this.lastPrivateSeqNo = lastPrivateSeqNo;
	}
	
	protected void sendUnloginMsg(int tid, BaseWebTraderField bwtf, int seqNo){
		CornuMessage msg = new CornuMessage();
		
		msg.setTid(tid);
		msg.setSeqNo(seqNo);
		msg.setSeqSeries(OnlineConst.COMM_MODE_DIALOG);
		msg.addField(bwtf);
		
		comminicationClient.sendMsg(msg);
	}
	
	public void noticeMsg(CornuMessage message) {
		setLastPrivateSeqNo(message.getSeqNo());
	}
	
	public  boolean isForceClose() {
		return comminicationClient.isForceClose();
	}
	public long getLastAliveMills() {
		return lastAliveMills;
	}

	public void setLastAliveMills(long lastAliveMills) {
		this.lastAliveMills = lastAliveMills;
	}

	public CommHandler getCommHandler() {
		return commHandler;
	}

	public void setCommHandler(CommHandler commHandler) {
		this.commHandler = commHandler;
	}
}
