/**
 * Copyright (c) 2012 by sangame.com.
 * All right reserved.
 */
package com.lmsoft.cornu.webtrade.sdk.client2;

import java.util.List;
import java.util.concurrent.TimeUnit;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.lmsoft.cornu.webtrade.sdk.SkyFallClient;
import com.lmsoft.cornu.webtrade.sdk.TidConst;
import com.lmsoft.cornu.webtrade.sdk.config.WebTraderConfig;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB10011;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB10012;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB10992;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB12011;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB12012;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB12052;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB12071;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB12153;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB12161;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13011;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13012;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13071;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13081;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13082;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13101;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13102;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13312;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13321;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13351;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13352;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13451;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13452;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13461;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13462;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13502;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13522;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB15301;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB15591;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB15992;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20011;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20012;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20031;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20071;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20081;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20101;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20111;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20121;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20131;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20141;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20201;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20211;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20312;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB20481;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB23031;
import com.lmsoft.cornu.webtrade.sdk.message.bean.QuotoPost;
import com.lmsoft.cornu.webtrade.sdk.message.bean.SymbolSwitch;
import com.lmsoft.cornu.webtrade.sdk.message.bean.TradeOrderPost;

/**
 * Skyfall通用的业务协议实现 <BR>
 * @author Jerry Zhang <BR>
 * 2012-12-28 上午11:26:44
 */
public abstract class BaseSkyfallBizClient extends BaseSkyfallCommonBizClient implements SkyFallClient{
	private static final Log log = LogFactory.getLog(BaseSkyfallBizClient.class);

	public BaseSkyfallBizClient(WebTraderConfig config) {
		super(config);
	}
	
	public synchronized MB20012 modifyPending(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20111 mb20111 = new MB20111(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getId(), to.getOpen_prc(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getExpire_day()==null? 0 : to.getExpire_day().getTime(), to.getDraft_point()); 
			sendMsgAndSetNoSeq(TidConst.T20111, mb20111);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20312 modifyPendingWithCngoldId(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20312 mb20312 = null;
		try {
			MB20211 mb20111 = new MB20211(askId, to.getCngold_id(), (int)to.getSmbl_id(), to.getId(), to.getOpen_prc(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getExpire_day()==null? 0 : to.getExpire_day().getTime(), to.getDraft_point()); 
			sendMsgAndSetNoSeq(TidConst.T20211, mb20111);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else{
				if(nowCornuMessage instanceof MB10992){
					MB10992 mb10992 = (MB10992) nowCornuMessage;
					mb20312 = new MB20312();
					mb20312.setRtnCode(mb10992.getRtnCode());
				}else{
					mb20312 = (MB20312)nowCornuMessage;
				}
			}
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20312;
	}
	
	public synchronized MB20012 openBuyHolding(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20011 mb20011 = new MB20011(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getLots(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_point(), to.getMaxWarp(), to.getOpen_prc(), to.getMemo());
			sendMsgAndSetNoSeq(TidConst.T20011, mb20011);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;
	
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20012 openBuyPending(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20031 mb20031 = new MB20031(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getLots(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_point(), to.getOpen_prc(), to.getMemo(), 
					to.getExpire_day()==null ? 0 : to.getExpire_day().getTime());
			sendMsgAndSetNoSeq(TidConst.T20031, mb20031);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20012 openBuyStopPending(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20031 mb20031 = new MB20031(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getLots(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_point(), to.getOpen_prc(), to.getMemo(), 
					to.getExpire_day()==null ? 0 : to.getExpire_day().getTime());
			sendMsgAndSetNoSeq(TidConst.T20051, mb20031);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20012 openSellHolding(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20011 mb20011 = new MB20011(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getLots(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_point(), to.getMaxWarp(), to.getOpen_prc(), to.getMemo());
			sendMsgAndSetNoSeq(TidConst.T20021, mb20011);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20012 openSellPending(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20031 mb20031 = new MB20031(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getLots(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_point(), to.getOpen_prc(), to.getMemo(), 
					to.getExpire_day()==null ? 0 : to.getExpire_day().getTime());
			sendMsgAndSetNoSeq(TidConst.T20041, mb20031);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;
			
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20012 openSellStopPending(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20031 mb20031 = new MB20031(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getLots(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_point(), to.getOpen_prc(), to.getMemo(), 
					to.getExpire_day()==null ? 0 : to.getExpire_day().getTime());
			sendMsgAndSetNoSeq(TidConst.T20061, mb20031);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}


	@Override
	public synchronized MB20012 openTdBuyClosePending(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20031 mb20031 = new MB20031(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getLots(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_point(), to.getOpen_prc(), to.getMemo(), 
					to.getExpire_day()==null ? 0 : to.getExpire_day().getTime());
			sendMsgAndSetNoSeq(TidConst.T20271, mb20031);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	@Override
	public synchronized MB20012 openTdBuyPending(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20031 mb20031 = new MB20031(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getLots(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_point(), to.getOpen_prc(), to.getMemo(), 
					to.getExpire_day()==null ? 0 : to.getExpire_day().getTime());
			sendMsgAndSetNoSeq(TidConst.T20251, mb20031);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	@Override
	public synchronized MB20012 openTdSellClosePending(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20031 mb20031 = new MB20031(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getLots(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_point(), to.getOpen_prc(), to.getMemo(), 
					to.getExpire_day()==null ? 0 : to.getExpire_day().getTime());
			sendMsgAndSetNoSeq(TidConst.T20281, mb20031);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	@Override
	public synchronized MB20012 openTdSellPending(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20031 mb20031 = new MB20031(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getLots(), 
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_point(), to.getOpen_prc(), to.getMemo(), 
					to.getExpire_day()==null ? 0 : to.getExpire_day().getTime());
			sendMsgAndSetNoSeq(TidConst.T20261, mb20031);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}
	
	public synchronized MB20012 cancelLastTrade(int askId, int accntId) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20071 mb20071 = new MB20071(askId, accntId);
			sendMsgAndSetNoSeq(TidConst.T20071, mb20071);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20012 cancelPending(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20121 mb20121 = new MB20121(askId, to.getAccnt_id(), to.getSmbl_id(), to.getId());
			sendMsgAndSetNoSeq(TidConst.T20121, mb20121);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;
		
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20012 closeBuyHolding(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20081 mb20081 = new MB20081(askId, to.getAccnt_id(), (int)to.getSmbl_id(), 
					to.getLots(), to.getId(), to.getClose_prc(), to.getMaxWarp());
			sendMsgAndSetNoSeq(TidConst.T20081, mb20081);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20012 closeBuyHoldingWithCngoldId(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20481 mb20481 = new MB20481(askId, to.getCngold_id(), (int)to.getSmbl_id(), 
					to.getLots(), to.getId(), to.getClose_prc(), to.getMaxWarp());
			sendMsgAndSetNoSeq(TidConst.T20481, mb20481);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}
	
	public synchronized MB20012 closeBy(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20141 mb20141 = new MB20141(askId, to.getAccnt_id(), to.getSmbl_id());
			sendMsgAndSetNoSeq(TidConst.T20141, mb20141);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20012 closeSellHolding(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20081 mb20081 = new MB20081(askId, to.getAccnt_id(), (int)to.getSmbl_id(), 
					to.getLots(), to.getId(), to.getClose_prc(), to.getMaxWarp());
			sendMsgAndSetNoSeq(TidConst.T20091, mb20081);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;
	
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20012 closeWith(int askId, TradeOrderPost to, TradeOrderPost to2) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20131 mb20131 = new MB20131(askId, to.getAccnt_id(), to.getSmbl_id(), to.getId(), to2.getId());
			sendMsgAndSetNoSeq(TidConst.T20131, mb20131);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}
	

	public synchronized MB13102 getCustInfo(int custId) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13102 mb13102 = null;
		try {
			MB13101 mb13101 = new MB13101(custId);
			sendMsgAndSetNoSeq(TidConst.T13101, mb13101);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else if(nowCornuMessage instanceof MB10992){
				mb13102 = new MB13102();
			}else{
				mb13102 = (MB13102)nowCornuMessage;
			}

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb13102;
	}

	public synchronized MB13102 getCustInfoByCnGoldId(int cngoldId) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13102 mb13102 = null;
		try {
			MB13101 mb13101 = new MB13101(9,cngoldId);
			sendMsgAndSetNoSeq(TidConst.T13101, mb13101);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb13102 = (MB13102)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb13102;
	}
	
	public synchronized MB13082 getGroupMarkets(int groupId) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13082 mb13082 = null;
		try {
			MB13081 mb13081 = new MB13081(groupId);
			sendMsgAndSetNoSeq(TidConst.T13081, mb13081);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb13082 = (MB13082)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb13082;
	}

	public synchronized MB13012 getSysConfig(String key) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13012 mb13102 = null;
		try {
			
			MB13011 mb13011 = new MB13011(key);
			sendMsgAndSetNoSeq(TidConst.T13011, mb13011);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb13102 = (MB13012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb13102;
	}
	

	public synchronized MB20012 deliveryBuyHolding(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20081 mb20081 = new MB20081(askId, to.getAccnt_id(), (int)to.getSmbl_id(), 
					to.getLots(), to.getId(), to.getClose_prc(), to.getMaxWarp());
			sendMsgAndSetNoSeq(TidConst.T20161, mb20081);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB20012 deliverySellHolding(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20081 mb20081 = new MB20081(askId, to.getAccnt_id(), (int)to.getSmbl_id(), 
					to.getLots(), to.getId(), to.getClose_prc(), to.getMaxWarp());
			sendMsgAndSetNoSeq(TidConst.T20171, mb20081);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}


	public synchronized MB20012 extensionHolding(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20121 mb20121 = new MB20121(askId, to.getAccnt_id(), to.getSmbl_id(), to.getId());
			sendMsgAndSetNoSeq(TidConst.T20151, mb20121);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb20012 = (MB20012)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}

	public synchronized MB10012 getNotice() {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();

		MB10012 mb10012 = null;
		
		try {
			
			MB10011 mb10011 = new MB10011();
			sendMsgAndSetNoSeq(TidConst.T10011, mb10011);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb10012 = (MB10012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb10012;
	}

	public synchronized MB13352 getSysAccnts() {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13352 mb13352 = null;
		try {
			MB13351 mb13351 = new MB13351();
			sendMsgAndSetNoSeq(TidConst.T13351, mb13351);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb13352 = (MB13352)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb13352;
	}

	public synchronized MB13312 getTradeAccnts(int custId) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13312 mb13312 = null;
		try {
			
			MB13321 mb13321 = new MB13321(custId);
			sendMsgAndSetNoSeq(TidConst.T13321, mb13321);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else if(nowCornuMessage instanceof MB10992){
				mb13312 = new MB13312();
			}else{
				mb13312 = (MB13312)nowCornuMessage;
			}
			
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb13312;
	}
	
	public synchronized MB10992 balanceReq(int cngoldId, int accntId, int bankId, int reqType, double balance, String reqReason) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB10992 mb10992 = null;
		try {
			MB23031 mb23031 = new MB23031(cngoldId, accntId, bankId, reqType, balance, reqReason);
			sendMsgAndSetNoSeq(TidConst.T23031, mb23031);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb10992 = (MB10992)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb10992;
	}
	
	public synchronized MB12153 getStockList(List<Integer> stockIdList) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();

		MB12153 mb12153 = null;
		
		try {
			
			MB12161 mb12161 = new MB12161(stockIdList);
			sendMsgAndSetNoSeq(TidConst.T12161, mb12161);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb12153 = (MB12153)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb12153;
	}
	
	public synchronized MB13462 getStockTag() {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13462 mb13462 = null;
		try {
			
			MB13461 mb13461 = new MB13461();
			
			sendMsgAndSetNoSeq(TidConst.T13461, mb13461);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);

			if(nowCornuMessage ==null){
				
			}else
				mb13462 = (MB13462)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb13462;
	}
	
	public synchronized MB12052 symbolSwitch(List<SymbolSwitch> switches) {
		if(switches == null){
			return null;
		}
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB12052 mb12052 = null;
		try {
			MB12071 mb12071 = new MB12071(switches);
			sendMsgAndSetNoSeq(TidConst.T12071, mb12071);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb12052= (MB12052)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb12052;
	}
	
	public synchronized MB20012 modifyHolding(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20101 mb20101 = new MB20101(askId, to.getAccnt_id(), (int)to.getSmbl_id(), to.getId(),
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_prc(), to.getDraft_point());
			sendMsgAndSetNoSeq(TidConst.T20101, mb20101);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else if(nowCornuMessage instanceof MB10992){
				MB10992 mb10992 = (MB10992) nowCornuMessage;
				mb20012 = new MB20012();
				mb20012.setReturnCode(mb10992.getRtnCode());
			}else{
				mb20012 = (MB20012)nowCornuMessage;
			}
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}
	
	public synchronized MB20012 modifyHoldingWithCngoldId(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20012 mb20012 = null;
		try {
			MB20201 mb20101 = new MB20201(askId, to.getCngold_id(), (int)to.getSmbl_id(), to.getId(),
					to.getProfit_prc(), to.getLoss_prc(), to.getDraft_prc(), to.getDraft_point());
			sendMsgAndSetNoSeq(TidConst.T20201, mb20101);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else if(nowCornuMessage instanceof MB10992){
				MB10992 mb10992 = (MB10992) nowCornuMessage;
				mb20012 = new MB20012();
				mb20012.setReturnCode(mb10992.getRtnCode());
			}else{
				mb20012 = (MB20012)nowCornuMessage;
			}
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20012;
	}
	
	public synchronized MB10992 modifyPassword(int id, String oldPwd, String newPwd) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB10992 mb10992 = null;
		try {
			MB15301 mb15301 = new MB15301(id, oldPwd, newPwd);
			sendMsgAndSetNoSeq(TidConst.T15301, mb15301);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb10992 = (MB10992)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb10992;
	}
	

	public synchronized MB12012 queryQuotoPost(QuotoPost quotoPost) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB12012 mb12012 = null;
		try {
			MB12011 mb12011 = new MB12011(quotoPost);
			sendMsgAndSetNoSeq(TidConst.T12011, mb12011);

			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb12012 = (MB12012)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb12012;
	}

	public synchronized MB13452 getSymbolOpts(List<Integer> idList){
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13452 mb13452 = null;
		try {
			MB13451 mb13451 = new MB13451(idList);
			sendMsgAndSetNoSeq(TidConst.T13451, mb13451);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb13452= (MB13452)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb13452;
	}
	

	@Override
	public synchronized MB13502 getHoldingOrderStatistics(int accntId) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13502 mb13452 = null;
		try {
			MB13101 mb13101 = new MB13101(accntId);
			sendMsgAndSetNoSeq(TidConst.T13501, mb13101);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else if(nowCornuMessage instanceof MB10992){
				mb13452 = new MB13502();
			}else{
				mb13452= (MB13502)nowCornuMessage;
			}
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb13452;
	}

	@Override
	public synchronized MB13502 getHoldingOrderStatisticsByCngoldId(int cngoldId) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13502 mb13452 = null;
		try {
			MB13101 mb13101 = new MB13101(2,cngoldId);
			sendMsgAndSetNoSeq(TidConst.T13501, mb13101);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else if(nowCornuMessage instanceof MB10992){
				mb13452 = new MB13502();
			}else{
				mb13452= (MB13502)nowCornuMessage;
			}
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb13452;
	}
	
	@Override
	public synchronized MB13522 getCustGroup(int groupId) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13522 mb13452 = null;
		try {
			MB13071 mb13071 = new MB13071(groupId);
			sendMsgAndSetNoSeq(TidConst.T13521, mb13071);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else if(nowCornuMessage instanceof MB10992){
				mb13452= new MB13522();
			}else{
				mb13452= (MB13522)nowCornuMessage;
			}
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb13452;
	}

	@Override
	public synchronized MB15992 custReset(int custId) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB15992 mb13032 = null;
		try {
			MB15591 mb13471 = new MB15591(custId);
			sendMsgAndSetNoSeq(TidConst.T15591, mb13471);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage ==null){
				
			}else if(nowCornuMessage instanceof MB10992){
				MB10992 mb10992 = (MB10992) nowCornuMessage;
				mb13032 = new MB15992();
				mb13032.setRtnCode(mb10992.getRtnCode());
			}else{
				mb13032 = (MB15992)nowCornuMessage;
			}
			
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb13032;
	}
}
