/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.client2;

import com.lmsoft.cornu.common.online.OnlineConst;
import com.lmsoft.cornu.webtrade.sdk.CommClient;
import com.lmsoft.cornu.webtrade.sdk.TidConst;
import com.lmsoft.cornu.webtrade.sdk.WebOnlineSession;
import com.lmsoft.cornu.webtrade.sdk.config.WebTraderConfig;
import com.lmsoft.cornu.webtrade.sdk.message.all.*;
import com.lmsoft.cornu.webtrade.sdk.message.bean.TradeOrderPost;
import com.sangame.phoenix.cornu.CornuMessage;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.util.Date;
import java.util.concurrent.TimeUnit;
/**
 * TradeSdk
 * @author JerryZ
 *
 */
public class DefaultCommClient2 extends BaseSkyfallBizClient implements CommClient{
	private static final Log log = LogFactory.getLog(DefaultCommClient2.class);
	WebOnlineSession wos;
	
	public DefaultCommClient2(WebTraderConfig config) {
		super(config);
	}

	public synchronized MB13032 getTradeSymbols(int groupId, int custId) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13032 mb13032 = null;
		try {
			
			MB13091 mb13091 = new MB13091(groupId, custId);
			sendMsgAndSetNoSeq(TidConst.T13091, mb13091);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);

			if(nowCornuMessage ==null){
				
			}else
				mb13032 = (MB13032)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb13032;
	}
	
	@Deprecated //@since 2.9 废弃
	public synchronized MB10042 login(String loginName, String password, String ip) {
		dialogLock.lock();
		MB10042 mb10042 = null;
		try {
			MB10041 mb10041 = new MB10041(loginName, password, "AAAAAAAAAAAAA",
					OnlineConst.SOURCE_WEB_TRADER, comminicationClient.getConfig().getServerVersion(), 
					"IP:"+ip);
			nowDialogSeq = 0;
			sendUnloginMsg(TidConst.T10041, mb10041, nowDialogSeq);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage ==null){
				
			}else
				mb10042 = (MB10042)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb10042;
	}
	
	/**
	 * 客户登录, 根据交易系统的用户Id和Passport的用户Id
	 * 
	 * @param userId 交易系统里面的用户ID
	 * @param passportId Passport的用户ID
	 * @param password
	 * @param ip
	 * @since 2.9
	 */
	public synchronized MB10042 login(int userId, int passportId, String password, String ip) {
		dialogLock.lock();
		MB10042 mb10042 = null;
		try {
			MB10041 mb10041 = new MB10041(userId+":"+passportId, password, "AAAAAAAAAAAAA",
					OnlineConst.SOURCE_WEB_TRADER, comminicationClient.getConfig().getServerVersion(), 
					"IP:"+ip);
			nowDialogSeq = 0;
			sendUnloginMsg(TidConst.T10041, mb10041, nowDialogSeq);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage ==null){
				
			}else
				mb10042 = (MB10042)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb10042;
	}

	public synchronized MB10042 login4Cms(int custId, String password, String ip) {
		dialogLock.lock();
		MB10042 mb10042 = null;
		try {
			MB10041 mb10041 = new MB10041(custId+"", password, "AAAAAAAAAAAAA",
					OnlineConst.SOURCE_WEB_TRADER, comminicationClient.getConfig().getServerVersion(), 
					"IP:"+ip);
			nowDialogSeq = 0;
			sendUnloginMsg(TidConst.T10241, mb10041, nowDialogSeq);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage ==null){
				
			}else
				mb10042 = (MB10042)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb10042;
	}
	
	public synchronized MB10042 login4Jjh(int custId, String password, String ip) {
		dialogLock.lock();
		MB10042 mb10042 = null;
		try {
			MB10041 mb10041 = new MB10041(custId+"", password, "AAAAAAAAAAAAA",
					OnlineConst.SOURCE_WEB_TRADER, comminicationClient.getConfig().getServerVersion(), 
					"IP:"+ip);
			nowDialogSeq = 0;
			sendUnloginMsg(TidConst.T10251, mb10041, nowDialogSeq);
			
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage ==null){
				
			}else
				mb10042 = (MB10042)nowCornuMessage;
			
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb10042;
	}
	
	/**
	 * jjh客户端模拟交易登录请求..
	 */
	public synchronized MB10042 login4Jjh(int custId, String password,
			String ip, String clientMac, String clientVsersion) {
		dialogLock.lock();
		MB10042 mb10042 = null;
		try {
			MB10041 mb10041 = new MB10041(custId + "", password,
					"AAAAAAAAAAAAA", OnlineConst.SOURCE_WEB_TRADER,
					clientVsersion, "IP:" + ip);
			nowDialogSeq = 0;
			sendUnloginMsg(TidConst.T10251, mb10041, nowDialogSeq);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);

			if (nowCornuMessage == null) {

			} else
				mb10042 = (MB10042) nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally {
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb10042;
	}
	
	@Override
	public MB10042 loginKey(String loginkey) {
		dialogLock.lock();
		MB10042 mb10042 = null;
		try {
			MB10221 mb10221 = new MB10221(loginkey);
			nowDialogSeq = 0;
			sendUnloginMsg(TidConst.T10221, mb10221, nowDialogSeq);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage ==null){
				
			}else
				mb10042 = (MB10042)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb10042;
	}
	
	
	public MB10112 checkLoginName(String loginName){
		dialogLock.lock();
		MB10112 mb10112 = null;
		try {
			MB10111 mb10111 = new MB10111(loginName);
			nowDialogSeq = 0;
			sendUnloginMsg(TidConst.T10111, mb10111, nowDialogSeq);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage ==null){
				
			}else
				mb10112 = (MB10112)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb10112;
	}
	
	public MB10202 queryRegCustGroups(){
		//TODO 对话模式这个结构要调整一下, 等忙过这阵把方法提取出来
		dialogLock.lock();
		MB10202 mb10202 = null;
		try {
			MB10201 mb10201 = new MB10201();
			nowDialogSeq = 0;
			sendUnloginMsg(TidConst.T10201, mb10201, nowDialogSeq);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage ==null){
				
			}else
				mb10202 = (MB10202)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb10202;
	}
	
	public MB10992 selfReg(String loginName, String loginPwd, String readOnlyPwd,
			String realName, String province, String city, String addr,
			Date birthday, String zipCode, String phone, String mobile,
			String eMail, String cardId, int groupId){
		
		dialogLock.lock();
		MB10992 mb10992 = null;
		try {
			MB10091 mb10091 = new MB10091(loginName, loginPwd, readOnlyPwd, realName,
					province, city, addr, birthday, zipCode, phone, mobile, eMail, cardId, groupId);
			nowDialogSeq = 0;
			sendUnloginMsg(TidConst.T10091, mb10091, nowDialogSeq);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage ==null){
				
			}else
				mb10992 = (MB10992)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb10992;
	}


	@Override
	public MB17172 queryCustBill(int agentId, int userId, int custId, long beginTime,
			long endTime, int symbolId, byte queryView, boolean deepQuery,
			byte custStatus, String currency) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB17172 mb17172 = null;
		try {
			
			
			MB17031 mb17031 = new MB17031(agentId, userId, custId, 
					beginTime, endTime, symbolId, queryView, deepQuery, custStatus, currency);
			
			sendMsgAndSetNoSeq(TidConst.T17171, mb17031);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb17172= (MB17172)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb17172;
	}
	
	/////////////////////////////dialog////////////////////////////

	public void beClosed() {
		if(commHandler != null && wos != null)
			commHandler.noticeSessionClose(wos.uid());
		
	}

	public WebOnlineSession getWos() {
		return wos;
	}

	public void setWebOnlineSession(WebOnlineSession wos) {
		this.wos = wos;
	}
	
	////////////////////////////NoticeMsgHandler//////////////////

	public void noticeMsg(CornuMessage message) {
		if(commHandler==null || wos ==null)
			return;
		super.noticeMsg(message);
		switch (message.getTid()) {
		case TidConst.T12123:
			MB12123 mb12123 = (MB12123)message.getFields()[0];
			commHandler.noticeQuoto(wos.uid(), mb12123.getRt());
			break;
		case TidConst.T20183:
			MB20183 mb20183 = (MB20183)message.getFields()[0];
			commHandler.noticeTradeResult(wos.uid(), mb20183);
			break;
		case TidConst.T20193:
			MB13332 mb13332 = (MB13332)message.getFields()[0];
			commHandler.noticeOrderChange(wos.uid(), mb13332.getTradeOrders());
			break;
		case TidConst.T20203:
			MB13312 mb13312 = (MB13312)message.getFields()[0];
			commHandler.noticeAccntChange(wos.uid(), mb13312.getTradeAccnts());
			break;
		case TidConst.T20213:
			MB13312 _mb13312 = (MB13312)message.getFields()[0];
			commHandler.noticeStopOut(wos.uid(), _mb13312.getTradeAccnts());
			break;
		case TidConst.T20223:
			MB20223 mb20223 = (MB20223)message.getFields()[0];
			commHandler.noticeOverNight(wos.uid(), mb20223);
			break;
		case TidConst.T10113:
			MB10113 mb10113 = (MB10113)message.getFields()[0];
			commHandler.noticeBeKicked(wos.uid(), mb10113);
			break;
		case TidConst.T12153:
			MB12153 mb12153 = (MB12153)message.getFields()[0];
			commHandler.noticeStockQuoto(wos.uid(), mb12153.getStockQuoto());
		case TidConst.T20293:
			MB13502 mb13502 = (MB13502)message.getFields()[0];
			commHandler.noticeHoldStatistics(wos.uid(), mb13502);
			break;
		default:
//			throw new IllegalStateException("通知事件没有处理: Tid: " + message.getTid());
			log.warn("通知事件没有处理: Tid: " + message.getTid());
			break;
		}
	}
	@Override
	public MB23092 sendBalanceRequest(int custId,String bankNum,double balance, String reqReason) {
			//以下一段话必带， 用于锁对话模式
			dialogLock.lock();
			MB23092 mb23092 = null;
			try {
				MB23091 mb23091 = new MB23091(custId, bankNum, balance, reqReason);
				sendMsgAndSetNoSeq(TidConst.T23091, mb23091);
				
				//以下一段话必带，用于等对话模式回包
				sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
				if(nowCornuMessage ==null){
					
				}else if(nowCornuMessage instanceof MB10992){
					MB10992 mb10992 = (MB10992) nowCornuMessage;
					mb23092 = new MB23092();
					mb23092.setRtnCode(mb10992.getRtnCode());
				}else{
					mb23092 = (MB23092)nowCornuMessage;
				}
			} catch (Exception e) {
				log.error("error", e);
			} finally{
				nowCornuMessage = null;
				dialogLock.unlock();
			}

			return mb23092;
	}

	@Override
	public MB23102 auditVoucherStatus(int cngoldId,int reqId,int status, String reason,String assessor) {
		dialogLock.lock();
		MB23102 mb23102 = null;
		try{
			MB23101 mb23101 = new MB23101(cngoldId,reqId,status,reason,assessor);
			sendMsgAndSetNoSeq(TidConst.T23101, mb23101);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else if(nowCornuMessage instanceof MB10992){
				MB10992 mb10992 = (MB10992) nowCornuMessage;
				mb23102 = new MB23102();
				mb23102.setRtnCode(mb10992.getRtnCode());
			}else{
				mb23102 = (MB23102)nowCornuMessage;
			}
		}catch(Exception e){
			log.error("error", e);
		}finally {
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb23102;
	}

	@Override
	public MB10992 confirmDrawCash(int custId, int reqId, String serialNum) {
		dialogLock.lock();
		MB10992 mb10992 = null;
		try{
			MB23301 mb23301 = new MB23301(custId,reqId,serialNum);
			sendMsgAndSetNoSeq(TidConst.T23301, mb23301);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else
				mb10992 = (MB10992)nowCornuMessage;
		}catch(Exception e){
			log.error("error", e);
		}finally {
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb10992;
	}

	@Override
	public MB23202 getCustBalanceRequestList(int custId,int reqId, int status, String reqDate, int beginNum, int limit, String esc,String orderBy) {
		dialogLock.lock();
		MB23202 mb23202 = null;
		try{
			MB23201 mb23201 = new MB23201(custId,reqId,status,reqDate,limit,esc,beginNum,orderBy);
			sendMsgAndSetNoSeq(TidConst.T23201, mb23201);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else if(nowCornuMessage instanceof MB10992){
				MB10992 mb10992 = (MB10992) nowCornuMessage;
				mb23202 = new MB23202();
				mb23202.setRtnCode(mb10992.getRtnCode());
			}else{
				mb23202 = (MB23202)nowCornuMessage;
			}
		}catch(Exception e){
			log.error("error", e);
		}finally {
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		return mb23202;
	}

	@Override
	public MB13622 getTradeAccntsByCnGoldId(int cngoldId) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB13622 mb13622 = null;
		try {
			
			MB13321 mb13321 = new MB13321(cngoldId);
			sendMsgAndSetNoSeq(TidConst.T13621, mb13321);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else{
				if(nowCornuMessage instanceof MB10992){
					MB10992 mb10992 = (MB10992) nowCornuMessage;
					mb13622 = new MB13622();
					mb13622.setRtnCode(mb10992.getRtnCode());
				}else{
					mb13622 = (MB13622)nowCornuMessage;
				}
			}
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb13622;
	}

	@Override
	public MB10042 getLoginTokenByCngoldId(int i) {
		dialogLock.lock();
		MB10042 mb10042 = null;
		try {
			MB15711 mb15711 = new MB15711();
			mb15711.setCngoldId(145948);
			nowDialogSeq = 0;
			sendUnloginMsg(15711, mb15711, nowDialogSeq);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);

			if(nowCornuMessage ==null){

			}else
				mb10042 = (MB10042)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb10042;
	}

	@Override
	public MB20312 closeSellHoldingWithCngoldId(int askId, TradeOrderPost to) {
		//以下一段话必带， 用于锁对话模式
		dialogLock.lock();
		MB20312 mb20312 = null;
		try {
			MB20081 mb20081 = new MB20081(askId, to.getCngoldId(), (int)to.getSmbl_id(), 
					to.getLots(), to.getId(), to.getClose_prc(), to.getMaxWarp());
			sendMsgAndSetNoSeq(TidConst.T20491, mb20081);
			
			//以下一段话必带，用于等对话模式回包
			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			if(nowCornuMessage ==null){
				
			}else{
				if(nowCornuMessage instanceof MB10992){
					MB10992 mb10992 = (MB10992) nowCornuMessage;
					mb20312 = new MB20312();
					mb20312.setRtnCode(mb10992.getRtnCode());
				}else{
					mb20312 = (MB20312)nowCornuMessage;
				}
			}
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}

		return mb20312;
	}
}
