/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.client2.phoenix;

import com.lmsoft.cornu.common.online.OnlineConst;
import com.lmsoft.cornu.webtrade.sdk.base.DialogMsgHandler;
import com.lmsoft.cornu.webtrade.sdk.base.NoticeMsgHandler;
import com.lmsoft.cornu.webtrade.sdk.base.NoticeSessionCloseHandler;
import com.lmsoft.cornu.webtrade.sdk.client2.PrivateMsgTask;
import com.lmsoft.cornu.webtrade.sdk.client2.PrivateMsgTheadPool;
import com.lmsoft.cornu.webtrade.sdk.config.WebTraderConfig;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB10141;
import com.sangame.phoenix.client.PhoenixClient2;
import com.sangame.phoenix.client.PhoenixClient2.RemoteHost;
import com.sangame.phoenix.cornu.CornuMessage;

import static com.lmsoft.cornu.webtrade.sdk.TidConst.T10141;

/**
 * @author JerryZ
 *
 */
public class ComminicationClient {
//    private static final Log log = LogFactory.getLog(ComminicationClient.class);
    
	private static final String FORCE_CLOSE_SESSION = "Cornu.common.OnlineSession.FORCE_CLOSE_SESSION";
	public static String BOUND_CLIENT = "Cornu.common.OnlineSession.bindClient";
	
	private PhoenixClient2 client;
	private DialogMsgHandler dialogMsgHandler;
	private NoticeMsgHandler noticeMsgHandler;
	private WebTraderConfig config;
	private PrivateMsgTheadPool privateMsgTheadPool;
	private NoticeSessionCloseHandler noticeSessionCloseHandler;

	public ComminicationClient(WebTraderConfig tradeConfig, DialogMsgHandler dialogMsgHandler,
			NoticeMsgHandler noticeMsgHandler,NoticeSessionCloseHandler noticeSessionCloseHandler,  PrivateMsgTheadPool privateMsgTheadPool) {
		this.config = tradeConfig;
		this.dialogMsgHandler = dialogMsgHandler;
		this.noticeMsgHandler = noticeMsgHandler;
		this.noticeSessionCloseHandler = noticeSessionCloseHandler;
		this.privateMsgTheadPool = privateMsgTheadPool;
	}
	
	public void init(){
		client = new PhoenixClient2(SingleSc.getInstance().getSc());
		
		client.setAutoConn(false);
		
		RemoteHost loginInfo = new RemoteHost();
		loginInfo.setServIp(config.getServerIp());
		loginInfo.setServPort(config.getServerPort());
		loginInfo.setLoginName("FS");
		loginInfo.setLoginPwd("fs.6maisoft");
		client.setLoginInfo(loginInfo);
	}
	
	public void connect(){
		client.connect();
		client.getSession().setAttribute(BOUND_CLIENT, this);
	}

	public void sendMsg(CornuMessage msg) {
		client.getSession().write(msg);
	}

	public void disconnect(){
		client.getSession().setAttribute(FORCE_CLOSE_SESSION, true);
		client.disconnect();
	}

	public boolean haveConnected(){
		return client.haveConnected();
	}
	
	//根据不同type进行分发, 并且切断线程
	public void receiveMsg(CornuMessage msg) {
		
//		noticeMsgHandler.noticeMsg(msg);
		if(msg.getSeqSeries() == OnlineConst.COMM_MODE_DIALOG){
//			if(log.isDebugEnabled() && msg.getTid() != TidConst.T12011)
//				log.debug("receive Message: TID:" + msg.getTid() +"seqNo..." + msg.getSeqNo() + "..." + ((BaseWebTraderField)msg.getFields()[0]).id()
//						+ ((BaseWebTraderField)msg.getFields()[0]).toString() + "时间" + System.currentTimeMillis()
//						 + " ["+ DateUtil.getMinuteStr(new Date()) +"]");
			dialogMsgHandler.receiveMsg(msg);

		}else if(msg.getSeqSeries() == OnlineConst.COMM_MODE_PRIVATE){
//			if(log.isDebugEnabled() && msg.getTid() != TidConst.T12123)
//				log.debug("receive Message: TID:" + msg.getTid() +"seqNo..." + msg.getSeqNo() + "..." + ((BaseWebTraderField)msg.getFields()[0]).id()
//						+ ((BaseWebTraderField)msg.getFields()[0]).toString() + "时间" + System.currentTimeMillis()
//						 + " ["+ DateUtil.getMinuteStr(new Date()) +"]");
			PrivateMsgTask task = new PrivateMsgTask(this, msg);
			privateMsgTheadPool.addPrivateMsgTask(task);
		}
	}

	public NoticeMsgHandler getNoticeMsgHandler() {
		return noticeMsgHandler;
	}

	public void setNoticeMsgHandler(NoticeMsgHandler noticeMsgHandler) {
		this.noticeMsgHandler = noticeMsgHandler;
	}
	
	public  boolean isForceClose() {
		boolean flag = false;
		flag = (Boolean)client.getSession().getAttribute(FORCE_CLOSE_SESSION, false);
		return flag;
	}
	
	public void sesseionClosed(){
		noticeSessionCloseHandler.beClosed();
	}

	public WebTraderConfig getConfig() {
		return config;
	}

	public void setConfig(WebTraderConfig config) {
		this.config = config;
	}

	public void sessionIdle() {
		CornuMessage msg = new CornuMessage();
		msg.setTid(T10141);
		msg.setSeqSeries(0);
		msg.addField(new MB10141());
		msg.setSeqNo(0);
		sendMsg(msg);
	}

}