/**
 * Copyright (c) 2008 by sangame.com.
 * All right reserved.
 */
package com.lmsoft.cornu.webtrade.sdk.message;

import java.nio.charset.Charset;

import com.lmsoft.cornu.webtrade.sdk.message.bean.QueryTimeType;
import com.lmsoft.cornu.webtrade.sdk.message.bean.QueryType;
import com.sangame.phoenix.cornu.field.BaseDataField;


public abstract class BaseWebTraderField extends BaseDataField implements WebTraderMessage {

	@Override
	public int id() {
		return getCommandCode();
	}

	protected void readCommandHead() {
	}
	protected void writeCommandHead() {
	}
	
	// get commandbody attributes	
	abstract protected void readCommandBody();
	
	// set commandbody attributes	
	abstract protected void writeCommandBody();
	
	@Override
	protected String readString() {
		byte[] temp = readByteArray();
		return temp == null? null : new String(temp, Charset.forName("GBK"));
	}

	@Override
	protected void writeString(String str) {
		writeByteArray(str == null? null : str.getBytes(Charset.forName("GBK")));
	}
	
	@Override
	public void readData() {
		readCommandHead();
		readCommandBody();
	}

	@Override
	public void writeData() {
		writeCommandHead();
		writeCommandBody();
	}	
	
	
	protected double readFloatAsDouble(){
		return readFloatD();
	}
	
	protected void writeQueryType(QueryType queryType){
		writeByte((byte)queryType.getQueryType());
		writeString(queryType.getQueryCondition());
	}
	
	protected void writeQueryTimeType(QueryTimeType queryTimeType){
		writeInt(queryTimeType.getQueryType());
		writeLong(queryTimeType.getBeginTime());
		writeLong(queryTimeType.getEndTime());
	}
	
}
