/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.nio.charset.Charset;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.UnloginAble;

/**
 * 登陆挑战应答
 * @author JerryZ 
 * 2009-6-16 下午 08:01:33
 */
public class MB10032 extends BaseWebTraderField implements UnloginAble{
	/**
	 * 0成功
	 */
	int errCode;
	/**
	 * 挑战串
	 */
	String returnStr;
	
	@Override
	protected void readCommandBody() {
		errCode = readInt();
		returnStr = readString();
	}

	@Override
	protected void writeString(String str) {
		writeByteArray(str == null? null : str.getBytes(Charset.forName("UTF-8")));
	}
	
	@Override
	protected void writeCommandBody() {
		writeInt(errCode);
		writeString(returnStr);
	}

	public int getCommandCode() {
		return PidConst.P10032;
	}

	public int getErrCode() {
		return errCode;
	}

	public void setErrCode(int errCode) {
		this.errCode = errCode;
	}

	public String getReturnStr() {
		return returnStr;
	}

	public void setReturnStr(String returnStr) {
		this.returnStr = returnStr;
	}
}
