/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.UnloginAble;

/**
 * 客户登录请求
 * @author JerryZ 
 * 2009-6-16 下午 08:01:33
 */
public class MB10041 extends BaseWebTraderField implements UnloginAble {
	/**
	 * 登录名
	 */
	String loginName;
	/**
	 * 密码，用户密码的MD5字符串+SendTime，再取MD5字符串
	 */
	String password;
	/**
	 * mac地址
	 */
	String clientMac;
	int source;
	/**
	 * 客户端类型
	 */
	String version;
	/**
	 * 扩展字段，用于传输一些额外的信息, 使用key value的形式,key 与value之间使用冒号(:)分隔, 多个值中间用分号(;)分隔, 如webTrader想传客户的登陆IP和客户的UID, 即可以通过"IP:127.0.0.1;UID:XXXXX"的形式
	 */
	String extend;
	@Override
	protected void readCommandBody() {
		loginName = readString();
		password = readString();
		clientMac = readString();
		source = readInt();
		version = readString();
		extend = readString();
	}

	@Override
	protected void writeCommandBody() {
		writeString(loginName);
		writeString(password);
		writeString(clientMac);
		writeInt(source);
		writeString(version);
		writeString(extend);
	}

	public int getCommandCode() {
		return PidConst.P10041;
	}

	public String getClientMac() {
		return clientMac;
	}

	public void setClientMac(String clientMac) {
		this.clientMac = clientMac;
	}

	public String getLoginName() {
		return loginName;
	}

	public void setLoginName(String loginName) {
		this.loginName = loginName;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public int getSource() {
		return source;
	}

	public void setSource(int source) {
		this.source = source;
	}

	public String getVersion() {
		return version;
	}

	public void setVersion(String version) {
		this.version = version;
	}

	
	
	public String getExtend() {
		return extend;
	}

	public void setExtend(String extend) {
		this.extend = extend;
	}

	private MB10041() {
	}

	public MB10041(String loginName, String password, String clientMac, int source, String version, String extend) {
		super();
		this.loginName = loginName;
		this.password = password;
		this.clientMac = clientMac;
		this.source = source;
		this.version = version;
		this.extend = extend;
	}
}
