/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.UnloginAble;

/**
 * 客户登录应答 
 * @author JerryZ 
 * 2009-6-16 下午  08:01:33
 * 
 */
public class MB10042 extends BaseWebTraderField implements UnloginAble{
	/**
	 * 返回码
	 */
	int rtnCode;
	/**
	 * 用户编号
	 */
	int userId;
	/**
	 * 客户端登陆方式，1: 为正常登陆, 2:为只读登陆
	 */
	byte loginType;
	
	/**
	 * 扩展字段，用于传输一些额外的信息, 使用key value的形式,<br/>
	 * key 与value之间使用冒号(:)分隔, 多个值中间用分号(;)分隔,<br/>
	 * 如webTrader想传客户的登陆IP和客户的UID, 即可以通过"IP:127.0.0.1;UID:XXXXX"的形式
	 * 
	 * <ul>key列表
	 * <li>UID: 用于传UID</li>
	 * <li>LOGIN_KEY: 用于在登陆成功时有人已经在他处登陆,就给客户端生成一个登陆的密钥，如果确定要踢只要发此KEY即可登陆</li>
	 * <li>IP:用于传IP(用于在登陆成功时有人已经在他处登陆,当前的登陆IP)</li>
	 * <li>LOGIN_TIME:用于传登陆时间(用于在登陆成功时有人已经在他处登陆,当前的登陆时间, 类型为long)</li>
	 * </ul>
	 */
	String extend;
	@Override
	protected void readCommandBody() {
		rtnCode = readInt();
		userId = readInt();
		loginType =  readByte();
		extend = readString();
	}

	@Override
	protected void writeCommandBody() {
	}

	public int getCommandCode() {
		return PidConst.P10042;
	}

	public byte getLoginType() {
		return loginType;
	}

	public void setLoginType(byte loginType) {
		this.loginType = loginType;
	}

	public int getRtnCode() {
		return rtnCode;
	}

	public void setRtnCode(int rtnCode) {
		this.rtnCode = rtnCode;
	}

	public int getUserId() {
		return userId;
	}

	public void setUserId(int userId) {
		this.userId = userId;
	}

	public String getExtend() {
		return extend;
	}

	public void setExtend(String extend) {
		this.extend = extend;
	}
}
