/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.nio.ByteOrder;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.base.DoubleUtil;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.bean.QuotoPost;

/**
 * 点线图请求应答
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB12012 extends BaseWebTraderField{
	private static final Log log = LogFactory.getLog(MB12012.class);
	/** unit数据大小 */
	public static final int SIZE = 44;
	
	/**
	 * 商品Code
	 */
	private String symbolCode;
	/**
	 * 行情时间
	 */
	private long DateTime;

	/**
	 * 开盘价
	 */
	private double Open;

	/**
	 * 最高价
	 */
	private double high;

	/**
	 * 最高价
	 */
	private double low;

	/**
	 * 最高价
	 */
	private double close;
	/**
	 * 最高价
	 */
	private double volume;
	/**
	 * 最高价
	 */
	private double holding;

	/**
	 * 商品行情
	 */
	QuotoPost quotoPost = new QuotoPost();
	List<MB12012> quotoResults = new ArrayList<MB12012>();
	
	@Override
	protected void readCommandBody() {
		quotoPost.setSymbolCode(readString());	// symbolCode
		quotoPost.setStyle(readInt());			// style
		quotoPost.setTime(readLong());			// time
		quotoPost.setOffset(readShort());		// offset
		int pointCount = readShort();			// 点数
		byte[] b = readByteArray();
		//数据处理
		dealByteArray(b, pointCount);
	}

	@Override
	protected void writeCommandBody() {
	}

	public int getCommandCode() {
		return PidConst.P12012;
	}

	private void dealByteArray(byte[] b, int pointCount){
		if(b.length != SIZE * pointCount){
			log.error("数据段长度有误: pointCount:" + pointCount + ", 实际Byte[]长度" + b.length);
		}
		
		java.nio.ByteBuffer buf = java.nio.ByteBuffer.wrap(b);
		buf.order(ByteOrder.LITTLE_ENDIAN);// windows native byte order
		for(int i=0; i<pointCount ; i++){
			MB12012 result = new MB12012();
			result.setQuotoPost(quotoPost);
			result.setSymbolCode(quotoPost.getSymbolCode());
			result.setDateTime(buf.getLong());
			result.setOpen(DoubleUtil.float2Double(buf.getFloat()));
			result.setHigh(DoubleUtil.float2Double(buf.getFloat()));
			result.setLow(DoubleUtil.float2Double(buf.getFloat()));
			result.setClose(DoubleUtil.float2Double(buf.getFloat()));
			result.setVolume(DoubleUtil.float2Double(buf.getFloat()));
			result.setHolding(DoubleUtil.float2Double(buf.getFloat()));
			buf.getFloat();				// reserved1
			buf.getFloat();				// reserved2
			buf.getFloat();				// reserved3
			quotoResults.add(result);
		}
	}

	public String getSymbolCode() {
		return symbolCode;
	}

	public void setSymbolCode(String symbolCode) {
		this.symbolCode = symbolCode;
	}

	public long getDateTime() {
		return DateTime;
	}

	public void setDateTime(long dateTime) {
		DateTime = dateTime;
	}

	public double getOpen() {
		return Open;
	}

	public void setOpen(double open) {
		Open = open;
	}

	public double getHigh() {
		return high;
	}

	public void setHigh(double high) {
		this.high = high;
	}

	public double getLow() {
		return low;
	}

	public void setLow(double low) {
		this.low = low;
	}

	public double getClose() {
		return close;
	}

	public void setClose(double close) {
		this.close = close;
	}

	public double getVolume() {
		return volume;
	}

	public void setVolume(double volume) {
		this.volume = volume;
	}

	public double getHolding() {
		return holding;
	}

	public void setHolding(double holding) {
		this.holding = holding;
	}

	public QuotoPost getQuotoPost() {
		return quotoPost;
	}

	public void setQuotoPost(QuotoPost quotoPost) {
		this.quotoPost = quotoPost;
	}

	public List<MB12012> getQuotoResults() {
		return quotoResults;
	}

	public void setQuotoResults(List<MB12012> quotoResults) {
		this.quotoResults = quotoResults;
	}
}
