/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.bean.BeginEndPrice;

/**
 * 12061 所有行情信息查询应答(所有自己有权限商品的高开低收)
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB12123 extends BaseWebTraderField{
	List<MB12123> rt = new ArrayList<MB12123>();
	
	int smblId;
	
	int decPoint;
	
	int quotoType;
	
	double price;

	Date quotoTime;
	
	//限价挂近远点
	BeginEndPrice limitPendingPrice;
	
	//止损挂近远点
	BeginEndPrice stopLossPendingPrice;
	
	//止损持单近远点
	BeginEndPrice stopLossHoldingPrice;
	
	//止盈持单近远点
	BeginEndPrice stopProfitHoldingPrice;
	
	long receiveTime;
	@Override
	protected void readCommandBody() {
		receiveTime = readLong();
		int size = readShort();
		for(int i=0; i<size; i++){
			MB12123 quotation = new MB12123();
			quotation.setSmblId(readInt());
			quotation.setQuotoType(readByte());
			quotation.setPrice(readFloatAsDouble());
			quotation.setQuotoTime(new Date(receiveTime));
			rt.add(quotation);
		}
	}

	@Override
	protected void writeCommandBody() {
	}

	public int getCommandCode() {
		return PidConst.P12123;
	}

	public long getReceiveTime() {
		return receiveTime;
	}

	public void setReceiveTime(long receiveTime) {
		this.receiveTime = receiveTime;
	}

	public List<MB12123> getRt() {
		return rt;
	}

	public void setRt(List<MB12123> rt) {
		this.rt = rt;
	}

	public int getSmblId() {
		return smblId;
	}

	public void setSmblId(int smblId) {
		this.smblId = smblId;
	}

	public int getDecPoint() {
		return decPoint;
	}

	public void setDecPoint(int decPoint) {
		this.decPoint = decPoint;
	}

	public int getQuotoType() {
		return quotoType;
	}

	public void setQuotoType(int quotoType) {
		this.quotoType = quotoType;
	}

	public double getPrice() {
		return price;
	}

	public void setPrice(double price) {
		this.price = price;
	}

	public Date getQuotoTime() {
		return quotoTime;
	}

	public void setQuotoTime(Date quotoTime) {
		this.quotoTime = quotoTime;
	}

	public BeginEndPrice getLimitPendingPrice() {
		return limitPendingPrice;
	}

	public void setLimitPendingPrice(BeginEndPrice limitPendingPrice) {
		this.limitPendingPrice = limitPendingPrice;
	}

	public BeginEndPrice getStopLossPendingPrice() {
		return stopLossPendingPrice;
	}

	public void setStopLossPendingPrice(BeginEndPrice stopLossPendingPrice) {
		this.stopLossPendingPrice = stopLossPendingPrice;
	}

	public BeginEndPrice getStopLossHoldingPrice() {
		return stopLossHoldingPrice;
	}

	public void setStopLossHoldingPrice(BeginEndPrice stopLossHoldingPrice) {
		this.stopLossHoldingPrice = stopLossHoldingPrice;
	}

	public BeginEndPrice getStopProfitHoldingPrice() {
		return stopProfitHoldingPrice;
	}

	public void setStopProfitHoldingPrice(BeginEndPrice stopProfitHoldingPrice) {
		this.stopProfitHoldingPrice = stopProfitHoldingPrice;
	}
}
