/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.bean.QuotoItem;
import com.lmsoft.cornu.webtrade.sdk.message.bean.StockQuoto;

/**
 * 股票商品通知
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB12153 extends BaseWebTraderField{
	/**
	 * 股票行情
	 */
	StockQuoto stockQuoto = new StockQuoto();
	
	@Override
	protected void readCommandBody() {
		stockQuoto.setNoticeTime(new Date(readLong()));
		int size = readShort();
		List<QuotoItem> quotoItems = new ArrayList<QuotoItem>();
		for (int i = 0; i < size; i++) {
			QuotoItem item = new QuotoItem();
			item.setNoticeTime(stockQuoto.getNoticeTime());
			item.setSymbolId(readInt());
			item.setClose(readFloatD());
			item.setOpen(readFloatD());
			item.setHigh(readFloatD());
			item.setLow(readFloatD());
			item.setPrice(readFloatD());
			item.setAmount(readFloatD());
			item.setMoney(readFloatD());
			item.setSellPrice5(readFloatD());
			item.setSellAmount5(readFloatD());
			item.setSellPrice4(readFloatD());
			item.setSellAmount4(readFloatD());
			item.setSellPrice3(readFloatD());
			item.setSellAmount3(readFloatD());
			item.setSellPrice2(readFloatD());
			item.setSellAmount2(readFloatD());
			item.setSellPrice1(readFloatD());
			item.setSellAmount1(readFloatD());
			item.setBuyPrice1(readFloatD());
			item.setBuyAmount1(readFloatD());
			item.setBuyPrice2(readFloatD());
			item.setBuyAmount2(readFloatD());
			item.setBuyPrice3(readFloatD());
			item.setBuyAmount3(readFloatD());
			item.setBuyPrice4(readFloatD());
			item.setBuyAmount4(readFloatD());
			item.setBuyPrice5(readFloatD());
			item.setBuyAmount5(readFloatD());
			readFloatD();
			readFloatD();
			quotoItems.add(item);
		}
		stockQuoto.setQuotoItems(quotoItems);
	}

	@Override
	protected void writeCommandBody() {}

	@Override
	public int getCommandCode() {
		return PidConst.P12153;
	}

	public StockQuoto getStockQuoto() {
		return stockQuoto;
	}
}
