/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 商品信息查询应答
 * @author JerryZ 
 * 2009-6-18 下午01:48:46
 *
 */
public class MB13032 extends BaseWebTraderField{
	Map<Integer, MB13032> tradeSymbols = new HashMap<Integer, MB13032>();
	@Override
	protected void readCommandBody() {
		int size = readShort();
		for (int i = 0; i < size; i++) {
			MB13032 smbl = new MB13032();
			smbl.setId(readInt());
			smbl.setSmbl_name(readString());
			smbl.setTs_code(readString());
			smbl.setCode_id(readInt());
			smbl.setDetails(readString());
			smbl.setMarket_id( readInt());
			
			smbl.setMarket_name(readString());	//市场名称
			smbl.setMarket_type(readInt());		//市场类型
			
			smbl.setTrada_mode(readByte());
			smbl.setProfitloss_curr(readString());
			smbl.setMargin_curr(readString());
			smbl.setPermit(readByte());
			smbl.setBg_color(readString());
			smbl.setSpread(readShort());
			smbl.setSpread_scale(readFloatD());
			smbl.setFliter_level(readFloatD());
			smbl.setAuto_restrict(readFloatD());
			smbl.setFliter_count(readInt());
			smbl.setAbanded_second(readInt());
			smbl.setAlert_time(readInt());
			smbl.setContract_size(readInt());
			smbl.setHang_mode(readInt());
			smbl.setMargin(readFloatD());
			smbl.setLock_margin(readFloatD());
			smbl.setFrozen_margin(readFloatD());
			smbl.setHigh_order_spread_value(readFloatD());
			smbl.setHigh_order_spread_type(readByte());
			smbl.setLower_order_spread_value(readFloatD());
			smbl.setLower_order_spread_type(readByte());
			smbl.setHigh_loss_spread_value(readFloatD());
			smbl.setHigh_loss_spread_type(readByte());
			smbl.setLower_loss_spread_value(readFloatD());
			smbl.setLower_loss_spread_type(readByte());
			smbl.setHigh_profit_spread_value(readFloatD());
			smbl.setHigh_profit_spread_type(readByte());
			smbl.setLower_profit_spread_value(readFloatD());
			smbl.setLower_profit_spread_type(readByte());
			smbl.setCal_intst_mode(readShort());
			smbl.setCal_charge_mode(readShort());
			smbl.setBuy_cease_diff(readFloatD());
			smbl.setSail_cease_diff(readFloatD());
			smbl.setFund_charge(readFloatD());
			smbl.setClose_charge(readFloatD());
			smbl.setThree_interest(readInt());
			long beginTime = readLong();
			smbl.setBegin_time(beginTime==0 ? null : new Date(beginTime)); 
			long endTime = readLong();
			smbl.setEnd_time(endTime==0 ? null : new Date(endTime));
			smbl.setSort_index(readInt());
			smbl.setCal_formula(readString()); //计算公式
			smbl.setMemo(readString()); //comment 备注
			smbl.setBalance_time(readString());
			smbl.setDec_point(readInt());
			smbl.setTime_effective_cycle(readInt());
			smbl.setExtension_type(readInt());
			smbl.setDelivery_charge(readFloatD());
			smbl.setExtension_charge(readFloatD());
			smbl.setMem_quo_protected(readBoolean());
			smbl.setMini_size(readDouble());
			smbl.setDeposit_scale(readDouble());
			smbl.setBail_gram(readDouble());
			smbl.setContract_gram(readInt());
			smbl.setMin_lots(readDouble());
			tradeSymbols.put(smbl.getId(), smbl);
		}
	}

	public MB13032() {
		super();
	}

	@Override
	protected void writeCommandBody() {
	}

	public int getCommandCode() {
		return PidConst.P13032;
	}
	int id;
	/**
	 * 商品名称(交易代码)
	 */
	private String ts_code;
	/**
	 * 商品名称(交易代码)
	 */
	private String smbl_name;
	/**
	 * 保证金货币
	 */
	private String margin_curr;
	/**
	 * 盈亏货币
	 */
	private String profitloss_curr;
	/**
	 * PK
	 */
	private int code_id;

	/**
	 * 小数点位数
	 */
	private int dec_point;

	/**
	 * 商品描述
	 */
	private String details;

	/**
	 * 所属市场ID
	 */
	private int market_id;

	/**
	 * 交易模式(1.要价成交，2.现价成交，3.市价成交)
	 */
	private int trada_mode;

	/**
	 * 交易许可（1.全部权限，2.只显示（close only）,3.不允许）
	 */
	private int permit;

	/**
	 * 背景颜色
	 */
	private String bg_color;

	/**
	 * 挂单模式(0,当日有效(包括止损，止盈)，1，永远有效，2，当日有效(除止损，止盈))
	 */
	private int hang_mode;

	/**
	 * 点差(按点)
	 */
	private int spread;

	/**
	 * 点差比例
	 */
	private double spread_scale;

	/**
	 * 过滤水平（不在此水平认为行情不合法）
	 */
	private double fliter_level;

	/**
	 * 自动限制(不在此百分比的跳动认为非法)
	 */
	private double auto_restrict;

	/**
	 * 连续错价次数，认为合法
	 */
	private int fliter_count;

	/**
	 * 交易节前多少秒舍弃
	 */
	private int abanded_second;

	/**
	 * 行情报警时间
	 */
	private int alert_time;

	/**
	 * 合约数量
	 */
	private int contract_size;

	/**
	 * 普通保证金
	 */
	private double margin;

	/**
	 * 一对锁单保证金
	 */
	private double lock_margin;

	/**
	 * 冻结保证金
	 */
	private double frozen_margin;

	/**
	 * 计算公式
	 */
	private String cal_formula;

	/**
	 * 挂单上限类型
	 */
	private int high_order_spread_type;

	/**
	 * 挂单上限值
	 */
	private double high_order_spread_value;

	/**
	 * 挂单下限类型
	 */
	private int lower_order_spread_type;

	/**
	 * 挂单下限值
	 */
	private double lower_order_spread_value;

	/**
	 * 止损上限类型
	 */
	private int high_loss_spread_type;

	/**
	 * 止损上限值
	 */
	private double high_loss_spread_value;

	/**
	 * 止损下限类型
	 */
	private int lower_loss_spread_type;

	/**
	 * 止损下限值
	 */
	private double lower_loss_spread_value;

	/**
	 * 止赢上限类型
	 */
	private int high_profit_spread_type;

	/**
	 * 止赢上限值
	 */
	private double high_profit_spread_value;

	/**
	 * 止赢下限类型
	 */
	private int lower_profit_spread_type;

	/**
	 * 止赢下限值
	 */
	private double lower_profit_spread_value;

	/**
	 * 利息收取方式 1:按利率(外汇专用)2：按保证金金额(外汇专用)3：按盈亏金额(通用的)
	 */
	private int cal_intst_mode;

	/**
	 * 外汇手续费收取方式(外汇专用) 2：按保证金金额，3：按盈亏金额
	 */
	private int cal_charge_mode;

	/**
	 * 建仓手续费
	 */
	private double fund_charge;

	/**
	 * 平仓手续费
	 */
	private double close_charge;

	/**
	 * 三日记息收取日
	 */
	private int three_interest;

	/**
	 * 与END_TIME组成有效期
	 */
	private Date begin_time;

	/**
	 * 与BEGIN_TIME组成有效期
	 */
	private Date end_time;

	/**
	 * 排序用
	 */
	private int sort_index;

	/**
	 * 买单隔夜
	 */
	private double buy_cease_diff;

	/**
	 * 卖单隔夜
	 */
	private double sail_cease_diff;

	/**
	 * 现价成交最大量
	 */
	private int max_trade;

	/**
	 * 结算时间
	 */
	private String balance_time;
	/**
	 * 备注
	 */
	private String memo;
	/**
	 * 时效周期
	 */
	private int time_effective_cycle;
	/**
	 * 续约方式
	 */
	private int extension_type;
	/**
	 * 交割手续费
	 */
	private double delivery_charge;
	/**
	 * 续约手续费
	 */
	private double extension_charge;
	
	/**
	 * 是否行情保护
	 */
	private boolean mem_quo_protected;

	/**
	 * 市场名称
	 */
	private String market_name;
	
	/**
	 * 市场类型
	 */
	private int market_type;
	
	/**
	 * 客户组ID
	 */
	private int custGroupId;
	
	/**
	 * @since skyfall v2.0
	 * 计点位数
	 */
	private int calc_profit_point;
	/**
	 * @since v2.0
	 * 计点模式折算率
	 *  每个商品的盈亏均按1点来算，对于玩不同商品的客户会不公平 ，所以需要增加一个折算率的属性，
	 *  比如黄金盈亏一个点按100%算，而白银的盈亏一个点比较容易，就将折算率设置为50%,
	 *  这样白银的玩家赚2个点才能和黄金赚一个点打平。
	 */
	private double calc_point_rate;
	
	/**
	 * 新增字段mini_size，表示mini手与真实手的比例
	 * */
	private Double mini_size;
	
	/**
	 * 保证金比例
	 * */
	private Double deposit_scale;
	/**
	 * 每克保证金
	 * */
	private double bail_gram;
	
	/**
	 * 每手合约克数
	 * */
	 private int contract_gram;
	 
	 /**
	  * 最小手数
	  * */
	 private double min_lots;
	public Map<Integer, MB13032> getTradeSymbols() {
		return tradeSymbols;
	}

	public void setTradeSymbols(Map<Integer, MB13032> tradeSymbols) {
		this.tradeSymbols = tradeSymbols;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getTs_code() {
		return ts_code;
	}

	public void setTs_code(String tsCode) {
		ts_code = tsCode;
	}

	public String getSmbl_name() {
		return smbl_name;
	}

	public void setSmbl_name(String smblName) {
		smbl_name = smblName;
	}

	public String getMargin_curr() {
		return margin_curr;
	}

	public void setMargin_curr(String marginCurr) {
		margin_curr = marginCurr;
	}

	public String getProfitloss_curr() {
		return profitloss_curr;
	}

	public void setProfitloss_curr(String profitlossCurr) {
		profitloss_curr = profitlossCurr;
	}

	public int getCode_id() {
		return code_id;
	}

	public void setCode_id(int codeId) {
		code_id = codeId;
	}

	public int getDec_point() {
		return dec_point;
	}

	public void setDec_point(int decPoint) {
		dec_point = decPoint;
	}

	public String getDetails() {
		return details;
	}

	public void setDetails(String details) {
		this.details = details;
	}

	public int getMarket_id() {
		return market_id;
	}

	public void setMarket_id(int marketId) {
		market_id = marketId;
	}

	public int getTrada_mode() {
		return trada_mode;
	}

	public void setTrada_mode(int tradaMode) {
		trada_mode = tradaMode;
	}

	public int getPermit() {
		return permit;
	}

	public void setPermit(int permit) {
		this.permit = permit;
	}

	public String getBg_color() {
		return bg_color;
	}

	public void setBg_color(String bgColor) {
		bg_color = bgColor;
	}

	public int getHang_mode() {
		return hang_mode;
	}

	public void setHang_mode(int hangMode) {
		hang_mode = hangMode;
	}

	public int getSpread() {
		return spread;
	}

	public void setSpread(int spread) {
		this.spread = spread;
	}

	public double getSpread_scale() {
		return spread_scale;
	}

	public void setSpread_scale(double spreadScale) {
		spread_scale = spreadScale;
	}

	public double getFliter_level() {
		return fliter_level;
	}

	public void setFliter_level(double fliterLevel) {
		fliter_level = fliterLevel;
	}

	public double getAuto_restrict() {
		return auto_restrict;
	}

	public void setAuto_restrict(double autoRestrict) {
		auto_restrict = autoRestrict;
	}

	public int getFliter_count() {
		return fliter_count;
	}

	public void setFliter_count(int fliterCount) {
		fliter_count = fliterCount;
	}

	public int getAbanded_second() {
		return abanded_second;
	}

	public void setAbanded_second(int abandedSecond) {
		abanded_second = abandedSecond;
	}

	public int getAlert_time() {
		return alert_time;
	}

	public void setAlert_time(int alertTime) {
		alert_time = alertTime;
	}

	public int getContract_size() {
		return contract_size;
	}

	public void setContract_size(int contractSize) {
		contract_size = contractSize;
	}

	public double getMargin() {
		return margin;
	}

	public void setMargin(double margin) {
		this.margin = margin;
	}

	public double getLock_margin() {
		return lock_margin;
	}

	public void setLock_margin(double lockMargin) {
		lock_margin = lockMargin;
	}

	public double getFrozen_margin() {
		return frozen_margin;
	}

	public void setFrozen_margin(double frozenMargin) {
		frozen_margin = frozenMargin;
	}

	public String getCal_formula() {
		return cal_formula;
	}

	public void setCal_formula(String calFormula) {
		cal_formula = calFormula;
	}

	public int getHigh_order_spread_type() {
		return high_order_spread_type;
	}

	public void setHigh_order_spread_type(int highOrderSpreadType) {
		high_order_spread_type = highOrderSpreadType;
	}

	public double getHigh_order_spread_value() {
		return high_order_spread_value;
	}

	public void setHigh_order_spread_value(double highOrderSpreadValue) {
		high_order_spread_value = highOrderSpreadValue;
	}

	public int getLower_order_spread_type() {
		return lower_order_spread_type;
	}

	public void setLower_order_spread_type(int lowerOrderSpreadType) {
		lower_order_spread_type = lowerOrderSpreadType;
	}

	public double getLower_order_spread_value() {
		return lower_order_spread_value;
	}

	public void setLower_order_spread_value(double lowerOrderSpreadValue) {
		lower_order_spread_value = lowerOrderSpreadValue;
	}

	public int getHigh_loss_spread_type() {
		return high_loss_spread_type;
	}

	public void setHigh_loss_spread_type(int highLossSpreadType) {
		high_loss_spread_type = highLossSpreadType;
	}

	public double getHigh_loss_spread_value() {
		return high_loss_spread_value;
	}

	public void setHigh_loss_spread_value(double highLossSpreadValue) {
		high_loss_spread_value = highLossSpreadValue;
	}

	public int getLower_loss_spread_type() {
		return lower_loss_spread_type;
	}

	public void setLower_loss_spread_type(int lowerLossSpreadType) {
		lower_loss_spread_type = lowerLossSpreadType;
	}

	public double getLower_loss_spread_value() {
		return lower_loss_spread_value;
	}

	public void setLower_loss_spread_value(double lowerLossSpreadValue) {
		lower_loss_spread_value = lowerLossSpreadValue;
	}

	public int getHigh_profit_spread_type() {
		return high_profit_spread_type;
	}

	public void setHigh_profit_spread_type(int highProfitSpreadType) {
		high_profit_spread_type = highProfitSpreadType;
	}

	public double getHigh_profit_spread_value() {
		return high_profit_spread_value;
	}

	public void setHigh_profit_spread_value(double highProfitSpreadValue) {
		high_profit_spread_value = highProfitSpreadValue;
	}

	public int getLower_profit_spread_type() {
		return lower_profit_spread_type;
	}

	public void setLower_profit_spread_type(int lowerProfitSpreadType) {
		lower_profit_spread_type = lowerProfitSpreadType;
	}

	public double getLower_profit_spread_value() {
		return lower_profit_spread_value;
	}

	public void setLower_profit_spread_value(double lowerProfitSpreadValue) {
		lower_profit_spread_value = lowerProfitSpreadValue;
	}

	public int getCal_intst_mode() {
		return cal_intst_mode;
	}

	public void setCal_intst_mode(int calIntstMode) {
		cal_intst_mode = calIntstMode;
	}

	public int getCal_charge_mode() {
		return cal_charge_mode;
	}

	public void setCal_charge_mode(int calChargeMode) {
		cal_charge_mode = calChargeMode;
	}

	public double getFund_charge() {
		return fund_charge;
	}

	public void setFund_charge(double fundCharge) {
		fund_charge = fundCharge;
	}

	public double getClose_charge() {
		return close_charge;
	}

	public void setClose_charge(double closeCharge) {
		close_charge = closeCharge;
	}

	public int getThree_interest() {
		return three_interest;
	}

	public void setThree_interest(int threeInterest) {
		three_interest = threeInterest;
	}

	public Date getBegin_time() {
		return begin_time;
	}

	public void setBegin_time(Date beginTime) {
		begin_time = beginTime;
	}

	public Date getEnd_time() {
		return end_time;
	}

	public void setEnd_time(Date endTime) {
		end_time = endTime;
	}

	public int getSort_index() {
		return sort_index;
	}

	public void setSort_index(int sortIndex) {
		sort_index = sortIndex;
	}

	public double getBuy_cease_diff() {
		return buy_cease_diff;
	}

	public void setBuy_cease_diff(double buyCeaseDiff) {
		buy_cease_diff = buyCeaseDiff;
	}

	public double getSail_cease_diff() {
		return sail_cease_diff;
	}

	public void setSail_cease_diff(double sailCeaseDiff) {
		sail_cease_diff = sailCeaseDiff;
	}

	public int getMax_trade() {
		return max_trade;
	}

	public void setMax_trade(int maxTrade) {
		max_trade = maxTrade;
	}

	public String getBalance_time() {
		return balance_time;
	}

	public void setBalance_time(String balanceTime) {
		balance_time = balanceTime;
	}

	public String getMemo() {
		return memo;
	}

	public void setMemo(String memo) {
		this.memo = memo;
	}

	public int getTime_effective_cycle() {
		return time_effective_cycle;
	}

	public void setTime_effective_cycle(int timeEffectiveCycle) {
		time_effective_cycle = timeEffectiveCycle;
	}

	public int getExtension_type() {
		return extension_type;
	}

	public void setExtension_type(int extensionType) {
		extension_type = extensionType;
	}

	public double getDelivery_charge() {
		return delivery_charge;
	}

	public void setDelivery_charge(double deliveryCharge) {
		delivery_charge = deliveryCharge;
	}

	public double getExtension_charge() {
		return extension_charge;
	}

	public void setExtension_charge(double extensionCharge) {
		extension_charge = extensionCharge;
	}

	public boolean isMem_quo_protected() {
		return mem_quo_protected;
	}

	public void setMem_quo_protected(boolean memQuoProtected) {
		mem_quo_protected = memQuoProtected;
	}

	public String getMarket_name() {
		return market_name;
	}

	public void setMarket_name(String marketName) {
		market_name = marketName;
	}

	public int getMarket_type() {
		return market_type;
	}

	public void setMarket_type(int marketType) {
		market_type = marketType;
	}

	public int getCustGroupId() {
		return custGroupId;
	}

	public void setCustGroupId(int custGroupId) {
		this.custGroupId = custGroupId;
	}

	public int getCalc_profit_point() {
		return calc_profit_point;
	}

	public void setCalc_profit_point(int calcProfitPoint) {
		calc_profit_point = calcProfitPoint;
	}

	public double getCalc_point_rate() {
		return calc_point_rate;
	}

	public void setCalc_point_rate(double calcPointRate) {
		calc_point_rate = calcPointRate;
	}

	public Double getMini_size() {
		return mini_size;
	}

	public void setMini_size(Double mini_size) {
		this.mini_size = mini_size;
	}

	public Double getDeposit_scale() {
		return deposit_scale;
	}

	public void setDeposit_scale(Double deposit_scale) {
		this.deposit_scale = deposit_scale;
	}

	public double getBail_gram() {
		return bail_gram;
	}

	public void setBail_gram(double bail_gram) {
		this.bail_gram = bail_gram;
	}

	public int getContract_gram() {
		return contract_gram;
	}

	public void setContract_gram(int contract_gram) {
		this.contract_gram = contract_gram;
	}

	public double getMin_lots() {
		return min_lots;
	}

	public void setMin_lots(double min_lots) {
		this.min_lots = min_lots;
	}
	
}
