/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.HashMap;
import java.util.Map;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 商品信息查询应答
 * @author JerryZ 
 * 2009-6-18 下午01:48:46
 *
 */
public class MB13082 extends BaseWebTraderField{
	Map<Integer, MB13082> custGroupMkts = new HashMap<Integer, MB13082>();
	
	
	@Override
	protected void readCommandBody() {
		int size = readShort();
		for(int i=0; i<size; i++) {
			MB13082 custGroupMkt = new MB13082();
			readInt();		// groupMarketId, 客户端没用
			custGroupMkt.setGroup_id(readInt());
			custGroupMkt.setGroup_name(readString());
			custGroupMkt.setMarket_id(readInt());
			custGroupMkt.setMarket_name(readString());
			custGroupMkt.setMarket_type(readByte());
			custGroupMkt.setActive_flag(readBoolean());
			custGroupMkt.setTrade_flag(readBoolean());
			custGroupMkt.setAsk_trade_flag(readBoolean());
			custGroupMkt.setTrade_mode(readByte());
			custGroupMkt.setMargin_adjust(readFloatD());
			custGroupMkt.setMax_deviation(readFloatD());
			custGroupMkt.setCheck_ava_tick(readBoolean());
			custGroupMkt.setCheck_immediately(readBoolean());
			custGroupMkt.setLock_enable_flag(readBoolean());
			custGroupMkt.setMutily_close_flag(readBoolean());
			custGroupMkt.setAuto_close_mode(readByte());
			custGroupMkt.setSyn_create_flag(readBoolean());
			custGroupMkt.setMin_quantity(readFloatD());
			custGroupMkt.setMax_quantity(readFloatD());
			custGroupMkt.setStep_length(readFloatD());
			custGroupMkt.setShow_step(readFloatD());
			custGroupMkt.setAudit_type(readInt());
	
			custGroupMkts.put(custGroupMkt.getMarket_id(), custGroupMkt);
		}
}

	@Override
	protected void writeCommandBody() {
	}

	public int getCommandCode() {
		return PidConst.P13082;
	}

	/**
	 * 客户组ID
	 */
	private int group_id;

	/**
	 * 市场ID
	 */
	private int market_id;

	/**
	 * 客户组名称
	 */
	private String group_name;

	/**
	 * 是否有效
	 */
	private boolean active_flag;

	/**
	 * 是否交易
	 */
	private boolean trade_flag;

	/**
	 * 要价交易模式下需要确认
	 */
	private boolean ask_trade_flag;

	/**
	 * 交易模式（3种）
	 */
	private int trade_mode;

	/**
	 * 点差调整范围
	 */
	private double margin_adjust;

	/**
	 * 最大偏差
	 */
	private double max_deviation;

	/**
	 * 交易柜台回应以后是否不检查可用保证金
	 */
	private boolean check_ava_tick;

	/**
	 * 在最大偏差范围内是否立即成交（不再确认）
	 */
	private boolean check_immediately;

	/**
	 * 锁仓对平是否有效
	 */
	private boolean lock_enable_flag;

	/**
	 * 多部位平是否有效
	 */
	private boolean mutily_close_flag;

	/**
	 * 多部位平仓方式(7种)
	 */
	private int auto_close_mode;

	/**
	 * 反手建仓是否有效
	 */
	private boolean syn_create_flag;

	/**
	 * 最小手数
	 */
	private double min_quantity;

	/**
	 * 最大手数
	 */
	private double max_quantity;

	/**
	 * 步长
	 */
	private double step_length;

	/**
	 * 显示最小步长的手数
	 */
	private double show_step;

	/**
	 * 审核类型(4种：Constant.AUDIT_TYPE_NOT_AUDIT等)
	 */
	private int audit_type;

	/**
	 * 市场名称
	 */
	private String market_name;
	
	/**
	 * 市场类型
	 */
	private int market_type;


	public Map<Integer, MB13082> getCustGroupMkts() {
		return custGroupMkts;
	}

	public void setCustGroupMkts(Map<Integer, MB13082> custGroupMkts) {
		this.custGroupMkts = custGroupMkts;
	}

	public int getGroup_id() {
		return group_id;
	}

	public void setGroup_id(int groupId) {
		group_id = groupId;
	}

	public int getMarket_id() {
		return market_id;
	}

	public void setMarket_id(int marketId) {
		market_id = marketId;
	}

	public String getGroup_name() {
		return group_name;
	}

	public void setGroup_name(String groupName) {
		group_name = groupName;
	}

	public boolean isActive_flag() {
		return active_flag;
	}

	public void setActive_flag(boolean activeFlag) {
		active_flag = activeFlag;
	}

	public boolean isTrade_flag() {
		return trade_flag;
	}

	public void setTrade_flag(boolean tradeFlag) {
		trade_flag = tradeFlag;
	}

	public boolean isAsk_trade_flag() {
		return ask_trade_flag;
	}

	public void setAsk_trade_flag(boolean askTradeFlag) {
		ask_trade_flag = askTradeFlag;
	}

	public int getTrade_mode() {
		return trade_mode;
	}

	public void setTrade_mode(int tradeMode) {
		trade_mode = tradeMode;
	}

	public double getMargin_adjust() {
		return margin_adjust;
	}

	public void setMargin_adjust(double marginAdjust) {
		margin_adjust = marginAdjust;
	}

	public double getMax_deviation() {
		return max_deviation;
	}

	public void setMax_deviation(double maxDeviation) {
		max_deviation = maxDeviation;
	}

	public boolean isCheck_ava_tick() {
		return check_ava_tick;
	}

	public void setCheck_ava_tick(boolean checkAvaTick) {
		check_ava_tick = checkAvaTick;
	}

	public boolean isCheck_immediately() {
		return check_immediately;
	}

	public void setCheck_immediately(boolean checkImmediately) {
		check_immediately = checkImmediately;
	}

	public boolean isLock_enable_flag() {
		return lock_enable_flag;
	}

	public void setLock_enable_flag(boolean lockEnableFlag) {
		lock_enable_flag = lockEnableFlag;
	}

	public boolean isMutily_close_flag() {
		return mutily_close_flag;
	}

	public void setMutily_close_flag(boolean mutilyCloseFlag) {
		mutily_close_flag = mutilyCloseFlag;
	}

	public int getAuto_close_mode() {
		return auto_close_mode;
	}

	public void setAuto_close_mode(int autoCloseMode) {
		auto_close_mode = autoCloseMode;
	}

	public boolean isSyn_create_flag() {
		return syn_create_flag;
	}

	public void setSyn_create_flag(boolean synCreateFlag) {
		syn_create_flag = synCreateFlag;
	}

	public double getMin_quantity() {
		return min_quantity;
	}

	public void setMin_quantity(double minQuantity) {
		min_quantity = minQuantity;
	}

	public double getMax_quantity() {
		return max_quantity;
	}

	public void setMax_quantity(double maxQuantity) {
		max_quantity = maxQuantity;
	}

	public double getStep_length() {
		return step_length;
	}

	public void setStep_length(double stepLength) {
		step_length = stepLength;
	}

	public double getShow_step() {
		return show_step;
	}

	public void setShow_step(double showStep) {
		show_step = showStep;
	}

	public int getAudit_type() {
		return audit_type;
	}

	public void setAudit_type(int auditType) {
		audit_type = auditType;
	}

	public String getMarket_name() {
		return market_name;
	}

	public void setMarket_name(String marketName) {
		market_name = marketName;
	}

	public int getMarket_type() {
		return market_type;
	}

	public void setMarket_type(int marketType) {
		market_type = marketType;
	}
}
