/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 客户信息查询应答
 * @author JerryZ 
 * 2009-6-18 下午01:48:46
 *
 */
public class MB13102 extends BaseWebTraderField{
	MB13102 custInfo;
	@Override
	protected void readCommandBody() {
		List<MB13102> tempLists = new ArrayList<MB13102>();
		int size = readShort();
		for (int i = 0; i < size; i++) {
			MB13102 ci = new MB13102();
			readInt();								// ClientType
			readString();							// Version
			ci.setId(readInt());					// CustomerId
			ci.setLogin_name(readString());			// LoginName
			ci.setLogin_pwd(readString());			// LoginPwd
			ci.setTrade_pwd(readString());			// TradePwd
			readString();							// LastLoginTime
			readString();							// LastLoginIp
			ci.setUser_id(readInt());				// ManagerId
			ci.setManager_name(readString());		// ManagerName
			ci.setAgent_id(readInt());				// AgentId
			ci.setAgent_name(readString());			// AgentName		
			ci.setGroup_id(readInt());				// CustGroupId
			ci.setGroup_name(readString());			// CustName
			ci.setReal_name(readString());			// RealName
			ci.setProvince(readString());			// Province
			ci.setCity(readString());				// City
			ci.setAddr(readString());				// Address
			long Birthday = readLong();				// Birthday
			ci.setBirthday(Birthday==0? null: new Date(Birthday));
			ci.setZip_code(readString());			// ZipCode
			ci.setPhone(readString());				// Tel
			ci.setMobil(readString());				// Mobile
			ci.setE_mail(readString());				// Email
			ci.setCard_id(readString());			// CardId
			ci.setStatus(readByte());				// Status
			ci.setBg_color(readString());			// BgColor
			ci.setMemo(readString());				// Memo
			ci.setLeverage(readInt());				// Leverage
			ci.setTax_percent(readFloatD());		// TaxPercent
			ci.setAgent_accnt(readString());		// AgentAccnt
			ci.setChange_pwd(readBoolean());		// ChangePwd
			ci.setReadable(readBoolean());			// IsTrade
			long createOn = readLong();				// CreatedOn
			ci.setCreate_on(createOn==0? null: new Date(createOn));
			tempLists.add(ci);
		}
		
		if(tempLists.size()==1){
			custInfo = tempLists.get(0);
		}else{
			
		}
	}

	public MB13102() {
		super();
	}

	@Override
	protected void writeCommandBody() {
	}

	public int getCommandCode() {
		return PidConst.P13102;
	}
private int id;
	
	/**
	 * 登陆名(ID)
	 */
	private String login_name;
	/**
	 * 登录密码（md5）
	 */
	private String login_pwd;
	/**
	 * 交易密码
	 */
	private String trade_pwd;
	
	/**
	 * 杠杆
	 */
	private int leverage;
	
	/**
	 * 业务员(经理人)ID
	 */
	private int user_id;
	
	/**
	 * 业务员(经理人)名称
	 */
	private String manager_name;
	/**
	 * 代理商ID
	 */
	private int agent_id;
	/**
	 * 代理商名称
	 */
	private String agent_name;
	/**
	 * 客户组ID
	 */
	private int group_id;
	/**
	 * 客户组名称
	 */
	private String group_name;
	/**
	 * 真实姓名
	 */
	private String real_name;
	/**
	 * 身份证号
	 */
	private String card_id;
	/**
	 * 省
	 */
	private String province;
	/**
	 * 市
	 */
	private String city;
	/**
	 * 地址
	 */
	private String addr;
	/**
	 * 邮编
	 */
	private String zip_code;
	/**
	 * 电话
	 */
	private String phone;
	/**
	 * 手机
	 */
	private String mobil;
	/**
	 * 邮箱
	 */
	private String e_mail;

	/**
	 * 出生年月
	 */
	private Date birthday;
	/**
	 * 状态
	 */
	private int status;
	/**
	 * 背景颜色
	 */
	private String bg_color;
	/**
	 * 注释
	 */
	private String memo;
	/**
	 * 税率
	 */
	private double tax_percent;
	/**
	 * 代理账号
	 */
	private String agent_accnt;
	/**
	 * 是否可以更改密码
	 */
	private boolean change_pwd;
	/**
	 * 是否只读帐户
	 */
	private boolean readable;
	/**
	 * 开户时间
	 */
	private Date create_on;
	
	private int languageInfo;
	
	private boolean loginOk;
	public MB13102 getCustInfo() {
		return custInfo;
	}

	public void setCustInfo(MB13102 custInfo) {
		this.custInfo = custInfo;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getLogin_name() {
		return login_name;
	}

	public void setLogin_name(String loginName) {
		login_name = loginName;
	}

	public String getLogin_pwd() {
		return login_pwd;
	}

	public void setLogin_pwd(String loginPwd) {
		login_pwd = loginPwd;
	}

	public String getTrade_pwd() {
		return trade_pwd;
	}

	public void setTrade_pwd(String tradePwd) {
		trade_pwd = tradePwd;
	}

	public int getLeverage() {
		return leverage;
	}

	public void setLeverage(int leverage) {
		this.leverage = leverage;
	}

	public int getUser_id() {
		return user_id;
	}

	public void setUser_id(int userId) {
		user_id = userId;
	}

	public String getManager_name() {
		return manager_name;
	}

	public void setManager_name(String managerName) {
		manager_name = managerName;
	}

	public int getAgent_id() {
		return agent_id;
	}

	public void setAgent_id(int agentId) {
		agent_id = agentId;
	}

	public String getAgent_name() {
		return agent_name;
	}

	public void setAgent_name(String agentName) {
		agent_name = agentName;
	}

	public int getGroup_id() {
		return group_id;
	}

	public void setGroup_id(int groupId) {
		group_id = groupId;
	}

	public String getGroup_name() {
		return group_name;
	}

	public void setGroup_name(String groupName) {
		group_name = groupName;
	}

	public String getReal_name() {
		return real_name;
	}

	public void setReal_name(String realName) {
		real_name = realName;
	}

	public String getCard_id() {
		return card_id;
	}

	public void setCard_id(String cardId) {
		card_id = cardId;
	}

	public String getProvince() {
		return province;
	}

	public void setProvince(String province) {
		this.province = province;
	}

	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	public String getAddr() {
		return addr;
	}

	public void setAddr(String addr) {
		this.addr = addr;
	}

	public String getZip_code() {
		return zip_code;
	}

	public void setZip_code(String zipCode) {
		zip_code = zipCode;
	}

	public String getPhone() {
		return phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	public String getMobil() {
		return mobil;
	}

	public void setMobil(String mobil) {
		this.mobil = mobil;
	}

	public String getE_mail() {
		return e_mail;
	}

	public void setE_mail(String eMail) {
		e_mail = eMail;
	}

	public Date getBirthday() {
		return birthday;
	}

	public void setBirthday(Date birthday) {
		this.birthday = birthday;
	}

	public int getStatus() {
		return status;
	}

	public void setStatus(int status) {
		this.status = status;
	}

	public String getBg_color() {
		return bg_color;
	}

	public void setBg_color(String bgColor) {
		bg_color = bgColor;
	}

	public String getMemo() {
		return memo;
	}

	public void setMemo(String memo) {
		this.memo = memo;
	}

	public double getTax_percent() {
		return tax_percent;
	}

	public void setTax_percent(double taxPercent) {
		tax_percent = taxPercent;
	}

	public String getAgent_accnt() {
		return agent_accnt;
	}

	public void setAgent_accnt(String agentAccnt) {
		agent_accnt = agentAccnt;
	}

	public boolean isChange_pwd() {
		return change_pwd;
	}

	public void setChange_pwd(boolean changePwd) {
		change_pwd = changePwd;
	}

	public boolean isReadable() {
		return readable;
	}

	public void setReadable(boolean readable) {
		this.readable = readable;
	}

	public Date getCreate_on() {
		return create_on;
	}

	public void setCreate_on(Date createOn) {
		create_on = createOn;
	}

	public int getLanguageInfo() {
		return languageInfo;
	}

	public void setLanguageInfo(int languageInfo) {
		this.languageInfo = languageInfo;
	}

	public boolean isLoginOk() {
		return loginOk;
	}

	public void setLoginOk(boolean loginOk) {
		this.loginOk = loginOk;
	}

	@Override
	public String toString() {
		return "MB13102 [custInfo=" + custInfo + ", id=" + id + ", login_name=" + login_name + ", login_pwd="
				+ login_pwd + ", trade_pwd=" + trade_pwd + ", leverage=" + leverage + ", user_id=" + user_id
				+ ", manager_name=" + manager_name + ", agent_id=" + agent_id + ", agent_name=" + agent_name
				+ ", group_id=" + group_id + ", group_name=" + group_name + ", real_name=" + real_name + ", card_id="
				+ card_id + ", province=" + province + ", city=" + city + ", addr=" + addr + ", zip_code=" + zip_code
				+ ", phone=" + phone + ", mobil=" + mobil + ", e_mail=" + e_mail + ", birthday=" + birthday
				+ ", status=" + status + ", bg_color=" + bg_color + ", memo=" + memo + ", tax_percent=" + tax_percent
				+ ", agent_accnt=" + agent_accnt + ", change_pwd=" + change_pwd + ", readable=" + readable
				+ ", create_on=" + create_on + ", languageInfo=" + languageInfo + ", loginOk=" + loginOk + "]";
	}
	
}
