/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.ArrayList;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 系统银行账户查询应答
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB13352 extends BaseWebTraderField{
	
	List<MB13352> sysAccnts = new ArrayList<MB13352>();
	
	@Override
	protected void readCommandBody() {
		int size = readShort();
		for (int i = 0; i < size; i++) {
			MB13352 sysAccnt = new MB13352();
			sysAccnt.setId(readInt());
			sysAccnt.setBank_name(readString());
			sysAccnt.setAccnt_no(readString());
			sysAccnt.setAccnt_name(readString());
			sysAccnt.setActive_flag(readBoolean());
			if(sysAccnt.isActive_flag())
				sysAccnts.add(sysAccnt);
		}
	}

	@Override
	protected void writeCommandBody() {}

	@Override
	public int getCommandCode() {
		return PidConst.P13352;
	}

	int id;
	
	/**
	 * 开户银行名称
	 */
	private String bank_name;

	/**
	 * 账号
	 */
	private String accnt_no;

	/**
	 * 帐户名
	 */
	private String accnt_name;

	/**
	 * 是否有效
	 */
	private boolean active_flag;

	public List<MB13352> getSysAccnts() {
		return sysAccnts;
	}

	public void setSysAccnts(List<MB13352> sysAccnts) {
		this.sysAccnts = sysAccnts;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getBank_name() {
		return bank_name;
	}

	public void setBank_name(String bankName) {
		bank_name = bankName;
	}

	public String getAccnt_no() {
		return accnt_no;
	}

	public void setAccnt_no(String accntNo) {
		accnt_no = accntNo;
	}

	public String getAccnt_name() {
		return accnt_name;
	}

	public void setAccnt_name(String accntName) {
		accnt_name = accntName;
	}

	public boolean isActive_flag() {
		return active_flag;
	}

	public void setActive_flag(boolean activeFlag) {
		active_flag = activeFlag;
	}
}
