/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.bean.QueryTimeType;
import com.lmsoft.cornu.webtrade.sdk.message.bean.QueryType;

/**
 * 交易单查询请求
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB13361 extends BaseWebTraderField{
	
	public static int TYPE_OF_ORDER_TYPE = 1;
	/**
	 * 全部
	 */
	public static int ORDER_TYPE_ALL = 0;
	/**
	 * 持单
	 */
	public static int ORDER_TYPE_HOLDING = 1;
	/**
	 * 挂单
	 */
	public static int ORDER_TYPE_PENDING = 2;
	/**
	 * 平单
	 */
	public static int ORDER_TYPE_CLOSED = 3;
	/**
	 * 出入金
	 */
	public static int ORDER_TYPE_BALANCE = 4;
	/**
	 * 信用额度，常量名应该为 ORDER_TYPE_CREDIT
	 */
	public static int ORDER_TYPE_CREATE = 5;
	/**
	 * 调整金
	 */
	public static int ORDER_TYPE_ADJUST = 6;
	/**
	 * 全部，开仓和平仓
	 */
	public static int TIME_TYPE_ALL = 1;
	/**
	 * 开仓
	 */
	public static int TIME_TYPE_OPEN = 2;
	/**
	 * 平仓
	 */
	public static int TIME_TYPE_CLOSE = 3;
	
	
	int custId;
	/**
	 * type: 1:单子类型
	 * String:  1:持单 2:挂单 3:平单 4:出入金
	 */
	List<QueryType> queryTypes;
	/**
	 * type: 1全部 2开仓 3平仓
	 */
	QueryTimeType queryTimeType;
	@Override
	protected void readCommandBody() {
		
	}

	@Override
	protected void writeCommandBody() {
		writeInt(custId);
		
		writeShort((short)queryTypes.size());		//查询条件数量1
		for(int i=0; i<queryTypes.size(); i++){
			writeQueryType(queryTypes.get(i));
		}
		writeQueryTimeType(queryTimeType);
	}

	public int getCommandCode() {
		return PidConst.P13361;
	}

	public MB13361(int custId, List<QueryType> queryTypes, QueryTimeType queryTimeType) {
		super();
		this.custId = custId;
		this.queryTypes = queryTypes;
		this.queryTimeType = queryTimeType;
	}
}
