/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.ArrayList;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.bean.TradeSymbolOpts;

/**
 * 商品交易控制查询应答
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB13452 extends BaseWebTraderField{
	/**
	 * 商品交易控制段 列表
	 */
	private List<TradeSymbolOpts> allTradeSymbolOpts = new ArrayList<TradeSymbolOpts>();

	
	@Override
	protected void readCommandBody() {
		int size = readShort();
		
		for(int i=0; i<size; i++){
			TradeSymbolOpts opts = new TradeSymbolOpts();
			opts.setSymbol_id(readInt());
			opts.setBuy_open_order(readBoolean());
			opts.setSell_open_order(readBoolean());
			opts.setBuy_pending_order(readBoolean());
			opts.setSell_pending_order(readBoolean());
			opts.setBuy_close_order(readBoolean());
			opts.setSell_close_order(readBoolean());
			opts.setBuy_delivery(readBoolean());
			opts.setSell_delivery(readBoolean());
			opts.setBuy_extension(readBoolean());
			opts.setSell_extension(readBoolean());
			opts.setBuy_modify_order(readBoolean());
			opts.setSell_modify_order(readBoolean());
			opts.setBuy_modify_pending(readBoolean());
			opts.setSell_modify_pending(readBoolean());
			opts.setBuy_no_order_delivery(readBoolean());
			opts.setSell_no_order_delivery(readBoolean());
			opts.setBuy_cancel_pending(readBoolean());
			opts.setSell_cancel_pending(readBoolean());
			allTradeSymbolOpts.add(opts);
		}
	}

	public List<TradeSymbolOpts> getAllTradeSymbolOpts() {
		return allTradeSymbolOpts;
	}

	@Override
	protected void writeCommandBody() {
		
	}

	@Override
	public int getCommandCode() {
		return PidConst.P13452;
	}
}
