/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.ArrayList;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.MutiPackage;
import com.lmsoft.cornu.webtrade.sdk.message.bean.StockTag;

/**
 * 商品标签查询应答
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB13462 extends BaseWebTraderField implements MutiPackage{
	
	/**
	 * 商品标签列表
	 */
	List<StockTag> stockList = new ArrayList<StockTag>();
	
	@Override
	protected void readCommandBody() {
		int size = readShort();
		for (int i = 0; i < size; i++) {
			StockTag stockTag = new StockTag(readByte(),readInt(),readInt(),readString(),readString(),readString(),readInt());
			stockList.add(stockTag);
		}
	}

	@Override
	protected void writeCommandBody() {}

	@Override
	public int getCommandCode() {
		return PidConst.P13462;
	}

	public List<StockTag> getStockList() {
		return stockList;
	}

	@Override
	public BaseWebTraderField packageing(List<BaseWebTraderField> packages) {
		MB13462 rt = new MB13462();
		for (BaseWebTraderField baseWebTraderField : packages) {
			MB13462 temp = (MB13462)baseWebTraderField;
			rt.stockList.addAll(temp.getStockList());
		}
		return rt;
	}
}
