/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.bean.QueryType;

/**
 * @since 3.3
 * 客户客户组商品查询请求(新)
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB13471 extends BaseWebTraderField{
	public static int TYPE_OF_SYMBOL_ID = 1;
	public static int TYPE_OF_CUST_ID = 2;
	public static int TYPE_OF_CUST_GROUP_ID = 3;
	public static int TYPE_OF_CUST_GROUP_SYMBOL_ID = 4;
	public static int TYPE_OF_CNGOLDID = 5;
	
	/**
	 * type: 
	 * <ul><li> 1:根据商品ID查询,可传多个中间以字符串隔开
	 * <li> 2:根据客户ID查询
	 * <li> 3:根据客户组ID查询  
	 * <li> 4:根据客户组商品ID查询
	 * <li> 5:根据CngoldId查询
	 * </ul>
	 * String:  查询类型为1时 为商品ID字符串  其他均传对应ID
	 */
	List<QueryType> queryTypes;
	@Override
	protected void readCommandBody() {
		
	}

	@Override
	protected void writeCommandBody() {
		writeShort((short)queryTypes.size());		//查询条件数量1
		for(int i=0; i<queryTypes.size(); i++){
			writeQueryType(queryTypes.get(i));
		}
	}

	public int getCommandCode() {
		return PidConst.P13471;
	}

	public MB13471() {
		super();
	}

	public MB13471(List<QueryType> queryTypes) {
		super();
		this.queryTypes = queryTypes;
	}

	public List<QueryType> getQueryTypes() {
		return queryTypes;
	}

	public void setQueryTypes(List<QueryType> queryTypes) {
		this.queryTypes = queryTypes;
	}
}
