package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.ArrayList;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.bean.HoldingOrderStatisticsResult;
/**
 * 持仓汇总查询应答
 * @author JerryZ 
 * 2009-7-10 下午05:50:51
 * @since skyfall v1.0
 */
public class MB13502 extends BaseWebTraderField {

	List<HoldingOrderStatisticsResult> list;
	int accntId;
	
	
	@Override
	protected void readCommandBody() {
		accntId = readInt();
		int size = readShort();
		for (int i = 0; i < size; i++) {
			HoldingOrderStatisticsResult iterable_element = new HoldingOrderStatisticsResult();
			
			iterable_element.setSymbolId(readInt());
			
			iterable_element.setBuyHodingAmount(readFloatD());
			iterable_element.setBuyHodingFrozen(readFloatD());
			iterable_element.setBuyOpenAvgPrice(readFloatD());
			
			iterable_element.setSellHodingAmount(readFloatD());
			iterable_element.setSellHodingFrozen(readFloatD());
			iterable_element.setSellOpenAvgPrice(readFloatD());
			if(list == null)
				list = new ArrayList<HoldingOrderStatisticsResult>();
			list.add(iterable_element);
		}
	}

	public List<HoldingOrderStatisticsResult> getList() {
		return list;
	}

	public int getAccntId() {
		return accntId;
	}

	@Override
	protected void writeCommandBody() {
		
	}
	
	@Override
	public int getCommandCode() {
		return PidConst.P13502;
	}

}
