/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 商品详情查询(应答)
 * @since skyfall v2.0
 * @author Jerry zhang
 *
 */
public class MB13512 extends BaseWebTraderField {

	Map<Integer, MB13032> tradeSymbols = new HashMap<Integer, MB13032>();
	@Override
	protected void readCommandBody() {
		int size = readShort();
		for (int i = 0; i < size; i++) {
			MB13032 smbl = new MB13032();
			smbl.setId(readInt());
			smbl.setSmbl_name(readString());
			smbl.setTs_code(readString());
			smbl.setCode_id(readInt());
			smbl.setDetails(readString());
			smbl.setMarket_id( readInt());
			
			smbl.setMarket_name(readString());	//市场名称
			smbl.setMarket_type(readInt());		//市场类型
			
			smbl.setTrada_mode(readByte());
			smbl.setProfitloss_curr(readString());
			smbl.setMargin_curr(readString());
			smbl.setPermit(readByte());
			smbl.setBg_color(readString());
			smbl.setSpread(readShort());
			smbl.setSpread_scale(readFloatD());
			smbl.setFliter_level(readFloatD());
			smbl.setAuto_restrict(readFloatD());
			smbl.setFliter_count(readInt());
			smbl.setAbanded_second(readInt());
			smbl.setAlert_time(readInt());
			smbl.setContract_size(readInt());
			smbl.setHang_mode(readInt());
			smbl.setMargin(readFloatD());
			smbl.setLock_margin(readFloatD());
			smbl.setFrozen_margin(readFloatD());
			smbl.setHigh_order_spread_value(readFloatD());
			smbl.setHigh_order_spread_type(readByte());
			smbl.setLower_order_spread_value(readFloatD());
			smbl.setLower_order_spread_type(readByte());
			smbl.setHigh_loss_spread_value(readFloatD());
			smbl.setHigh_loss_spread_type(readByte());
			smbl.setLower_loss_spread_value(readFloatD());
			smbl.setLower_loss_spread_type(readByte());
			smbl.setHigh_profit_spread_value(readFloatD());
			smbl.setHigh_profit_spread_type(readByte());
			smbl.setLower_profit_spread_value(readFloatD());
			smbl.setLower_profit_spread_type(readByte());
			smbl.setCal_intst_mode(readShort());
			smbl.setCal_charge_mode(readShort());
			smbl.setBuy_cease_diff(readFloatD());
			smbl.setSail_cease_diff(readFloatD());
			smbl.setFund_charge(readFloatD());
			smbl.setClose_charge(readFloatD());
			smbl.setThree_interest(readInt());
			long beginTime = readLong();
			smbl.setBegin_time(beginTime==0 ? null : new Date(beginTime)); 
			long endTime = readLong();
			smbl.setEnd_time(endTime==0 ? null : new Date(endTime));
			smbl.setSort_index(readInt());
			smbl.setCal_formula(readString()); //计算公式
			smbl.setMemo(readString()); //comment 备注
			smbl.setBalance_time(readString());
			smbl.setDec_point(readInt());
			smbl.setTime_effective_cycle(readInt());
			smbl.setExtension_type(readInt());
			smbl.setDelivery_charge(readFloatD());
			smbl.setExtension_charge(readFloatD());
			smbl.setMem_quo_protected(readBoolean());
			
			smbl.setCalc_profit_point(readInt());
			smbl.setCalc_point_rate(readFloatD());
			
			smbl.setMini_size(readDouble());
			smbl.setDeposit_scale(readDouble());
			smbl.setBail_gram(readDouble());
			smbl.setContract_gram(readInt());
			smbl.setMin_lots(readDouble());
			tradeSymbols.put(smbl.getId(), smbl);
		}
	}

	@Override
	protected void writeCommandBody() {
		
	}

	@Override
	public int getCommandCode() {
		return PidConst.P13512;
	}
	
	public Map<Integer, MB13032> getTradeSymbols() {
		return tradeSymbols;
	}

}
