/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.HashMap;
import java.util.Map;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 客户组详情查询(应答)
 * @since skyfall v2.0
 * @author Jerry Zhang
 *
 */
public class MB13522 extends BaseWebTraderField {
	Map<Integer, MB13522> tradeSymbols = new HashMap<Integer, MB13522>();

	@Override
	protected void readCommandBody() {
		int size = readShort();
		for (int i = 0; i < size; i++) {
			MB13522 group=new MB13522();
			group.setId(readInt());
			group.setActive_flag(readBoolean());
			group.setGroup_name(readString());
			group.setAdvanced_safe(readBoolean());
			group.setComp_name(readString());
			group.setCurr_code(readString());
			group.setInitial_money(readFloatD());
			group.setReal_percentage(readFloatD());
			group.setInterest_rate(readFloatD());
			group.setWait_time(readInt());
			group.setNews_mode(readInt());
			group.setSmbl_number(readInt());
			group.setMax_trade(readInt());
			group.setMail_flag(readBoolean());
			group.setProfetional_flag(readBoolean());
			group.setInterest_flag(readBoolean());
			group.setHang_flag(readBoolean());
			group.setTrackloss_flag(readBoolean());
			group.setOrder_valid_flag(readBoolean());
			group.setAccnt_frozen(readInt());
			group.setMax_balance(readInt());
			group.setMinus_can_lock(readBoolean());
			group.setAlert_threshold(readFloatD());
			group.setForce_threshold(readFloatD());
			group.setForce_mode(readByte());
			group.setIdletick_mode(readByte());
			group.setCredit_line(readFloatD());
			group.setIgnore_lockaccnt(readBoolean());
			group.setFinancial_flag(readBoolean());
			group.setSmtp_addr(readString());
			group.setFb_ctl(readString());
			group.setLogin_accnt(readString());
			group.setLogin_pwd(readString());
			group.setSupport_mail(readString());
			group.setCopy_mailto_mailbox(readBoolean());
			group.setMemo(readString());
			short x = readShort();
			group.setExtend1(x + "");
			group.setIs_open_seft_reg(readBoolean());
			group.setExpired_handle_type(readByte());
			
			group.setCalc_point_flag(readBoolean());
			group.setCust_reset_permit_flag(readBoolean());
			
			tradeSymbols.put(group.getId(), group);
		}
	}
	@Override
	protected void writeCommandBody() {
		
	}
	@Override
	public int getCommandCode() {
		return PidConst.P13522;
	}
	///////////////////////////////////////////////////////////////
	private int id;
	/**
	 * 是否有效
	 */
	private boolean active_flag;
	/**
	 * 名称
	 */
	private String group_name;
	/**
	 * 是否RSA加密
	 */
	private boolean advanced_safe;
	/**
	 * 公司名称
	 */
	private String comp_name;
	/**
	 * 入金货币
	 */
	private String curr_code;
	/**
	 * 默认入金（针对外汇）
	 */
	private double initial_money;

	/**
	 * 实收比例
	 */
	private double real_percentage;

	/**
	 * 利率
	 */
	private double interest_rate;
	/**
	 * 询价等待确认时间（7秒)
	 */
	private int wait_time;
	/**
	 * 新闻显示模式
	 */
	private int news_mode;
	/**
	 * 商品数量
	 */
	private int smbl_number;
	/**
	 * 最大交易量（0表示没限制）
	 */
	private int max_trade;
	/**
	 * 邮件标识
	 */
	private boolean mail_flag;
	/**
	 * 专家交易系统标识
	 */
	private boolean profetional_flag;
	/**
	 * 利息标识
	 */
	private boolean interest_flag;
	/**
	 * 挂单到期日标识
	 */
	private boolean hang_flag;
	/**
	 * 跟踪止损标识
	 */
	private boolean trackloss_flag;
	/**
	 * 现价是否到服务器验证标识
	 */
	private boolean order_valid_flag;
	/**
	 * 帐户休眠方式
	 */
	private int accnt_frozen;
	/**
	 * 余额上限
	 */
	private int max_balance;
	/**
	 * 可用保证金为负可以下锁定
	 */
	private boolean minus_can_lock;
	/**
	 * 保证金预警水平
	 */
	private double alert_threshold;
	/**
	 * 强平水平
	 */
	private double force_threshold;
	/**
	 * 强平模式（1，百分比，2，金额（相应货币类型））
	 */
	private int force_mode;
	/**
	 * 空余保证金计算模式（分四种）
	 */
	private int idletick_mode;
	/**
	 * 信用额度
	 */
	private double credit_line;
	/**
	 * 检测强平忽略锁仓用户
	 */
	private boolean ignore_lockaccnt;
	/**
	 * 财务报表是否有效
	 */
	private boolean financial_flag;
	/**
	 * 财务SMTP服务器地址
	 */
	private String smtp_addr;
	/**
	 * 财务模板目录
	 */
	private String fb_ctl;
	/**
	 * 登陆帐号
	 */
	private String login_accnt;
	/**
	 * 登陆密码
	 */
	private String login_pwd;
	/**
	 * 支持邮箱
	 */
	private String support_mail;
	/**
	 * 拷贝报道到邮箱
	 */
	private boolean copy_mailto_mailbox;
	/**
	 * 签名
	 */
	private String memo;

	/**
	 * 客户组是否开放自注册
	 */
	private boolean is_open_seft_reg;
	/**
	 * 客户到期处理方式
	 */
	private int expired_handle_type;
	/**
	 * @since v2.0
	 * 是否启用计点模式
	 */
	private boolean calc_point_flag;
	/**
	 * @since v2.0
	 * 是否开启客户重置
	 */
	private boolean cust_reset_permit_flag;
	
	private String extend1;
	public boolean isActive_flag() {
		return active_flag;
	}

	public void setActive_flag(boolean active_flag) {
		this.active_flag = active_flag;
	}

	public String getGroup_name() {
		return group_name;
	}

	public void setGroup_name(String group_name) {
		this.group_name = group_name;
	}

	public boolean isAdvanced_safe() {
		return advanced_safe;
	}

	public void setAdvanced_safe(boolean advanced_safe) {
		this.advanced_safe = advanced_safe;
	}

	public String getComp_name() {
		return comp_name;
	}

	public void setComp_name(String comp_name) {
		this.comp_name = comp_name;
	}

	public String getCurr_code() {
		return curr_code;
	}

	public void setCurr_code(String curr_code) {
		this.curr_code = curr_code;
	}

	public double getInitial_money() {
		return initial_money;
	}

	public void setInitial_money(double initial_money) {
		this.initial_money = initial_money;
	}

	public double getReal_percentage() {
		return real_percentage;
	}

	public void setReal_percentage(double real_percentage) {
		this.real_percentage = real_percentage;
	}

	public double getInterest_rate() {
		return interest_rate;
	}

	public void setInterest_rate(double interest_rate) {
		this.interest_rate = interest_rate;
	}

	public int getWait_time() {
		return wait_time;
	}

	public void setWait_time(int wait_time) {
		this.wait_time = wait_time;
	}

	public int getNews_mode() {
		return news_mode;
	}

	public void setNews_mode(int news_mode) {
		this.news_mode = news_mode;
	}

	public int getSmbl_number() {
		return smbl_number;
	}

	public void setSmbl_number(int smbl_number) {
		this.smbl_number = smbl_number;
	}

	public int getMax_trade() {
		return max_trade;
	}

	public void setMax_trade(int max_trade) {
		this.max_trade = max_trade;
	}

	public boolean isMail_flag() {
		return mail_flag;
	}

	public void setMail_flag(boolean mail_flag) {
		this.mail_flag = mail_flag;
	}

	public boolean isProfetional_flag() {
		return profetional_flag;
	}

	public void setProfetional_flag(boolean profetional_flag) {
		this.profetional_flag = profetional_flag;
	}

	public boolean isInterest_flag() {
		return interest_flag;
	}

	public void setInterest_flag(boolean interest_flag) {
		this.interest_flag = interest_flag;
	}

	public boolean isHang_flag() {
		return hang_flag;
	}

	public void setHang_flag(boolean hang_flag) {
		this.hang_flag = hang_flag;
	}

	public boolean isTrackloss_flag() {
		return trackloss_flag;
	}

	public void setTrackloss_flag(boolean trackloss_flag) {
		this.trackloss_flag = trackloss_flag;
	}

	public boolean isOrder_valid_flag() {
		return order_valid_flag;
	}

	public void setOrder_valid_flag(boolean order_valid_flag) {
		this.order_valid_flag = order_valid_flag;
	}

	public int getAccnt_frozen() {
		return accnt_frozen;
	}

	public void setAccnt_frozen(int accnt_frozen) {
		this.accnt_frozen = accnt_frozen;
	}

	public int getMax_balance() {
		return max_balance;
	}

	public void setMax_balance(int max_balance) {
		this.max_balance = max_balance;
	}

	public boolean isMinus_can_lock() {
		return minus_can_lock;
	}

	public void setMinus_can_lock(boolean minus_can_lock) {
		this.minus_can_lock = minus_can_lock;
	}

	public double getAlert_threshold() {
		return alert_threshold;
	}

	public void setAlert_threshold(double alert_threshold) {
		this.alert_threshold = alert_threshold;
	}

	public double getForce_threshold() {
		return force_threshold;
	}

	public void setForce_threshold(double force_threshold) {
		this.force_threshold = force_threshold;
	}

	public int getForce_mode() {
		return force_mode;
	}

	public void setForce_mode(int force_mode) {
		this.force_mode = force_mode;
	}

	public int getIdletick_mode() {
		return idletick_mode;
	}

	public void setIdletick_mode(int idletick_mode) {
		this.idletick_mode = idletick_mode;
	}

	public double getCredit_line() {
		return credit_line;
	}

	public void setCredit_line(double credit_line) {
		this.credit_line = credit_line;
	}

	public boolean isIgnore_lockaccnt() {
		return ignore_lockaccnt;
	}

	public void setIgnore_lockaccnt(boolean ignore_lockaccnt) {
		this.ignore_lockaccnt = ignore_lockaccnt;
	}

	public boolean isFinancial_flag() {
		return financial_flag;
	}

	public void setFinancial_flag(boolean financial_flag) {
		this.financial_flag = financial_flag;
	}

	public String getSmtp_addr() {
		return smtp_addr;
	}

	public void setSmtp_addr(String smtp_addr) {
		this.smtp_addr = smtp_addr;
	}

	public String getFb_ctl() {
		return fb_ctl;
	}

	public void setFb_ctl(String fb_ctl) {
		this.fb_ctl = fb_ctl;
	}

	public String getLogin_accnt() {
		return login_accnt;
	}

	public void setLogin_accnt(String login_accnt) {
		this.login_accnt = login_accnt;
	}

	public String getLogin_pwd() {
		return login_pwd;
	}

	public void setLogin_pwd(String login_pwd) {
		this.login_pwd = login_pwd;
	}

	public String getSupport_mail() {
		return support_mail;
	}

	public void setSupport_mail(String support_mail) {
		this.support_mail = support_mail;
	}

	public boolean isCopy_mailto_mailbox() {
		return copy_mailto_mailbox;
	}

	public void setCopy_mailto_mailbox(boolean copy_mailto_mailbox) {
		this.copy_mailto_mailbox = copy_mailto_mailbox;
	}

	public String getMemo() {
		return memo;
	}

	public void setMemo(String memo) {
		this.memo = memo;
	}

	public int getExpired_handle_type() {
		return expired_handle_type;
	}

	public void setExpired_handle_type(int expired_handle_type) {
		this.expired_handle_type = expired_handle_type;
	}

	public boolean isIs_open_seft_reg() {
		return is_open_seft_reg;
	}

	public void setIs_open_seft_reg(boolean is_open_seft_reg) {
		this.is_open_seft_reg = is_open_seft_reg;
	}

	public boolean isCalc_point_flag() {
		return calc_point_flag;
	}

	public void setCalc_point_flag(boolean calcPointFlag) {
		calc_point_flag = calcPointFlag;
	}

	public boolean isCust_reset_permit_flag() {
		return cust_reset_permit_flag;
	}

	public void setCust_reset_permit_flag(boolean custResetPermitFlag) {
		cust_reset_permit_flag = custResetPermitFlag;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public String getExtend1() {
		return extend1;
	}
	public void setExtend1(String extend1) {
		this.extend1 = extend1;
	}
	
	public Map<Integer, MB13522> getTradeSymbols() {
		return tradeSymbols;
	}
	public void setTradeSymbols(Map<Integer, MB13522> tradeSymbols) {
		this.tradeSymbols = tradeSymbols;
	}
}
