package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.MutiPackage;

/**
 * 操作明细查询应答
 * 
 * @author juyafeng
 * @date: 2014-3-12 下午06:26:19
 * @since skyfall v2.0
 */
public class MB13532 extends BaseWebTraderField implements MutiPackage {
	List<MB13532> tradeLogList = new ArrayList<MB13532>();
	@Override
	protected void readCommandBody() {
//		tradeLogList = new ArrayList<MB13532>();
		// 写第一个id作为客户端返回的查询起始id
		id = readInt();
		int size = readShort();
		for (int i = 0; i < size; i++) {
			MB13532 trade = new MB13532();
			trade.setId(readInt());
			trade.setSmbl_id(readInt());
			trade.setAccnt_id(readInt());
			trade.setOrder_id(readInt());
			trade.setFundPrice(readFloatD());
			trade.setLots(readFloatD());
			trade.setOperType(readInt());
			trade.setProfit_price(readFloatD());
			trade.setLoss_price(readFloatD());
			long time = readLong();
			trade.setCreateTime(new Date(time));
			trade.setRemark(readString());
			trade.setProfit_loss(readFloatD());
			trade.setCommission(readFloatD());
			trade.setInterest(readFloatD());
			trade.setPassport_user_id(readInt());
			trade.setSkyfall_user_id(readInt());
			tradeLogList.add(trade);
		}
	}

	@Override
	protected void writeCommandBody() {
		
	}

	@Override
	public int getCommandCode() {
		return PidConst.P13532;
	}


	int id;
	/**
	 * 账号ID
	 */
	private Integer accnt_id;
	/**
	 * 商品ID
	 */
	private Integer smbl_id;
	/**
	 * order_Id
	 */
	private Integer order_id;
	/**
	 * 交易数量
	 */
	private double lots;
	/**
	 * 成交价(平仓价或者开仓价)
	 */
	private double fundPrice;
	/**
	 * 开平仓原因(买, 卖, 平的原因)
	 */
	private int operType;
	/**
	 * 止损价(暂时不用, 考虑到以后可能会用)
	 */
	private double profit_price;
	/**
	 * 止盈价(暂时不用, 考虑到以后可能会用)
	 */
	private double loss_price;
	private Date createTime;
	/**
	 * 备注
	 */
	private String remark;
	/**
	 * 盈亏
	 */
	private double profit_loss;
	/**
	 * 手续费
	 */
	private double commission;
	/**
	 * 隔夜费(预留字段)
	 */
	private double interest;
	/**
	 * PassportUserId(用户在Passport唯一的ID标示)
	 * @since 2.9
	 */
	private int passport_user_id;
	
	private int skyfall_user_id;
	
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getAccnt_id() {
		return accnt_id;
	}

	public void setAccnt_id(int accntId) {
		accnt_id = accntId;
	}

	public Integer getSmbl_id() {
		return smbl_id;
	}

	public void setSmbl_id(Integer smblId) {
		smbl_id = smblId;
	}

	public Integer getOrder_id() {
		return order_id;
	}

	public void setOrder_id(Integer orderId) {
		order_id = orderId;
	}

	public double getLots() {
		return lots;
	}

	public void setLots(double lots) {
		this.lots = lots;
	}

	public double getFundPrice() {
		return fundPrice;
	}

	public void setFundPrice(double fundPrice) {
		this.fundPrice = fundPrice;
	}

	public int getOperType() {
		return operType;
	}

	public void setOperType(int operType) {
		this.operType = operType;
	}

	public double getProfit_price() {
		return profit_price;
	}

	public void setProfit_price(double profitPrice) {
		profit_price = profitPrice;
	}

	public double getLoss_price() {
		return loss_price;
	}

	public void setLoss_price(double lossPrice) {
		loss_price = lossPrice;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public void setAccnt_id(Integer accntId) {
		accnt_id = accntId;
	}

	public Date getCreateTime() {
		return createTime;
	}

	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}

	public List<MB13532> getTradeLogList() {
		return tradeLogList;
	}

	public double getProfit_loss() {
		return profit_loss;
	}

	public void setProfit_loss(double profitLoss) {
		profit_loss = profitLoss;
	}

	public double getCommission() {
		return commission;
	}

	public void setCommission(double commission) {
		this.commission = commission;
	}

	public double getInterest() {
		return interest;
	}

	public void setInterest(double interest) {
		this.interest = interest;
	}

	public int getPassport_user_id() {
		return passport_user_id;
	}

	public void setPassport_user_id(int passportUserId) {
		passport_user_id = passportUserId;
	}

	public int getSkyfall_user_id() {
		return skyfall_user_id;
	}

	public void setSkyfall_user_id(int skyfallUserId) {
		skyfall_user_id = skyfallUserId;
	}

	@Override
	public BaseWebTraderField packageing(List<BaseWebTraderField> packages) {
		MB13532 rt = new MB13532();
		for (BaseWebTraderField baseWebTraderField : packages) {
			MB13532 temp = (MB13532)baseWebTraderField;
			rt.tradeLogList.addAll(temp.getTradeLogList());
		}
		return rt;
	}
	
}
