package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.ArrayList;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 客户账户查询应答
 * @author hht 
 *
 */
public class MB13622 extends BaseWebTraderField{
	
	List<MB13312> tradeAccnts = new ArrayList<MB13312>();
	
	int RtnCode;
	
	@Override
	protected void readCommandBody() {
		int size = readShort();
		for (int i = 0; i < size; i++) {
			MB13312 ts = new MB13312();
			ts.setId(readInt());
			ts.setBalance(readDouble());
			ts.setCurr_code(readString());
			ts.setBank_name(readString());
			ts.setAccnt_name(readString());
			ts.setAccnt_no(readString());
			ts.setCredit(readDouble());
			ts.setMargin(readDouble());
			ts.setFrozen_margin(readDouble());
			ts.setWithdraw_cash(readDouble());
			tradeAccnts.add(ts);
		}
		prefitLoss = readDouble();
	}

	public MB13622() {
		super();
	}

	@Override
	protected void writeCommandBody() {}

	@Override
	public int getCommandCode() {
		return PidConst.P13622;
	}
	int id;
	/**
	 * 货币代码
	 */
	private String curr_code;
	/**
	 * 开户银行
	 */
	private String bank_name;
	/**
	 * 帐号名称
	 */
	private String accnt_name;
	/**
	 * 银行帐户
	 */
	private String accnt_no;
	/**
	 * 余额
	 */
	private double balance;
	/**
	 * 占用保证金
	 */
	private double margin;
	/**
	 * 冻结保证金
	 */
	private double frozen_margin;
	/**
	 * 信用额度
	 */
	private double credit;
	/**
	 * 净值
	 */
	private double netValue;
	/**
	 * 可用保证金
	 */
	private double couldUseMargin;
	/**
	 * 浮动盈亏
	 */
	private double prefitLoss;

	public List<MB13312> getTradeAccnts() {
		return tradeAccnts;
	}

	public void setTradeAccnts(List<MB13312> tradeAccnts) {
		this.tradeAccnts = tradeAccnts;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getCurr_code() {
		return curr_code;
	}

	public void setCurr_code(String currCode) {
		curr_code = currCode;
	}

	public String getBank_name() {
		return bank_name;
	}

	public void setBank_name(String bankName) {
		bank_name = bankName;
	}

	public String getAccnt_name() {
		return accnt_name;
	}

	public void setAccnt_name(String accntName) {
		accnt_name = accntName;
	}

	public String getAccnt_no() {
		return accnt_no;
	}

	public void setAccnt_no(String accntNo) {
		accnt_no = accntNo;
	}

	public double getBalance() {
		return balance;
	}

	public void setBalance(double balance) {
		this.balance = balance;
	}

	public double getMargin() {
		return margin;
	}

	public void setMargin(double margin) {
		this.margin = margin;
	}

	public double getFrozen_margin() {
		return frozen_margin;
	}

	public void setFrozen_margin(double frozenMargin) {
		frozen_margin = frozenMargin;
	}

	public double getCredit() {
		return credit;
	}

	public void setCredit(double credit) {
		this.credit = credit;
	}

	public double getNetValue() {
		return netValue;
	}

	public void setNetValue(double netValue) {
		this.netValue = netValue;
	}

	public double getCouldUseMargin() {
		return couldUseMargin;
	}

	public void setCouldUseMargin(double couldUseMargin) {
		this.couldUseMargin = couldUseMargin;
	}

	public double getPrefitLoss() {
		return prefitLoss;
	}

	public void setPrefitLoss(double prefitLoss) {
		this.prefitLoss = prefitLoss;
	}

	public int getRtnCode() {
		return RtnCode;
	}

	public void setRtnCode(int rtnCode) {
		this.RtnCode = rtnCode;
	}
}
