package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.bean.TradeOrders;

/**
 * 挂单查询应答
 * */
public class MB13632 extends BaseWebTraderField{

	int rtnCode;
	
	int size;
	
	List<TradeOrders> list;
	
	@Override
	public int getCommandCode() {
		return PidConst.P13632;
	}

	@Override
	protected void readCommandBody() {
		list = new ArrayList<TradeOrders>();
		rtnCode = readInt();
		size = readInt();
		for(int i=0;i<size;i++){
			TradeOrders to = new TradeOrders();
			to.setLots(readDouble());
			to.setOpen_time(new Date(readLong()));
			to.setOpen_prc(readDouble());
			to.setClose_prc(readDouble());
			to.setOrder_type(readInt());
			to.setOrder_status(readInt());
			to.setId(readInt());
			to.setProfit_prc(readDouble());
			to.setLoss_prc(readDouble());
			to.setProfit_loss(readDouble());
			to.setDraft_prc(readDouble());
			to.setMemo(readString());
			to.setVoucher_order(readBoolean());
			to.setSmbl_id(readInt());
			list.add(to);
		}
	}

	@Override
	protected void writeCommandBody() {
		
	}

	public int getRtnCode() {
		return rtnCode;
	}

	public void setRtnCode(int rtnCode) {
		this.rtnCode = rtnCode;
	}

	public List<TradeOrders> getList() {
		return list;
	}

	public void setList(List<TradeOrders> list) {
		this.list = list;
	}

}
