/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * @since 3.3
 * 客户账单查询(请求).xml
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB17031 extends BaseWebTraderField{
	/**
	 * 代理商ID
	 */
	int agentId ;
	/**
	 * 用户ID
	 */
	int userId;
	/**
	 * 客户ID
	 */
	int custId;
	/**
	 * 开始时间
	 */
	long beginTime;
	/**
	 * 结束时间
	 */
	long endTime;
	/**
	 * 商品ID
	 */
	int symbolId;
	/**
	 * 查询视野，必须选择，1:代理商，2：用户，3：客户 
	 */
	byte queryView;
	/**
	 * 深度查询，true深度查询，false查询本身的资源
	 */
	boolean deepQuery;
	/**
	 * 客户状态， 0所有,1:正常,2:删除,3:锁定,4:冻结
	 */
	byte custStatus;
	/**
	 * 货币单位，空为所有
	 */
	String currency;
	
	
	@Override
	protected void readCommandBody() {
		
	}

	@Override
	protected void writeCommandBody() {
		writeInt(agentId);
		writeInt(userId);
		writeInt(custId);
		writeLong(beginTime);
		writeLong(endTime);
		writeInt(symbolId);
		writeByte(queryView);
		writeBoolean(deepQuery);
		writeByte(custStatus);
		writeString(currency);
	}

	public int getCommandCode() {
		return PidConst.P17031;
	}

	public int getAgentId() {
		return agentId;
	}

	public void setAgentId(int agentId) {
		this.agentId = agentId;
	}

	public int getUserId() {
		return userId;
	}

	public void setUserId(int userId) {
		this.userId = userId;
	}

	public int getCustId() {
		return custId;
	}

	public void setCustId(int custId) {
		this.custId = custId;
	}

	public long getBeginTime() {
		return beginTime;
	}

	public void setBeginTime(long beginTime) {
		this.beginTime = beginTime;
	}

	public long getEndTime() {
		return endTime;
	}

	public void setEndTime(long endTime) {
		this.endTime = endTime;
	}

	public int getSymbolId() {
		return symbolId;
	}

	public void setSymbolId(int symbolId) {
		this.symbolId = symbolId;
	}

	public byte getQueryView() {
		return queryView;
	}

	public void setQueryView(byte queryView) {
		this.queryView = queryView;
	}

	public boolean isDeepQuery() {
		return deepQuery;
	}

	public void setDeepQuery(boolean deepQuery) {
		this.deepQuery = deepQuery;
	}

	public byte getCustStatus() {
		return custStatus;
	}

	public void setCustStatus(byte custStatus) {
		this.custStatus = custStatus;
	}

	public String getCurrency() {
		return currency;
	}

	public void setCurrency(String currency) {
		this.currency = currency;
	}

	public MB17031(int agentId, int userId, int custId, long beginTime,
			long endTime, int symbolId, byte queryView, boolean deepQuery,
			byte custStatus, String currency) {
		super();
		this.agentId = agentId;
		this.userId = userId;
		this.custId = custId;
		this.beginTime = beginTime;
		this.endTime = endTime;
		this.symbolId = symbolId;
		this.queryView = queryView;
		this.deepQuery = deepQuery;
		this.custStatus = custStatus;
		this.currency = currency;
	}
}
