/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;


import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.bean.CustBill;
import com.lmsoft.cornu.webtrade.sdk.message.bean.CustBillClosing;
import com.lmsoft.cornu.webtrade.sdk.message.bean.CustBillHolding;
import com.lmsoft.cornu.webtrade.sdk.message.bean.CustBillPrice;

/**
 * @since 3.3
 * 客户账单查询(应答)
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB17172 extends BaseWebTraderField{
	/**
	 * 结算时间
	 */
	private long billDate;
	private List<CustBill> bills;
	
	
	@Override
	protected void readCommandBody() {

		billDate = readLong();
		int size = readShort();
		if(size != 0)
			bills = new ArrayList<CustBill>();
		
		for(int i=0; i<size; i++){
			CustBill bill = new CustBill();
			// 基本部分
			bill.setBillDate(billDate);
			bill.setAgentId(readInt());
			bill.setAgentName(readString());
			bill.setUserId(readInt());
			bill.setUserName(readString());
			bill.setUserLoginName(readString());
			bill.setCustId(readInt());
			bill.setCustName(readString());
			bill.setCustLoginName(readString());
			bill.setAccntId(readInt());
			bill.setCurrency(readString());
			
			// custBill特有部分
			bill.setAddress(readString());
			bill.setLastBalance(readFloatD());
			bill.setIoMoney(readFloatD());
			bill.setProfitLoss(readFloatD());
			bill.setOverNight(readFloatD());
			bill.setCharge(readFloatD());
			bill.setDraftProfitLoss(readFloatD());
			bill.setClearFund(readFloatD());
			bill.setOrderFund(readFloatD());
			bill.setAvaFund(readFloatD());
			bill.setAdjust_money(readFloatD());
			bill.setCredit(readFloatD());
			bill.setTodayLots(readFloatD());
			bill.setMonthLots(readFloatD());
			
			int sizeOfHolding = readShort();
			List<CustBillHolding> holdings = null;
			if(sizeOfHolding != 0)
				holdings = new ArrayList<CustBillHolding>();
			for(int j=0; j<sizeOfHolding; j++){
				CustBillHolding holding = new CustBillHolding();
				holding.setId(readInt());
				holding.setLots(readFloatD());
				holding.setSymbolId(readInt());

				holding.setTsCode(readString());
				holding.setSymbolName(readString());
				holding.setOpenTime(new Date(readLong()));
				holding.setBuy(readString());
				holding.setSale(readString());
				holding.setOpenPrice(readFloatD());
				holding.setClosePrice(readFloatD());
				holding.setCharge(readFloatD());
				holding.setOverNight(readFloatD());
				holding.setDraftProfitLoss(readFloatD());
				holdings.add(holding);
			}
			bill.setHoldings(holdings);
			
			
			
			int sizeOfPrice = readShort();
			List<CustBillPrice> prices = null;
			if(sizeOfPrice != 0)
				prices = new ArrayList<CustBillPrice>();
			for(int j=0; j<sizeOfPrice; j++){
				CustBillPrice price = new CustBillPrice();
				price.setTsCode(readString());
				price.setSymbolName(readString());
				price.setPrice(readFloatD());
				prices.add(price);
			}
			bill.setPrices(prices);
			
			
			int sizeOfClosing = readShort();
			List<CustBillClosing> closings = null;
			if(sizeOfClosing != 0)
				closings = new ArrayList<CustBillClosing>();
			for(int j=0; j<sizeOfClosing; j++){
				CustBillClosing closing = new CustBillClosing();
				closing.setId(readInt());
				closing.setLots(readFloatD());
				closing.setSymbolId(readInt());
				closing.setTsCode(readString());
				closing.setSymbolName(readString());
				closing.setOpenTime(new Date(readLong()));
				closing.setOpenPrice(readFloatD());
				closing.setCloseTime(new Date(readLong()));
				closing.setClosePrice(readFloatD());
				closing.setCloseBuyPrice(readFloatD());
				closing.setCloseSalePrice(readFloatD());
				closing.setProfitLoss(readFloatD());
				closing.setCharge(readFloatD());
				closings.add(closing);
			}
			bill.setClosing(closings);
			bills.add(bill);
		}
	}

	@Override
	protected void writeCommandBody() {

	}

	public int getCommandCode() {
		return PidConst.P17172;
	}

	public long getBillDate() {
		return billDate;
	}

	public void setBillDate(long billDate) {
		this.billDate = billDate;
	}

	public List<CustBill> getBills() {
		return bills;
	}

	public void setBills(List<CustBill> bills) {
		this.bills = bills;
	}
}
