/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 市价建单请求
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB20011 extends BaseWebTraderField{
	/**
	 * 请求ID
	 */
	int askId;
	/**
	 * 账户Id
	 */
	int accntId;
	/**
	 * 商品ID
	 */
	int symbolId;
	/**
	 * 数量
	 */
	double lots;
	/**
	 * 止赢价 
	 */
	double profitPrice;
	/**
	 * 止损价
	 */
	double lossPrice;
	/**
	 * 移动止损的点数
	 */
	int draftPoint;
	/**
	 * 设置的最大偏差:滑点
	 */
	double maxWarp;
	/**
	 * 现价
	 */
	double nowPrice;
	/**
	 * 注释
	 */
	String Memo;
	
	@Override
	protected void readCommandBody() {
		
	}

	@Override
	protected void writeCommandBody() {
		writeInt(askId);
		writeInt(accntId);
		writeInt(symbolId);
		writeFloatD(lots);
		writeFloatD(profitPrice);
		writeFloatD(lossPrice);
		writeShort((short)draftPoint);
		writeFloatD(maxWarp);
		writeFloatD(nowPrice);
		writeString(Memo);
		
	}

	public int getCommandCode() {
		return PidConst.P20011;
	}

	public int getAccntId() {
		return accntId;
	}

	public void setAccntId(int accntId) {
		this.accntId = accntId;
	}

	public int getAskId() {
		return askId;
	}

	public void setAskId(int askId) {
		this.askId = askId;
	}

	public int getDraftPoint() {
		return draftPoint;
	}

	public void setDraftPoint(int draftPoint) {
		this.draftPoint = draftPoint;
	}

	public double getLossPrice() {
		return lossPrice;
	}

	public void setLossPrice(double lossPrice) {
		this.lossPrice = lossPrice;
	}

	public double getLots() {
		return lots;
	}

	public void setLots(double lots) {
		this.lots = lots;
	}

	public double getMaxWarp() {
		return maxWarp;
	}

	public void setMaxWarp(double maxWarp) {
		this.maxWarp = maxWarp;
	}

	public String getMemo() {
		return Memo;
	}

	public void setMemo(String memo) {
		Memo = memo;
	}

	public double getNowPrice() {
		return nowPrice;
	}

	public void setNowPrice(double nowPrice) {
		this.nowPrice = nowPrice;
	}

	public double getProfitPrice() {
		return profitPrice;
	}

	public void setProfitPrice(double profitPrice) {
		this.profitPrice = profitPrice;
	}

	public int getSymbolId() {
		return symbolId;
	}

	public void setSymbolId(int symbolId) {
		this.symbolId = symbolId;
	}

	public MB20011(int askId, int accntId, int symbolId, double lots, double profitPrice, double lossPrice, int draftPoint, double maxWarp, double nowPrice, String memo) {
		super();
		this.askId = askId;
		this.accntId = accntId;
		this.symbolId = symbolId;
		this.lots = lots;
		this.profitPrice = profitPrice;
		this.lossPrice = lossPrice;
		this.draftPoint = draftPoint;
		this.maxWarp = maxWarp;
		this.nowPrice = nowPrice;
		Memo = memo;
	}
}
