/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 挂单请求
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB20031 extends BaseWebTraderField{
	/**
	 * 请求ID
	 */
	int askId;
	/**
	 * 账户Id
	 */
	int accntId;
	/**
	 * 商品ID
	 */
	int symbolId;
	/**
	 * 数量
	 */
	double lots;
	/**
	 * 挂单价格
	 */
	double profitPrice;
	/**
	 * 止损价
	 */
	double lossPrice;
	/**
	 * 移动止损的点数
	 */
	int draftPoint;
	/**
	 * 挂单价格
	 */
	double pendingPrice;
	/**
	 * 注释
	 */
	String Memo;
	/**
	 * 挂单时间
	 */
	long pendingTime;
	
	@Override
	protected void readCommandBody() {
		
	}

	@Override
	protected void writeCommandBody() {
		writeInt(askId);
		writeInt(accntId);
		writeInt(symbolId);
		writeFloatD(lots);
		writeFloatD(pendingPrice);
		writeLong(pendingTime);
		writeFloatD(profitPrice);
		writeFloatD(lossPrice);
		writeShort((short)draftPoint);
		writeString(Memo);
	}

	public int getCommandCode() {
		return PidConst.P20031;
	}

	public int getAccntId() {
		return accntId;
	}

	public void setAccntId(int accntId) {
		this.accntId = accntId;
	}

	public int getAskId() {
		return askId;
	}

	public void setAskId(int askId) {
		this.askId = askId;
	}

	public int getDraftPoint() {
		return draftPoint;
	}

	public void setDraftPoint(int draftPoint) {
		this.draftPoint = draftPoint;
	}

	public double getLossPrice() {
		return lossPrice;
	}

	public void setLossPrice(double lossPrice) {
		this.lossPrice = lossPrice;
	}

	public double getLots() {
		return lots;
	}

	public void setLots(double lots) {
		this.lots = lots;
	}

	public String getMemo() {
		return Memo;
	}

	public void setMemo(String memo) {
		Memo = memo;
	}

	public double getPendingPrice() {
		return pendingPrice;
	}

	public void setPendingPrice(double pendingPrice) {
		this.pendingPrice = pendingPrice;
	}

	public long getPendingTime() {
		return pendingTime;
	}

	public void setPendingTime(long pendingTime) {
		this.pendingTime = pendingTime;
	}

	public double getProfitPrice() {
		return profitPrice;
	}

	public void setProfitPrice(double profitPrice) {
		this.profitPrice = profitPrice;
	}

	public int getSymbolId() {
		return symbolId;
	}

	public void setSymbolId(int symbolId) {
		this.symbolId = symbolId;
	}

	public MB20031(int askId, int accntId, int symbolId, double lots, double profitPrice, double lossPrice, int draftPoint, double pendingPrice, String memo, long pendingTime) {
		super();
		this.askId = askId;
		this.accntId = accntId;
		this.symbolId = symbolId;
		this.lots = lots;
		this.profitPrice = profitPrice;
		this.lossPrice = lossPrice;
		this.draftPoint = draftPoint;
		this.pendingPrice = pendingPrice;
		Memo = memo;
		this.pendingTime = pendingTime;
	}
}
