/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 挂单修改请求
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB20111 extends BaseWebTraderField{
	/**
	 * 请求ID
	 */
	int askId;
	/**
	 * 账户ID
	 */
	int accntId;
	/**
	 * 商品ID
	 */
	int symbolId;
	/**
	 * 对应单号
	 */
	int orderId;
	/**
	 * 挂单价
	 */
	double pendingPrice;
	/**
	 * 止赢价
	 */
	double profitPrice;
	/**
	 * 止损价
	 */
	double lossPrice;
	/**
	 * 移动止损的现价(比较价)
	 */
	double draftPrice;
	/**
	 * 移动止损的点数
	 */
	int draftPoint;
	/**
	 * 挂单时间
	 */
	long pendingTime;
	@Override
	protected void readCommandBody() {
		
	}

	@Override
	protected void writeCommandBody() {
		writeInt(askId);
		writeInt(accntId);
		writeInt(symbolId);
		writeInt(orderId);
		writeFloatD(pendingPrice);
		writeFloatD(profitPrice);
		writeFloatD(lossPrice);
		writeLong(pendingTime);
		writeShort((short)draftPoint);
	}

	public int getCommandCode() {
		return PidConst.P20111;
	}

	public int getAccntId() {
		return accntId;
	}

	public void setAccntId(int accntId) {
		this.accntId = accntId;
	}

	public int getAskId() {
		return askId;
	}

	public void setAskId(int askId) {
		this.askId = askId;
	}

	public int getDraftPoint() {
		return draftPoint;
	}

	public void setDraftPoint(int draftPoint) {
		this.draftPoint = draftPoint;
	}

	public double getLossPrice() {
		return lossPrice;
	}

	public void setLossPrice(double lossPrice) {
		this.lossPrice = lossPrice;
	}

	public int getOrderId() {
		return orderId;
	}

	public void setOrderId(int orderId) {
		this.orderId = orderId;
	}

	public double getPendingPrice() {
		return pendingPrice;
	}

	public void setPendingPrice(double pendingPrice) {
		this.pendingPrice = pendingPrice;
	}

	public long getPendingTime() {
		return pendingTime;
	}

	public void setPendingTime(long pendingTime) {
		this.pendingTime = pendingTime;
	}

	public double getProfitPrice() {
		return profitPrice;
	}

	public void setProfitPrice(double profitPrice) {
		this.profitPrice = profitPrice;
	}

	public int getSymbolId() {
		return symbolId;
	}

	public void setSymbolId(int symbolId) {
		this.symbolId = symbolId;
	}

	public MB20111() {
		super();
	}

	public MB20111(int askId, int accntId, int symbolId, int orderId, double pendingPrice, double profitPrice, double lossPrice, long pendingTime, int draftPoint) {
		super();
		this.askId = askId;
		this.accntId = accntId;
		this.symbolId = symbolId;
		this.orderId = orderId;
		this.pendingPrice = pendingPrice;
		this.profitPrice = profitPrice;
		this.lossPrice = lossPrice;
		this.pendingTime = pendingTime;
		this.draftPoint = draftPoint;
	}
}
