package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
/**
 * 平单请求 cngoldId
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB20181 extends BaseWebTraderField{
	/**
	 * 请求ID
	 */
	int askId;
	/**
	 * cngoldId
	 */
	int cngoldId;
	/**
	 * 商品ID
	 */
	int symbolId;
	/**
	 * 数量 
	 */
	double lots;
	/**
	 * 对应单号
	 */
	int orderId;
	/**
	 * 现价
	 */
	double nowPrice;
	/**
	 * 最大点差
	 */
	double maxWarp;
	
	public int getAskId() {
		return askId;
	}

	public void setAskId(int askId) {
		this.askId = askId;
	}

	public int getCngoldId() {
		return cngoldId;
	}

	public void setCngoldId(int cngoldId) {
		this.cngoldId = cngoldId;
	}

	public int getSymbolId() {
		return symbolId;
	}

	public void setSymbolId(int symbolId) {
		this.symbolId = symbolId;
	}

	public double getLots() {
		return lots;
	}

	public void setLots(double lots) {
		this.lots = lots;
	}

	public int getOrderId() {
		return orderId;
	}

	public void setOrderId(int orderId) {
		this.orderId = orderId;
	}

	public double getNowPrice() {
		return nowPrice;
	}

	public void setNowPrice(double nowPrice) {
		this.nowPrice = nowPrice;
	}

	public double getMaxWarp() {
		return maxWarp;
	}

	public void setMaxWarp(double maxWarp) {
		this.maxWarp = maxWarp;
	}

	@Override
	protected void readCommandBody() {
		
	}

	@Override
	protected void writeCommandBody() {
		writeInt(askId);
		writeInt(cngoldId);
		writeInt(symbolId);
		writeFloatD(lots);
		writeInt(orderId);
		writeFloatD(nowPrice);
		writeFloatD(maxWarp);
		writeInt(0);// 仓单 ID， 只做平单的时候没用， 以后如果做仓单的时候改动此处为传入即可
	}

	public int getCommandCode() {
		return PidConst.P20181;
	}

	public MB20181() {
		super();
	}

	public MB20181(int askId, int cngoldId, int symbolId, double lots, int orderId, double nowPrice, double maxWarp) {
		super();
		this.askId = askId;
		this.cngoldId = cngoldId;
		this.symbolId = symbolId;
		this.lots = lots;
		this.orderId = orderId;
		this.nowPrice = nowPrice;
		this.maxWarp = maxWarp;
	}
}
