/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 操做应答通知
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB20183 extends BaseWebTraderField{
	/**
	 * 返回码，0：交易成功(马上还会有一个包过来)； 2：取消请求成功；3：交易失败；5：重报价；
	 */
	int returnCode;
	/**
	 * 请求ID
	 */
	int askId;
	/**
	 * 账号ID
	 */
	int accntId;
	/**
	 * 新单Id，无新单则添0
	 */
	int toSendNewOrderId;
	/**
	 * 高的价格
	 */
	double askPrice;
	/**
	 * 低的价格
	 */
	double bidPrice;

	
	@Override
	protected void readCommandBody() {
		returnCode = readInt();
		askId = readInt();
		accntId = readInt();
		toSendNewOrderId = readInt();
		askPrice = readFloatD();
		bidPrice = readFloatD();
	}

	@Override
	protected void writeCommandBody() {
	}

	public int getCommandCode() {
		return PidConst.P20183;
	}

	public int getAccntId() {
		return accntId;
	}

	public void setAccntId(int accntId) {
		this.accntId = accntId;
	}

	public int getAskId() {
		return askId;
	}

	public void setAskId(int askId) {
		this.askId = askId;
	}

	public double getAskPrice() {
		return askPrice;
	}

	public void setAskPrice(double askPrice) {
		this.askPrice = askPrice;
	}

	public double getBidPrice() {
		return bidPrice;
	}

	public void setBidPrice(double bidPrice) {
		this.bidPrice = bidPrice;
	}

	public int getReturnCode() {
		return returnCode;
	}

	public void setReturnCode(int returnCode) {
		this.returnCode = returnCode;
	}

	public int getToSendNewOrderId() {
		return toSendNewOrderId;
	}

	public void setToSendNewOrderId(int toSendNewOrderId) {
		this.toSendNewOrderId = toSendNewOrderId;
	}
}
