package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

public class MB20201 extends BaseWebTraderField{
	/**
	 * 请求ID
	 */
	int askId;
	/**
	 * cngoldId
	 * */
	int CngoldId;
	/**
	 * 商品ID
	 */
	int symbolId;
	/**
	 * 对应单号
	 */
	int orderId;
	/**
	 * 止赢价
	 */
	double profitPrice;
	/**
	 * 止损价
	 */
	double lossPrice;
	/**
	 * 移动止损的现价(比较价)
	 */
	double draftPrice;
	/**
	 * 移动止损的点数
	 */
	int draftPoint;
	
	@Override
	protected void readCommandBody() {
		
	}

	@Override
	protected void writeCommandBody() {
		writeInt(CngoldId);
		writeInt(askId);
		writeInt(symbolId);
		writeInt(orderId);
		writeFloatD(profitPrice);
		writeFloatD(lossPrice);
		writeFloatD(draftPrice);
		writeShort((short)draftPoint);
	}

	public int getCommandCode() {
		return PidConst.P20201;
	}

	public int getAskId() {
		return askId;
	}

	public void setAskId(int askId) {
		this.askId = askId;
	}

	public int getDraftPoint() {
		return draftPoint;
	}

	public void setDraftPoint(int draftPoint) {
		this.draftPoint = draftPoint;
	}

	public double getDraftPrice() {
		return draftPrice;
	}

	public void setDraftPrice(double draftPrice) {
		this.draftPrice = draftPrice;
	}

	public double getLossPrice() {
		return lossPrice;
	}

	public void setLossPrice(double lossPrice) {
		this.lossPrice = lossPrice;
	}

	public int getOrderId() {
		return orderId;
	}

	public void setOrderId(int orderId) {
		this.orderId = orderId;
	}

	public double getProfitPrice() {
		return profitPrice;
	}

	public void setProfitPrice(double profitPrice) {
		this.profitPrice = profitPrice;
	}

	public int getSymbolId() {
		return symbolId;
	}

	public void setSymbolId(int symbolId) {
		this.symbolId = symbolId;
	}

	public int getCngoldId() {
		return CngoldId;
	}

	public void setCngoldId(int cngoldId) {
		CngoldId = cngoldId;
	}

	public MB20201() {
		super();
	}

	public MB20201(int askId, int cngoldId, int symbolId, int orderId, double profitPrice, double lossPrice, double draftPrice, int draftPoint) {
		super();
		this.askId = askId;
		this.CngoldId = cngoldId;
		this.symbolId = symbolId;
		this.orderId = orderId;
		this.profitPrice = profitPrice;
		this.lossPrice = lossPrice;
		this.draftPrice = draftPrice;
		this.draftPoint = draftPoint;
	}
}
