package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 金元券现价买单卖单请求
* @author liuming
* @date 2016年11月16日
 */
public class MB20311 extends BaseWebTraderField{
	/**
	 * 请求ID
	 */
	int askId;
	/**
	 * cngoldId
	 */
	int cngoldId;
	/**
	 * 商品ID
	 */
	int symbolId;
	/**
	 * 数量
	 */
	double lots;
	/**
	 * 止赢价 
	 */
	double profitPrice;
	/**
	 * 止损价
	 */
	double lossPrice;
	/**
	 * 移动止损的点数
	 */
	int draftPoint;
	/**
	 * 设置的最大偏差:滑点
	 */
	double maxWarp;
	/**
	 * 现价
	 */
	double nowPrice;
	/**
	 * 注释
	 */
	String Memo;
	/**
	 * 金元券，多个使用逗号隔开
	 */
	String vouchers;
	/**
	 * 建单类型 1:买单 2:卖单 3:挂单 -1:非建单
	 * */
	short OrderType;
	@Override
	protected void readCommandBody() {
		
	}

	@Override
	protected void writeCommandBody() {
		writeInt(askId);
		writeInt(cngoldId);
		writeInt(symbolId);
		writeFloatD(lots);
		writeFloatD(profitPrice);
		writeFloatD(lossPrice);
		writeShort((short)draftPoint);
		writeFloatD(maxWarp);
		writeFloatD(nowPrice);
		writeString(Memo);
		writeString(vouchers);
		writeShort(OrderType);
	}

	public int getCommandCode() {
		return PidConst.P20311;
	}

	public short getOrderType() {
		return OrderType;
	}

	public void setOrderType(short orderType) {
		OrderType = orderType;
	}

	public int getAskId() {
		return askId;
	}

	public void setAskId(int askId) {
		this.askId = askId;
	}

	public int getDraftPoint() {
		return draftPoint;
	}

	public void setDraftPoint(int draftPoint) {
		this.draftPoint = draftPoint;
	}

	public double getLossPrice() {
		return lossPrice;
	}

	public void setLossPrice(double lossPrice) {
		this.lossPrice = lossPrice;
	}

	public double getLots() {
		return lots;
	}

	public void setLots(double lots) {
		this.lots = lots;
	}

	public double getMaxWarp() {
		return maxWarp;
	}

	public void setMaxWarp(double maxWarp) {
		this.maxWarp = maxWarp;
	}

	public String getMemo() {
		return Memo;
	}

	public void setMemo(String memo) {
		Memo = memo;
	}

	public double getNowPrice() {
		return nowPrice;
	}

	public void setNowPrice(double nowPrice) {
		this.nowPrice = nowPrice;
	}

	public double getProfitPrice() {
		return profitPrice;
	}

	public void setProfitPrice(double profitPrice) {
		this.profitPrice = profitPrice;
	}

	public int getSymbolId() {
		return symbolId;
	}

	public void setSymbolId(int symbolId) {
		this.symbolId = symbolId;
	}

	public int getCngoldId() {
		return cngoldId;
	}

	public void setCngoldId(int cngoldId) {
		this.cngoldId = cngoldId;
	}

	public String getVouchers() {
		return vouchers;
	}

	public void setVouchers(String vouchers) {
		this.vouchers = vouchers;
	}

	public MB20311(int askId, int cngoldId, int symbolId, double lots, double profitPrice, double lossPrice,
			int draftPoint, double maxWarp, double nowPrice, String memo, String vouchers,short orderType) {
		super();
		this.askId = askId;
		this.cngoldId = cngoldId;
		this.symbolId = symbolId;
		this.lots = lots;
		this.profitPrice = profitPrice;
		this.lossPrice = lossPrice;
		this.draftPoint = draftPoint;
		this.maxWarp = maxWarp;
		this.nowPrice = nowPrice;
		Memo = memo;
		this.vouchers = vouchers;
		this.OrderType = orderType;
	}

	public MB20311() {
		super();
	}

}
