/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 金元券挂单请求
* @author liuming
* @date 2016年11月4日
 */
public class MB20331 extends BaseWebTraderField{
	/**
	 * 请求ID
	 */
	int askId;
	/**
	 * 账户Id
	 */
	int cngoldId;
	/**
	 * 商品ID
	 */
	int symbolId;
	/**
	 * 数量
	 */
	double lots;
	/**
	 * 挂单价格
	 */
	double profitPrice;
	/**
	 * 止损价
	 */
	double lossPrice;
	/**
	 * 移动止损的点数
	 */
	int draftPoint;
	/**
	 * 挂单价格
	 */
	double pendingPrice;
	/**
	 * 注释
	 */
	String Memo;
	/**
	 * 挂单时间
	 */
	long pendingTime;
	/**
	 * 金元券，多个使用逗号隔开
	 */
	String vouchers;
	/**
	 * 建单类型 1:买单 2:卖单 3:挂单 -1:非建单
	 * */
	short OrderType;
	
	@Override
	protected void readCommandBody() {
		
	}

	@Override
	protected void writeCommandBody() {
		writeInt(askId);
		writeInt(cngoldId);
		writeInt(symbolId);
		writeFloatD(lots);
		writeFloatD(pendingPrice);
		writeLong(pendingTime);
		writeFloatD(profitPrice);
		writeFloatD(lossPrice);
		writeShort((short)draftPoint);
		writeString(Memo);
		writeString(vouchers);
		writeShort((short) 3);
	}

	public int getCommandCode() {
		return PidConst.P20331;
	}

	public int getAskId() {
		return askId;
	}

	public void setAskId(int askId) {
		this.askId = askId;
	}

	public int getCngoldId() {
		return cngoldId;
	}

	public void setCngoldId(int cngoldId) {
		this.cngoldId = cngoldId;
	}

	public int getSymbolId() {
		return symbolId;
	}

	public void setSymbolId(int symbolId) {
		this.symbolId = symbolId;
	}

	public double getLots() {
		return lots;
	}

	public void setLots(double lots) {
		this.lots = lots;
	}

	public double getProfitPrice() {
		return profitPrice;
	}

	public void setProfitPrice(double profitPrice) {
		this.profitPrice = profitPrice;
	}

	public double getLossPrice() {
		return lossPrice;
	}

	public void setLossPrice(double lossPrice) {
		this.lossPrice = lossPrice;
	}

	public int getDraftPoint() {
		return draftPoint;
	}

	public void setDraftPoint(int draftPoint) {
		this.draftPoint = draftPoint;
	}

	public double getPendingPrice() {
		return pendingPrice;
	}

	public void setPendingPrice(double pendingPrice) {
		this.pendingPrice = pendingPrice;
	}

	public String getMemo() {
		return Memo;
	}

	public void setMemo(String memo) {
		Memo = memo;
	}

	public long getPendingTime() {
		return pendingTime;
	}

	public void setPendingTime(long pendingTime) {
		this.pendingTime = pendingTime;
	}

	public String getVouchers() {
		return vouchers;
	}

	public void setVouchers(String vouchers) {
		this.vouchers = vouchers;
	}

	public short getOrderType() {
		return OrderType;
	}

	public void setOrderType(short orderType) {
		OrderType = orderType;
	}

	public MB20331(int askId, int cngoldId, int symbolId, double lots, double profitPrice, double lossPrice,
			int draftPoint, double pendingPrice, String memo, long pendingTime, String vouchers) {
		super();
		this.askId = askId;
		this.cngoldId = cngoldId;
		this.symbolId = symbolId;
		this.lots = lots;
		this.profitPrice = profitPrice;
		this.lossPrice = lossPrice;
		this.draftPoint = draftPoint;
		this.pendingPrice = pendingPrice;
		Memo = memo;
		this.pendingTime = pendingTime;
		this.vouchers = vouchers;
	}

	public MB20331() {
		super();
	}

}
