/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.webtrade.sdk.PidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 出入金申请请求
 * @author JerryZ 
 * 2009-6-17 下午04:00:18
 *
 */
public class MB23031 extends BaseWebTraderField{
	/**
	 * 客户ID
	 */
	int custId;
	/**
	 * 请求ID
	 */
	int accntId;
	/**
	 * 银行ID，1:入金的话是系统银行，2：出金的话是客户银行，这点要注意 
	 */
	int bankId;
	/**
	 * 请求类型，1:入金，2：出金
	 */
	int reqType;
	/**
	 * 金额
	 */
	double balance;
	/**
	 * 请求原因
	 */
	String reqReason;
	
	@Override
	protected void readCommandBody() {
		
	}

	@Override
	protected void writeCommandBody() {
		writeInt(custId);
		writeInt(accntId);
		writeInt(bankId);
		writeInt(reqType);
		writeFloatD(balance);
		writeString(reqReason);
	}

	public int getCommandCode() {
		return PidConst.P23031;
	}

	public int getAccntId() {
		return accntId;
	}

	public void setAccntId(int accntId) {
		this.accntId = accntId;
	}

	public double getBalance() {
		return balance;
	}

	public void setBalance(double balance) {
		this.balance = balance;
	}

	public int getBankId() {
		return bankId;
	}

	public void setBankId(int bankId) {
		this.bankId = bankId;
	}

	public int getCustId() {
		return custId;
	}

	public void setCustId(int custId) {
		this.custId = custId;
	}

	public String getReqReason() {
		return reqReason;
	}

	public void setReqReason(String reqReason) {
		this.reqReason = reqReason;
	}

	public int getReqType() {
		return reqType;
	}

	public void setReqType(int reqType) {
		this.reqType = reqType;
	}

	public MB23031(int custId, int accntId, int bankId, int reqType, double balance, String reqReason) {
		super();
		this.custId = custId;
		this.accntId = accntId;
		this.bankId = bankId;
		this.reqType = reqType;
		this.balance = balance;
		this.reqReason = reqReason;
	}
}
