package com.lmsoft.cornu.webtrade.sdk.message.all;

import java.util.ArrayList;
import java.util.List;

import com.lmsoft.cornu.webtrade.sdk.TidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.bean.CustBalanceReq;

public class MB23202 extends BaseWebTraderField{

	private List<CustBalanceReq> list;
	private Long total;
	private int rtnCode;
	
	@Override
	public int getCommandCode() {
		return TidConst.T23202;
	}

	@Override
	protected void readCommandBody() {
		rtnCode = readInt();
		total = readLong(); 
		int size = readShort();
		for(int i=0;i<size;i++){
			CustBalanceReq cbr = new CustBalanceReq();
			cbr.setReqId(readInt());
			cbr.setCustId(readInt());
			cbr.setAccntId(readInt());
			cbr.setBankId(readInt());
			cbr.setStatus(readInt());
			cbr.setWithdrawal_type(readInt());
			cbr.setAssessor(readString());
			cbr.setAccept_dt(readString());
			cbr.setDeal_reason(readString());
			cbr.setSerial_num(readString());
			cbr.setReq_dt(readString());
			cbr.setBalance(readDouble());
			cbr.setBankNum(readString());
			if(list == null){
				list = new ArrayList<CustBalanceReq>();
			}
			list.add(cbr);
		}
	}

	@Override
	protected void writeCommandBody() {
		
	}

	public List<CustBalanceReq> getList() {
		return list;
	}

	public void setList(List<CustBalanceReq> list) {
		this.list = list;
	}

	public Long getTotal() {
		return total;
	}

	public void setTotal(Long total) {
		this.total = total;
	}

	public int getRtnCode() {
		return rtnCode;
	}

	public void setRtnCode(int rtnCode) {
		this.rtnCode = rtnCode;
	}

	public MB23202() {
		super();
	}

}
