package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.common.CommonTidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

import java.util.List;

/**
 * 发放金元券
 * {@link MB26002#msg msg}
 * created at 2016/10/26 18:27
 * @author vncnliu
 * @since default 1.0.0
 */

public class MB26001 extends BaseWebTraderField {
	/**
	 * 券类型id
	 */
	private int typeId;
	/**
	 * 券来源id
	 */
	private int voucher_source_id;
	/**
	 * 数量
	 */
	private short amount;
	/**
	 * 是否允许部分发放
	 */
	private boolean partSubmit;
	/**
	 * 发放用户cngold_id
	 */
	private List<Integer> cngoldIds;

	@Override
	protected void readCommandBody() {

	}

	@Override
	protected void writeCommandBody() {
		writeInt(typeId);
		writeShort(amount);
		writeInt(voucher_source_id);
		writeBoolean(partSubmit);
		writeListInt(cngoldIds);
	}

	public int getCommandCode() {
		return CommonTidConst.T26001;
	}

	public int getTypeId() {
		return typeId;
	}

	public void setTypeId(int typeId) {
		this.typeId = typeId;
	}

	public short getAmount() {
		return amount;
	}

	public void setAmount(short amount) {
		this.amount = amount;
	}

	public int getVoucher_source_id() {
		return voucher_source_id;
	}

	public void setVoucher_source_id(int voucher_source_id) {
		this.voucher_source_id = voucher_source_id;
	}

	public boolean isPartSubmit() {
		return partSubmit;
	}

	public void setPartSubmit(boolean partSubmit) {
		this.partSubmit = partSubmit;
	}

	public List<Integer> getCngoldIds() {
		return cngoldIds;
	}

	public void setCngoldIds(List<Integer> cngoldIds) {
		this.cngoldIds = cngoldIds;
	}
}
