package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.common.CommonTidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

import java.util.ArrayList;
import java.util.List;

/**
 * int类型通用批量响应包
 * created at 2016/10/26 18:27
 * @author vncnliu
 * @since default 1.0.0
 */

public class MB26002 extends BaseWebTraderField {
	/**
	 * 返回码，0成功，如果允许部分提交则返回必定是0
	 */
	private int code;
	/**
	 * 返回信息，如果批量操作返回第一个错误信息和key
	 */
	private String msg;
	/**
	 * 操作失败keys，不能以此判断请求成功还是失败
	 */
	List<Integer> failKeys;

	@Override
	protected void readCommandBody() {
		code = readInt();
		msg = readString();
		failKeys = new ArrayList<Integer>();
		int length = readInt();
		for (int i = 0; i < length; i++) {
			failKeys.add(readInt());
		}
	}

	@Override
	protected void writeCommandBody() {
	}

	@Override
	public int getCommandCode() {
		return CommonTidConst.R_INTLIST;
	}

	public int getCode() {
		return code;
	}

	public String getMsg() {
		return msg;
	}

	public List<Integer> getFailKeys() {
		return failKeys;
	}

}
