/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.common.CommonTidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.MutiPackage;
import com.lmsoft.cornu.webtrade.sdk.message.bean.VouchersBean;

import java.util.ArrayList;
import java.util.List;


/**
 * 查询金元券回包
 * created at 2016/10/26 18:27
 * @author vncnliu
 * @since default 1.0.0
 */

public class MB26012 extends BaseWebTraderField implements MutiPackage{

	/**
	 * 返回码
	 */
	private int code;
	/**
	 * 返回信息
	 */
	private String msg;
	private int voucherType;
	private int count;
	private List<VouchersBean> vouchersList=new ArrayList<VouchersBean>();

	@Override
	protected void readCommandBody() {
		code = readInt();
		voucherType = readInt();
		msg = readString();
		count = readInt();
		int length = readInt();
		for (int i = 0; i < length; i++) {
			VouchersBean vouchersBean = new VouchersBean();
			vouchersBean.setId(readInt());
			vouchersBean.setCngold_id(readInt());
			vouchersBean.setCreate_at(readLong());
			vouchersBean.setExpress_time(readLong());
			vouchersBean.setEffect_time(readLong());
			vouchersBean.setPrice(readInt());
			vouchersBean.setStatus(readShort());
			vouchersBean.setType_id(readInt());
			vouchersBean.setComment(readString());
			vouchersBean.setUsed_time(readLong());
			vouchersList.add(vouchersBean);
		}
	}

	@Override
	protected void writeCommandBody() {
	}

	public int getCommandCode() {
		return CommonTidConst.R26011;
	}

	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}

	public List<VouchersBean> getVouchersList() {
		return vouchersList;
	}

	public void setVouchersList(List<VouchersBean> vouchersList) {
		this.vouchersList = vouchersList;
	}

	public int getCode() {
		return code;
	}

	public void setCode(int code) {
		this.code = code;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	public int getVoucherType() {
		return voucherType;
	}

	public void setVoucherType(int voucherType) {
		this.voucherType = voucherType;
	}

	@Override
	public BaseWebTraderField packageing(List<BaseWebTraderField> packages) {
		MB26012 mb26012 = new MB26012();
		mb26012.setCode(code);
		mb26012.setCount(count);
		mb26012.setMsg(msg);
		mb26012.setVoucherType(voucherType);
		ArrayList<VouchersBean> newlist = new ArrayList<VouchersBean>(100*(packages.size()-1));
		for (BaseWebTraderField aPackage : packages) {
			MB26012 tmp = (MB26012) aPackage;
			newlist.addAll(tmp.getVouchersList());
		}
		mb26012.setVouchersList(newlist);
		return mb26012;
	}
}
