package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.common.CommonTidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;
import com.lmsoft.cornu.webtrade.sdk.message.bean.VoucherTypeBean;

import java.util.ArrayList;
import java.util.List;

/**
 * 查询金元券类别返回
 * created at 2016/10/26 18:27
 * @author vncnliu
 * @since default 1.0.0
 */

public class MB26022 extends BaseWebTraderField {

	/**
	 * 返回码
	 */
	private int code;
	/**
	 * 返回信息
	 */
	private String msg;
	private int count;
	private List<VoucherTypeBean> vouchersTypeBeanList;

	@Override
	protected void readCommandBody() {
		code = readInt();
		msg = readString();
		count = readInt();
		vouchersTypeBeanList=new ArrayList<VoucherTypeBean>();
		int length = readInt();
		for (int i = 0; i < length; i++) {
			VoucherTypeBean vouchersTypeBean = new VoucherTypeBean();
			vouchersTypeBean.setId(readInt());
			vouchersTypeBean.setBiz_type(readShort());
			vouchersTypeBean.setPrice(readInt());
			vouchersTypeBean.setExpire_type(readShort());
			vouchersTypeBean.setExpire_time(readLong());
			vouchersTypeBean.setEffect_type(readShort());
			vouchersTypeBean.setEffect_time(readLong());
			vouchersTypeBean.setComment(readString());
			vouchersTypeBean.setDelete_flag(readByte());
			vouchersTypeBean.setSymbol_id(readInt());
			vouchersTypeBeanList.add(vouchersTypeBean);
		}
	}

	@Override
	protected void writeCommandBody() {
	}

	public int getCommandCode() {
		return CommonTidConst.R26021;
	}

	public int getCode() {
		return code;
	}

	public void setCode(int code) {
		this.code = code;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}

	public List<VoucherTypeBean> getVouchersTypeBeanList() {
		return vouchersTypeBeanList;
	}

	public void setVouchersTypeBeanList(List<VoucherTypeBean> vouchersTypeBeanList) {
		this.vouchersTypeBeanList = vouchersTypeBeanList;
	}
}
