/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.common.CommonTidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 增加金元券类别
 * created at 2016/10/26 18:27
 * @author vncnliu
 * @since default 1.0.0
 */

public class MB26031 extends BaseWebTraderField {

	/**
	 * 业务类型<br>
	 * 具体类型见枚举{@link  com.lmsoft.cornu.common.EnumCode.VouchersBizType com.lmsoft.cornu.common.EnumCode.VouchersBizType}
	 */
	private short biz_type;
	/**
	 * 金额
	 */
	private int price;
	/**
	 * 过期类型<br>
	 * 具体参考枚举 {@link com.lmsoft.cornu.common.EnumCode.ExpireType com.lmsoft.cornu.common.EnumCode.ExpireType}
	 */
	private short expire_type;
	/**
	 * 有效时间,毫秒数
	 */
	private long express_time;
	/**
	 * 生效类型
	 * 具体参考枚举 {@link com.lmsoft.cornu.common.EnumCode.ExpireType com.lmsoft.cornu.common.EnumCode.EffectType}
	 * */
	private short effect_type;
	/**
	 * 生效时间,毫秒数
	 * */
	private long effect_time;
	/**
	 * 描述
	 */
	private String comment;
	/**
	 * 适用商品
	 * */
	private int symbol_id;
	@Override
	protected void readCommandBody() {
	}

	@Override
	protected void writeCommandBody() {
		writeShort(biz_type);
		writeInt(price);
		writeShort(expire_type);
		writeLong(express_time);
		writeShort(effect_type);
		writeLong(effect_time);
		writeString(comment);
		writeInt(symbol_id);
	}

	public int getCommandCode() {
		return CommonTidConst.T26031;
	}

	public short getBiz_type() {
		return biz_type;
	}

	public void setBiz_type(short biz_type) {
		this.biz_type = biz_type;
	}

	public int getPrice() {
		return price;
	}

	public void setPrice(int price) {
		this.price = price;
	}

	public long getExpress_time() {
		return express_time;
	}

	public void setExpress_time(long express_time) {
		this.express_time = express_time;
	}

	public String getComment() {
		return comment;
	}

	public void setComment(String comment) {
		this.comment = comment;
	}

	public short getExpire_type() {
		return expire_type;
	}

	public void setExpire_type(short expire_type) {
		this.expire_type = expire_type;
	}

	public short getEffect_type() {
		return effect_type;
	}

	public void setEffect_type(short effect_type) {
		this.effect_type = effect_type;
	}

	public long getEffect_time() {
		return effect_time;
	}

	public void setEffect_time(long effect_time) {
		this.effect_time = effect_time;
	}

	public int getSymbol_id() {
		return symbol_id;
	}

	public void setSymbol_id(int symbol_id) {
		this.symbol_id = symbol_id;
	}
	
}
