package com.lmsoft.cornu.webtrade.sdk.message.all;

import com.lmsoft.cornu.common.CommonTidConst;
import com.lmsoft.cornu.webtrade.sdk.message.BaseWebTraderField;

/**
 * 修改金元券类别，如果传递非法值不会做数据更新但依然会返回成功
 * created at 2016/10/26 18:27
 * @author vncnliu
 * @since default 1.0.0
 */

public class MB26091 extends BaseWebTraderField {

	/**
	 * voucher_type_id
	 */
	int id;
	/**
	 * 业务类型<br>
	 * 具体类型见枚举{@link  com.lmsoft.cornu.common.EnumCode.VouchersBizType com.lmsoft.cornu.common.EnumCode.VouchersBizType}
	 */
	private short biz_type;
	/**
	 * 金额
	 */
	private int price;
	/**
	 * 过期类型<br>
	 * 具体参考枚举 {@link com.lmsoft.cornu.common.EnumCode.ExpireType com.lmsoft.cornu.common.EnumCode.ExpireType}
	 */
	private short expire_type;
	/**
	 * 有效时间,毫秒数
	 */
	private long expire_time;
	/**
	 * 描述
	 */
	private String comment;

	@Override
	protected void readCommandBody() {
	}

	@Override
	protected void writeCommandBody() {
		writeInt(id);
		writeShort(biz_type);
		writeInt(price);
		writeShort(expire_type);
		writeLong(expire_time);
		writeString(comment);
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getCommandCode() {
		return CommonTidConst.T26091;
	}

	public short getBiz_type() {
		return biz_type;
	}

	public void setBiz_type(short biz_type) {
		this.biz_type = biz_type;
	}

	public int getPrice() {
		return price;
	}

	public void setPrice(int price) {
		this.price = price;
	}

	public long getExpire_time() {
		return expire_time;
	}

	public void setExpire_time(long expire_time) {
		this.expire_time = expire_time;
	}

	public String getComment() {
		return comment;
	}

	public void setComment(String comment) {
		this.comment = comment;
	}

	public short getExpire_type() {
		return expire_type;
	}

	public void setExpire_type(short expire_type) {
		this.expire_type = expire_type;
	}
}
