package com.lmsoft.cornu.webtrade.sdk.message.bean;

import java.util.Date;

/**
 * @author JerryZ
 * 
 *         交易单表
 */
public class TradeOrderPost {

	int id;
	
	/**
	 * cngoldId
	 * */
	private int cngoldId;
	
	/**
	 * 账号ID
	 */
	private int accnt_id;

	/**
	 * 商品ID
	 */
	private Integer smbl_id;
	/**
	 * 交易类型（8种，包括balance, credit）
	 */
	private int order_type;
	/**
	 * 单子所处状态(open,close)
	 */
	private int order_status;

	/**
	 * 交易数量
	 */
	private double lots;

	/**
	 * 开仓时间（建单时间，挂单时间）
	 */
	private Date open_time;

	/**
	 * 闭仓时间（平仓时间，挂单取消时间）
	 */
	private Date close_time;

	/**
	 * 开仓建
	 */
	private double open_prc;

	/**
	 * 平仓建
	 */
	private double close_prc;

	/**
	 * 平仓类型
	 */
	private int close_type;

	/**
	 * 止赢价
	 */
	private double profit_prc;

	/**
	 * 止损位
	 */
	private double loss_prc;
	/**
	 * 移动止损的现价
	 */
	private double draft_prc;
	/**
	 * 移动止损的点数
	 */
	private int draft_point;

	/**
	 * 盈亏
	 */
	private double profit_loss;

	/**
	 * 保证金水平
	 */
	private int tick_level;

	/**
	 * 手续费
	 */
	private double commission;

	/**
	 * 代理手续费(累加)
	 */
	private double agent_cms;

	/**
	 * 隔夜(累加)
	 */
	private double interest;

	/**
	 * 到期日
	 */
	private Date expire_day;

	/**
	 * 注释
	 */
	private String memo;

	/**
	 * 商品对保证金汇率
	 */
	private double first_con_rate;

	/**
	 * 保证金对帐户汇率
	 */
	private double second_con_rate;

	/**
	 * 持单时效(T+D专用)
	 */
	private Date time_effective;

	private String symbol_name;
	/**
	 * 最大偏差，用于建单与平单操作
	 */
	private int maxWarp;
	
	/**
	 * 剩余移动止损的点数
	 */
	private int left_draft_point;
	/**
	 * cngoldId，用于金元券下单
	 */
	private int cngold_id;
	/**
	 * 金元券id列表，多个使用逗号隔开
	 */
	private String vouchers;

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getAccnt_id() {
		return accnt_id;
	}

	public void setAccnt_id(int accntId) {
		accnt_id = accntId;
	}

	public Integer getSmbl_id() {
		return smbl_id;
	}

	public void setSmbl_id(Integer smblId) {
		smbl_id = smblId;
	}

	public int getOrder_type() {
		return order_type;
	}

	public void setOrder_type(int orderType) {
		order_type = orderType;
	}

	public int getOrder_status() {
		return order_status;
	}

	public void setOrder_status(int orderStatus) {
		order_status = orderStatus;
	}

	public double getLots() {
		return lots;
	}

	public void setLots(double lots) {
		this.lots = lots;
	}

	public Date getOpen_time() {
		return open_time;
	}

	public void setOpen_time(Date openTime) {
		open_time = openTime;
	}

	public Date getClose_time() {
		return close_time;
	}

	public void setClose_time(Date closeTime) {
		close_time = closeTime;
	}

	public double getOpen_prc() {
		return open_prc;
	}

	public void setOpen_prc(double openPrc) {
		open_prc = openPrc;
	}

	public double getClose_prc() {
		return close_prc;
	}

	public void setClose_prc(double closePrc) {
		close_prc = closePrc;
	}

	public int getClose_type() {
		return close_type;
	}

	public void setClose_type(int closeType) {
		close_type = closeType;
	}

	public double getProfit_prc() {
		return profit_prc;
	}

	public void setProfit_prc(double profitPrc) {
		profit_prc = profitPrc;
	}

	public double getLoss_prc() {
		return loss_prc;
	}

	public void setLoss_prc(double lossPrc) {
		loss_prc = lossPrc;
	}

	public double getDraft_prc() {
		return draft_prc;
	}

	public void setDraft_prc(double draftPrc) {
		draft_prc = draftPrc;
	}

	public int getDraft_point() {
		return draft_point;
	}

	public void setDraft_point(int draftPoint) {
		draft_point = draftPoint;
	}

	public double getProfit_loss() {
		return profit_loss;
	}

	public void setProfit_loss(double profitLoss) {
		profit_loss = profitLoss;
	}

	public int getTick_level() {
		return tick_level;
	}

	public void setTick_level(int tickLevel) {
		tick_level = tickLevel;
	}

	public double getCommission() {
		return commission;
	}

	public void setCommission(double commission) {
		this.commission = commission;
	}

	public double getAgent_cms() {
		return agent_cms;
	}

	public void setAgent_cms(double agentCms) {
		agent_cms = agentCms;
	}

	public double getInterest() {
		return interest;
	}

	public void setInterest(double interest) {
		this.interest = interest;
	}

	public Date getExpire_day() {
		return expire_day;
	}

	public void setExpire_day(Date expireDay) {
		expire_day = expireDay;
	}

	public String getMemo() {
		return memo;
	}

	public void setMemo(String memo) {
		this.memo = memo;
	}

	public double getFirst_con_rate() {
		return first_con_rate;
	}

	public void setFirst_con_rate(double firstConRate) {
		first_con_rate = firstConRate;
	}

	public double getSecond_con_rate() {
		return second_con_rate;
	}

	public void setSecond_con_rate(double secondConRate) {
		second_con_rate = secondConRate;
	}

	public Date getTime_effective() {
		return time_effective;
	}

	public void setTime_effective(Date timeEffective) {
		time_effective = timeEffective;
	}

	public String getSymbol_name() {
		return symbol_name;
	}

	public void setSymbol_name(String symbolName) {
		symbol_name = symbolName;
	}

	public int getMaxWarp() {
		return maxWarp;
	}

	public void setMaxWarp(int maxWarp) {
		this.maxWarp = maxWarp;
	}

	public int getLeft_draft_point() {
		return left_draft_point;
	}

	public void setLeft_draft_point(int leftDraftPoint) {
		left_draft_point = leftDraftPoint;
	}

	public int getCngold_id() {
		return cngold_id;
	}

	public void setCngold_id(int cngold_id) {
		this.cngold_id = cngold_id;
	}

	public String getVouchers() {
		return vouchers;
	}

	public void setVouchers(String vouchers) {
		this.vouchers = vouchers;
	}

	public int getCngoldId() {
		return cngoldId;
	}

	public void setCngoldId(int cngoldId) {
		this.cngoldId = cngoldId;
	}
	
}
