package com.lmsoft.cornu.webtrade.sdk.message.bean;

import java.util.Date;

public class TradeOrders {

	private int id; 
	
	/**
	 * 账号ID
	 */
	private int accnt_id;

	/**
	 * 商品ID
	 */
	private Integer smbl_id;
	/**
	 * 交易类型（8种，包括balance, credit）
	 */
	private int order_type;
	/**
	 * 单子所处状态(open,close)
	 */
	private int order_status;

	/**
	 * 交易数量
	 */
	private double lots;

	/**
	 * 开仓时间（建单时间，挂单时间）
	 */
	private Date open_time;

	/**
	 * 闭仓时间（平仓时间，挂单取消时间）
	 */
	private Date close_time;

	/**
	 * 开仓价
	 */
	private double open_prc;

	/**
	 * 平仓价
	 */
	private double close_prc;

	/**
	 * 平仓类型
	 */
	private int close_type;

	/**
	 * 止赢价
	 */
	private double profit_prc;

	/**
	 * 止损位
	 */
	private double loss_prc;
	/**
	 * 移动止损的现价
	 */
	private double draft_prc;
	/**
	 * 移动止损的点数
	 */
	private int draft_point;

	/**
	 * 盈亏
	 */
	private double profit_loss;

	/**
	 * 保证金水平
	 */
	private int tick_level;

	/**
	 * 手续费
	 */
	private double commission;

	/**
	 * 代理手续费(累加)
	 */
	private double agent_cms;

	/**
	 * 隔夜(累加)
	 */
	private double interest;

	/**
	 * 到期日
	 */
	private Date expire_day;

	/**
	 * 注释
	 */
	private String memo;

	/**
	 * 商品对保证金汇率
	 */
	private double first_con_rate;

	/**
	 * 保证金对帐户汇率
	 */
	private double second_con_rate;

	/**
	 * 持单时效(T+D专用)
	 */
	private Date time_effective;
	/**
	 * 初始建仓价
	 */
	private double init_open_prc;
	
	private boolean voucher_order;

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getAccnt_id() {
		return accnt_id;
	}

	public void setAccnt_id(int accnt_id) {
		this.accnt_id = accnt_id;
	}

	public Integer getSmbl_id() {
		return smbl_id;
	}

	public void setSmbl_id(Integer smbl_id) {
		this.smbl_id = smbl_id;
	}

	public int getOrder_type() {
		return order_type;
	}

	public void setOrder_type(int order_type) {
		this.order_type = order_type;
	}

	public int getOrder_status() {
		return order_status;
	}

	public void setOrder_status(int order_status) {
		this.order_status = order_status;
	}

	public double getLots() {
		return lots;
	}

	public void setLots(double lots) {
		this.lots = lots;
	}

	public Date getOpen_time() {
		return open_time;
	}

	public void setOpen_time(Date open_time) {
		this.open_time = open_time;
	}

	public Date getClose_time() {
		return close_time;
	}

	public void setClose_time(Date close_time) {
		this.close_time = close_time;
	}

	public double getOpen_prc() {
		return open_prc;
	}

	public void setOpen_prc(double open_prc) {
		this.open_prc = open_prc;
	}

	public double getClose_prc() {
		return close_prc;
	}

	public void setClose_prc(double close_prc) {
		this.close_prc = close_prc;
	}

	public int getClose_type() {
		return close_type;
	}

	public void setClose_type(int close_type) {
		this.close_type = close_type;
	}

	public double getProfit_prc() {
		return profit_prc;
	}

	public void setProfit_prc(double profit_prc) {
		this.profit_prc = profit_prc;
	}

	public double getLoss_prc() {
		return loss_prc;
	}

	public void setLoss_prc(double loss_prc) {
		this.loss_prc = loss_prc;
	}

	public double getDraft_prc() {
		return draft_prc;
	}

	public void setDraft_prc(double draft_prc) {
		this.draft_prc = draft_prc;
	}

	public int getDraft_point() {
		return draft_point;
	}

	public void setDraft_point(int draft_point) {
		this.draft_point = draft_point;
	}

	public double getProfit_loss() {
		return profit_loss;
	}

	public void setProfit_loss(double profit_loss) {
		this.profit_loss = profit_loss;
	}

	public int getTick_level() {
		return tick_level;
	}

	public void setTick_level(int tick_level) {
		this.tick_level = tick_level;
	}

	public double getCommission() {
		return commission;
	}

	public void setCommission(double commission) {
		this.commission = commission;
	}

	public double getAgent_cms() {
		return agent_cms;
	}

	public void setAgent_cms(double agent_cms) {
		this.agent_cms = agent_cms;
	}

	public double getInterest() {
		return interest;
	}

	public void setInterest(double interest) {
		this.interest = interest;
	}

	public Date getExpire_day() {
		return expire_day;
	}

	public void setExpire_day(Date expire_day) {
		this.expire_day = expire_day;
	}

	public String getMemo() {
		return memo;
	}

	public void setMemo(String memo) {
		this.memo = memo;
	}

	public double getFirst_con_rate() {
		return first_con_rate;
	}

	public void setFirst_con_rate(double first_con_rate) {
		this.first_con_rate = first_con_rate;
	}

	public double getSecond_con_rate() {
		return second_con_rate;
	}

	public void setSecond_con_rate(double second_con_rate) {
		this.second_con_rate = second_con_rate;
	}

	public Date getTime_effective() {
		return time_effective;
	}

	public void setTime_effective(Date time_effective) {
		this.time_effective = time_effective;
	}

	public double getInit_open_prc() {
		return init_open_prc;
	}

	public void setInit_open_prc(double initOpenPrc) {
		init_open_prc = initOpenPrc;
	}

	public boolean isVoucher_order() {
		return voucher_order;
	}

	public void setVoucher_order(boolean voucher_order) {
		this.voucher_order = voucher_order;
	}

	@Override
	public String toString() {
		return "TradeOrders [accnt_id=" + accnt_id + ", smbl_id=" + smbl_id + ", order_type=" + order_type
				+ ", order_status=" + order_status + ", lots=" + lots + ", open_time=" + open_time + ", close_time="
				+ close_time + ", open_prc=" + open_prc + ", close_prc=" + close_prc + ", close_type=" + close_type
				+ ", profit_prc=" + profit_prc + ", loss_prc=" + loss_prc + ", draft_prc=" + draft_prc
				+ ", draft_point=" + draft_point + ", profit_loss=" + profit_loss + ", tick_level=" + tick_level
				+ ", commission=" + commission + ", agent_cms=" + agent_cms + ", interest=" + interest + ", expire_day="
				+ expire_day + ", memo=" + memo + ", first_con_rate=" + first_con_rate + ", second_con_rate="
				+ second_con_rate + ", time_effective=" + time_effective + ", init_open_prc=" + init_open_prc
				+ ", voucher_order=" + voucher_order + "]";
	}

}
