package com.lmsoft.cornu.webtrade.sdk.message.bean;

import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * 代金券
 * created on 2016/10/25
 *
 * @author vncnliu
 * @since default 1.0.0
 */
public class VoucherTypeBean {

    private int id;

    /**
     * 业务类型<br>
     * 具体参考枚举 {@link com.lmsoft.cornu.common.EnumCode.VouchersBizType com.lmsoft.cornu.common.EnumCode.VouchersBizType}
     */
    private short biz_type;
    /**
     * 金额
     */
    private int price;
    /**
     * 过期类型<br>
     * 具体参考枚举 {@link com.lmsoft.cornu.common.EnumCode.ExpireType com.lmsoft.cornu.common.EnumCode.ExpireType}
     */
    private short expire_type;
    /**
     * 有效时间，根据{@link #expire_type expire_type}可表示创建后一定时间后过期，固定时间过期；毫秒数
     */
    private long expire_time;
    /**
     * 生效类型
     * 具体参考枚举 {@link com.lmsoft.cornu.common.EnumCode.ExpireType com.lmsoft.cornu.common.EnumCode.EffectType}
     * */
    private short effect_type;
    /**
     * 生效时间根据{@link #effect_time effect_time}表示券的生效时间；毫秒数
     * */
    private long effect_time;
    /**
     * 描述
     */
    private String comment;
    /**
     * 删除标识
     */
    private byte delete_flag;
    /**
     * 适用商品
     * */
    private int symbol_id;
    public short getBiz_type() {
        return biz_type;
    }

    public void setBiz_type(short biz_type) {
        this.biz_type = biz_type;
    }

    public int getPrice() {
        return price;
    }

    public void setPrice(int price) {
        this.price = price;
    }

    public short getExpire_type() {
        return expire_type;
    }

    public void setExpire_type(short expire_type) {
        this.expire_type = expire_type;
    }

    public long getExpire_time() {
        return expire_time;
    }

    public void setExpire_time(long expire_time) {
        this.expire_time = expire_time;
    }

    public short getEffect_type() {
		return effect_type;
	}

	public void setEffect_type(short effect_type) {
		this.effect_type = effect_type;
	}

	public long getEffect_time() {
		return effect_time;
	}

	public void setEffect_time(long effect_time) {
		this.effect_time = effect_time;
	}

	public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this);
    }

    public byte getDelete_flag() {
        return delete_flag;
    }

    public void setDelete_flag(byte delete_flag) {
        this.delete_flag = delete_flag;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

	public int getSymbol_id() {
		return symbol_id;
	}

	public void setSymbol_id(int symbol_id) {
		this.symbol_id = symbol_id;
	}
}
