/**
 * 
 */
package com.lmsoft.cornu.webtrade.sdk.serverclinet;

import java.util.concurrent.TimeUnit;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.lmsoft.cornu.common.online.OnlineConst;
import com.lmsoft.cornu.webtrade.sdk.ServerClient;
import com.lmsoft.cornu.webtrade.sdk.ServerClinetOnlineSession;
import com.lmsoft.cornu.webtrade.sdk.TidConst;
import com.lmsoft.cornu.webtrade.sdk.client2.BaseSkyfallCommonBizClient;
import com.lmsoft.cornu.webtrade.sdk.config.WebTraderConfig;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB10041;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB10042;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB10992;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13031;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13032;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13531;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13532;
import com.lmsoft.cornu.webtrade.sdk.message.all.MB13541;
import com.sangame.phoenix.cornu.CornuMessage;
/**
 * TradeSdk
 * @author JerryZ
 *
 */
public class DefaultServerClient extends BaseSkyfallCommonBizClient implements ServerClient{
	private static final Log log = LogFactory.getLog(DefaultServerClient.class);
	
	private ServerClinetOnlineSession serverOnlineSession;
	
	public DefaultServerClient(WebTraderConfig config) {
		super(config);
		
	}

	public synchronized MB10042 login(String loginName, String password, String ip) {
		dialogLock.lock();
		MB10042 mb10042 = null;
		try {
			MB10041 mb10041 = new MB10041(loginName, password, "AAAAAAAAAAAAA",
					OnlineConst.SOURCE_CLIENT_MANAGER, comminicationClient.getConfig().getServerVersion(), 
					"IP:"+ip);
			nowDialogSeq = 0;
			sendUnloginMsg(TidConst.T10261, mb10041, nowDialogSeq);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage ==null){
				
			}else
				mb10042 = (MB10042)nowCornuMessage;

		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb10042;
	}
	
	////////////////////////////NoticeMsgHandler//////////////////


	public void beClosed() {
		if (commHandler != null && serverOnlineSession!=null )
			commHandler.noticeSessionClose(serverOnlineSession.uid());
	}
	
	public void noticeMsg(CornuMessage message) {
		
		if(commHandler==null || serverOnlineSession ==null)
			return;
		super.noticeMsg(message);
		switch (message.getTid()) {
		case TidConst.T13543:
			MB13532 mb12123 = (MB13532)message.getFields()[0];
			commHandler.noticeTradeLog(serverOnlineSession.uid(), mb12123.getTradeLogList());
			break;
		default:
//			throw new IllegalStateException("通知事件没有处理: Tid: " + message.getTid());
			log.warn("通知事件没有处理: Tid: " + message.getTid());
			break;
		}
	}

	@Override
	public void setServerClientOnlineSession(ServerClinetOnlineSession serverClientOnlineSession) {
		this.serverOnlineSession = serverClientOnlineSession;
	}

	public ServerClinetOnlineSession getServerClientOnlineSession() {
		return serverOnlineSession;
	}
	
	@Override
	public MB13032 querySymbols(int symbolId) {
		dialogLock.lock();
		MB13032 mb13032 = null;
		try {
			MB13031 mb13031 = new MB13031(symbolId);
			nowDialogSeq = 0;
			sendUnloginMsg(TidConst.T13031, mb13031, nowDialogSeq);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage !=null)
				mb13032 = (MB13032)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb13032;
	}
	

	@Override
	public boolean isConnected() {
		return comminicationClient.haveConnected();
	}

	@Override
	public boolean queryNoticeSwitchOn() {
		dialogLock.lock();
		MB10992 mb13032 = null;
		try {
			MB13541 mb13031 = new MB13541(true);
			
			sendMsgAndSetNoSeq(TidConst.T13541, mb13031);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage !=null)
				mb13032 = (MB10992)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb13032 == null ? false : (mb13032.getRtnCode() == 0 ? true : false );
	}

	@Override
	public MB13532 queryTradeLogAfterId(long id) {
		dialogLock.lock();
		MB13532 mb13032 = null;
		try {
			MB13531 mb = new MB13531(id);
			
			sendMsgAndSetNoSeq(TidConst.T13531, mb);

			sending.await(TIME_OUT_TIME, TimeUnit.SECONDS);
			
			if(nowCornuMessage !=null)
				mb13032 = (MB13532)nowCornuMessage;
		} catch (Exception e) {
			log.error("error", e);
		} finally{
			nowCornuMessage = null;
			dialogLock.unlock();
		}
		
		return mb13032;
	}
}
